@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Starting the Name Service.
rem #
rem # ====================================================================

setlocal

rem # Check if the Name Service is already started.
if not exist %OpenCCM_CONFIG_DIR%\NameService.IOR goto :not_exist

echo Error: The Name Service is already started!
goto :eof

:not_exist

rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

:do_start
echo The Name Service will be started.

echo Launching the BES Name Service.

if exist %OpenCCM_CONFIG_DIR%\NameService.IOR.tmp del %OpenCCM_CONFIG_DIR%\NameService.IOR.tmp
start "NameService" cmd /c "nameserv.exe > %OpenCCM_CONFIG_DIR%\NameService.IOR.tmp "
echo pid? > %OpenCCM_CONFIG_DIR%\NameService.PID

:wait
set READY=
if not exist %OpenCCM_CONFIG_DIR%\NameService.IOR.tmp goto :wait
copy %OpenCCM_CONFIG_DIR%\NameService.IOR.tmp %OpenCCM_CONFIG_DIR%\NameService.IOR > nul
for /f %%i in (%OpenCCM_CONFIG_DIR%\NameService.IOR) do set READY=ok
if not defined READY goto :wait

echo The Name Service is started.
