@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Starting a Java Component Server.
rem #
rem # ====================================================================

setlocal

if "%1"=="-h" goto :help
if "%1"=="" goto :help
goto :no_help

:help
echo usage: jcs_start ^<server_name^>
goto :eof

:no_help

set JCS_PATH=%OpenCCM_CONFIG_DIR%\ComponentServers\%1

rem # Check if this Java Component Server is already started.
if not exist %JCS_PATH%.PID goto :not_exist

echo Error: The Component Server %1 is already started!
goto :eof

:not_exist
rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

rem # Obtain the IOR of the started Name Service.
call ns_ior > %OpenCCM_CONFIG_DIR%\ComponentServers\%1.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\ComponentServers\%1.tmp) do set NSIOR=%%i
del %OpenCCM_CONFIG_DIR%\ComponentServers\%1.tmp

rem # Check if a Name Service is started.
if defined NSIOR goto :ns_started

echo Error: The Name Service is not started!
goto :eof

:ns_started

rem # Obtain the IOR of the started Transaction Service.
call ots_ior > %OpenCCM_CONFIG_DIR%\ComponentServers\%1.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\ComponentServers\%1.tmp) do set OTSIOR=%%i
del %OpenCCM_CONFIG_DIR%\ComponentServers\%1.tmp

rem # Check if a Transaction Service is started.
if defined OTSIOR goto :ots_started

echo Error: The Transaction Service is not started!
goto :eof

:ots_started

echo The OpenCCM's Java Component Server %1 will be started.

rem # Check if the OpenCCM Java Component Server archive directory doesn't exist.
if exist %JCS_PATH%.archive_cache goto cache_exist

echo Creating the %JCS_PATH%.archive_cache directory.
mkdir %JCS_PATH%.archive_cache

:cache_exist

echo Launching a Transactional OpenCCM's Java Component Server.
set args="-DTRANSACTIONAL_PLUGIN=yes -Dorg.omg.PortableInterceptor.ORBInitializerClass.org.openorb.ots.Initializer -Dorg.omg.PortableInterceptor.ORBInitializerClass=org.openorb.ots.Initializer -DInstantDB.XA.VirtualXA=true -DInstantDB.JDBC.driver_loading=true -DInstantDB.JDBC.driver=jdbc.idbDriver -DInstantDB.JDBC.isolation_level=4 -DInstantDB.JDBC.url=jdbc:idb:XXX -DOpenCCM.ComponentServer.archive_cache=%JCS_PATH%.archive_cache org.objectweb.ccm.Deployment.ServerMain -ORBInitRef NameService=%NSIOR% -ORBInitRef TransactionService=%OTSIOR% %* %JCS_PATH%.IOR"
call jvm fork "JCS %1" %args% %JCS_PATH%.output %JCS_PATH%.PID

echo The OpenCCM's Java Component Server %1 is started.
