@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Philippe Merle.
rem # Contributor(s): Marc Navarro (mnavarro@wins.uva.nl).
rem #
rem # ====================================================================
rem #
rem #  Starting a demonstration.
rem #
rem #  $1: demonstration name.
rem #  $2: main Java class.
rem #
rem # ====================================================================

rem # Ant compilation if needed.
if not exist %1.idl build.bat
if not exist archives\%1.jar build.bat

rem # Install the OpenCCM Platform.
call ccm_install

rem # Start the Name Service.
call ns_start

rem # Obtain the IOR of the started Name Service.
call ns_ior > %OpenCCM_CONFIG_DIR%\%1.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\%1.tmp) do set NSIOR=%%i
del %OpenCCM_CONFIG_DIR%\%1.tmp

rem # Start Java Component Servers named ComponentServer1 and ComponentServer2.
call jcs_start ComponentServer1
call jcs_start ComponentServer2

echo Starting demonstration %1 ...
set CLASSPATH=archives\%1.jar;%CLASSPATH%
call jvm exec "" "%2 -ORBInitRef NameService=%NSIOR%"
echo Demonstration %1 is ready to be used ...
