/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Sylvain Leblanc.
Contributor(s): ______________________________________.

====================================================================*/

package DiningPhilosophers;

/**
 * This is the implementation of the OMG IDL3 
 * DiningPhilosophers::StatusInfo valuetype.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a> 
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a> 
 *
 * @version 2.0
 */

public class StatusInfoImpl
     extends StatusInfo
{
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /** The default constructor. */
    public
    StatusInfoImpl()
    {
        ticks_since_last_meal = 0;
        has_left_fork = false;
        has_right_fork = false;
        state = PhilosopherState.DEAD;
        name = "";
    }

    /**
     * The constructor.
     *
     * @param s The philosopher initial state.
     * @param n The philosopher name.
     * @param ticks The philosopher hungryness.
     * @param left_fork If the philosopher has the left fork.
     * @param right_fork If the philosopher has the right fork.
     */
    public
    StatusInfoImpl(PhilosopherState s,
                   String n,
                   int ticks,
                   boolean left_fork,
                   boolean right_fork)
    {
        state = s;
        name = n;
        ticks_since_last_meal = ticks;
        has_left_fork = left_fork;
        has_right_fork = right_fork;
    }
}
