# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2002 USTL - LIFL - GOAL
# Contact: openccm-team@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Philippe Merle, Sylvain Leblanc.
# Contributor(s): ______________________________________.
#
# ====================================================================
#
#  OMG IDLscript for the hello application deployment.
#
#  Note: To do before starting this script
#    ir_load hello.idl
#
# ====================================================================

println("Obtaining the Name Service...")

ns = CORBA.ORB.resolve_initial_references("NameService")

# ====================================================================

println("Obtaining the " + sys.arg[1] + " ServerHome instance...")

sh = ns.resolve([[sys.arg[1], ""]])

# ====================================================================

println("Creates a new Server component instance...")

server = sh.create()

# ====================================================================

println("Configuration completion...")

server.configuration_complete()

# ====================================================================

println("Retrieve the facet 'for_clients'...")

hello = server.provide_for_clients()

# ====================================================================

println("Call the 'say_hello' method...")

hello.say_hello()

# ====================================================================

println("Destroy the server component instance...")

server.remove()

println("Bye !!")

# ====================================================================
