/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.CORBA;

/**
 * This class encapsulates the CORBA::Repository singleton object.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.3
 */

public abstract class TheInterfaceRepository
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **  To store the CORBA::Repository singleton object.
     **/
    private static org.omg.CORBA.ComponentIR.Repository repository_ = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    private
    TheInterfaceRepository()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **  Obtain the CORBA::Repository singleton object.
     **
     **  @return The CORBA::Repository singleton object.
     **/
    public static org.omg.CORBA.ComponentIR.Repository
    getRepository()
    {
        if(repository_ == null)
	{
            repository_ = org.omg.CORBA.ComponentIR.RepositoryHelper.narrow(
                TheORB.resolve_initial_reference("InterfaceRepository"));
        }
        return repository_;
    }

    /**
     **  Set the CORBA::Repository singleton object.
     **
     **  @param repository The CORBA::Repository singleton object.
     **/
    public static void
    setRepository(org.omg.CORBA.ComponentIR.Repository repository)
    {
        repository_ = repository;
    }

    /**
     **  Lookup a definition by its repository Id.
     **
     **  @param id The repository Id.
     **
     **  @return The contained definition object.
     **/
    public static org.omg.CORBA.Contained
    lookup_id(String id)
    {
        return getRepository().lookup_id(id);
    }
}
