/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.CORBA;

/**
 * This class encapsulates the Name Service singleton object.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.3
 */

public abstract class TheNameService
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **  To store the CosNaming::NamingContext singleton object.
     **/
    private static NamingContext namingContext_ = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    private
    TheNameService()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **  Obtain the CosNaming::NamingContext singleton object.
     **
     **  @return The CosNaming::NamingContext singleton object.
     **/
    public static NamingContext
    getNamingContext()
    {
        if(namingContext_ == null)
	{
            namingContext_ = new NamingContext(
			       org.omg.CosNaming.NamingContextHelper.narrow(
                               TheORB.resolve_initial_reference("NameService")
			       ));
        }
        return namingContext_;
    }

    /**
     **  Set the CosNaming::NamingContext singleton object.
     **
     **  @param namingContext The NamingContext singleton object.
     **/
    public static void
    setNamingContext(NamingContext namingContext)
    {
        namingContext_ = namingContext;
    }
}
