/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.CORBA;

/**
 * This class encapsulates the Root POA singleton object.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.3
 */

public abstract class TheRootPOA
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **  To store the Root POA singleton object.
     **/
    private static org.omg.PortableServer.POA rootPOA_ = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    private
    TheRootPOA()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **  Obtain the Root POA singleton object.
     **
     **  @return The Root POA singleton object.
     **/
    public static org.omg.PortableServer.POA
    getRootPOA()
    {
        if(rootPOA_ == null)
	{
            rootPOA_ = org.omg.PortableServer.POAHelper.narrow(
                TheORB.resolve_initial_reference("RootPOA"));
        }
        return rootPOA_;
    }

    /**
     **  Set the Root POA singleton object.
     **
     **  @param poa The Root POA singleton object.
     **/
    public static void
    setRootPOA(org.omg.PortableServer.POA poa)
    {
        rootPOA_ = poa;
    }
}
