/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.CORBA;

/**
 * This class encapsulates a CORBA::UserException exception
 * allowing us to avoid to throw them in every operation sypnopsis.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.3
 */

public class UserExceptionWrapper
       extends java.lang.Error
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **  To store the CORBA::UserException object.
     **/
    private org.omg.CORBA.UserException userException_ = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    UserExceptionWrapper()
    {
        this(null, "");
    }

    /**
     **  The constructor.
     **
     **  @param userException The CORBA::UserException object.
     **/
    public
    UserExceptionWrapper(org.omg.CORBA.UserException userException)
    {
        this(userException, "");
    }

    /**
     **  The constructor.
     **
     **  @param userException The CORBA::UserException object.
     **  @param message The message describing the exception.
     **/
    public
    UserExceptionWrapper(org.omg.CORBA.UserException userException,
                         String message)
    {
        super(message);
        userException_ = userException;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **  Obtain the CORBA::UserException object.
     **
     **  @return The CORBA::UserException object.
     **/
    public org.omg.CORBA.UserException
    getUserException()
    {
        return userException_;
    }

    /**
     **  Set the CORBA::UserException object.
     **
     **  @param userException The CORBA::UserException object.
     **/
    public void
    setUserException(org.omg.CORBA.UserException userException)
    {
        userException_ = userException;
    }
}
