/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Components;

/**
 * This class implements the Components::ComponentPortDescription valuetype.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class ComponentPortDescriptionImpl
       extends org.omg.Components.ComponentPortDescription
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    ComponentPortDescriptionImpl()
    {
        this(null, null, null, null, null);
    }

    /**
     **  The constructor.
     **
     **/
    public
    ComponentPortDescriptionImpl(org.omg.Components.FacetDescription[] facets,
                                 org.omg.Components.ReceptacleDescription[] receptacles,
                                 org.omg.Components.ConsumerDescription[] consumers,
                                 org.omg.Components.EmitterDescription[] emitters,
                                 org.omg.Components.PublisherDescription[] publishers)
    {
        this.facets = facets;
        this.receptacles = receptacles;
        this.consumers = consumers;
        this.emitters = emitters;
        this.publishers = publishers;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    // 
    //  Public methods.
    // 
    // ==================================================================
}
