/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Components;

/**
 * ConsumesExecutor class.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class ConsumesInfo
       extends PortInfo
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private org.omg.Components.EventConsumerBase ref_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **
     **/
    public
    ConsumesInfo(String rep_id,
                 String name,
                 String type_id)
    {
        super(rep_id, name, type_id, PortInfo.pk_consumes);
        ref_ = null;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public org.omg.Components.EventConsumerBase
    consumer()
    {
        return ref_;
    }

    /**
     **
     **/
    public void
    consumer(org.omg.Components.EventConsumerBase ref)
    {
        ref_ = ref;
    }
}
