/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Components;

/**
 * This class is used to provide an unified view of executor objects.
 * In fact, facets and event sinks are encapsulated in this class
 * so that they can be managed as components or homes.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class PortInfo
{
    // ==================================================================
    //
    // Public constants.
    //
    // ==================================================================

    /**
     **
     **/
    public static final int pk_provides = 1;

    /**
     **
     **/
    public static final int pk_uses = 2;

    /**
     **
     **/
    public static final int pk_consumes = 3;

    /**
     **
     **/
    public static final int pk_emits = 4;

    /**
     **
     **/
    public static final int pk_publishes = 5;

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private java.lang.String repid_;

    /**
     **
     **/
    private java.lang.String type_id_;

    /**
     **
     **/
    private java.lang.String name_;

    /**
     **
     **/
    private int kind_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **
     **/
    public
    PortInfo(java.lang.String repid,
             java.lang.String name,
             java.lang.String type_id,
             int kind)
    {
        repid_ = repid;
        type_id_ = type_id;
        name_ = name;
        kind_ = kind;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public java.lang.String
    id()
    {
        return repid_;
    }

    /**
     **
     **/
    public java.lang.String
    type_id()
    {
        return type_id_;
    }

    /**
     **
     **/
    public java.lang.String
    name()
    {
        return name_;
    }

    /**
     **
     **/
    public int
    kind()
    {
        return kind_;
    }
}
