/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Components;

/**
 * PublishesExecutor class.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class PublishesInfo
       extends PortInfo
{
    // ==================================================================
    // 
    //  Internal state.
    // 
    // ==================================================================

    /**
     **
     **/
    private int limit_;

    /**
     **
     **/
    private org.objectweb.ccm.util.Table connections_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **
     **/
    public
    PublishesInfo(java.lang.String rep_id,
                  java.lang.String name,
                  java.lang.String type_id)
    {
        this(rep_id, name, type_id, java.lang.Integer.MAX_VALUE);
    }

    /**
     **
     **/
    public
    PublishesInfo(java.lang.String rep_id,
                  java.lang.String name,
                  java.lang.String type_id,
                  int limit)
    {
        super(rep_id, name, type_id, PortInfo.pk_publishes);
        limit_ = limit;
        connections_ = new org.objectweb.ccm.util.Table();
    }


    // ==================================================================
    // 
    //  Public Methods.
    // 
    // ==================================================================

    /**
     **
     **/
    public int
    limit()
    {
        return limit_;
    }

    /**
     **
     **/
    public org.objectweb.ccm.util.Table
    consumers()
    {
        return connections_;
    }
}
