/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): Romain Rouvoy_________________________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public interface ComponentExecutor
{
    /**
     **
     **/
    public ComponentServant
    _component_servant();

    /**
     **  This operation should also declare the ports of the component
     **/
    public void
    _component_servant(ComponentServant servant);

    /**
     **  To set the executor locator object for this skeleton.
     **/
    public void
    _executor_locator(org.omg.Components.ExecutorLocator locator);

    /**
     **  To get the executor locator for this skeleton.
     **/
    public org.omg.Components.ExecutorLocator
    _executor_locator();

    /**
     **  To set the component implementation for this skeleton.
     **/
    public void
    _delegate(org.omg.Components.EnterpriseComponent comp);

    /**
     **  To get the component implementation for this skeleton.
     **/
    public org.omg.Components.EnterpriseComponent
    _delegate();
}
