/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): Sylvain Leblanc, Romain Rouvoy________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * An component servant is conceptually an extension of the CORBA
 * servant but dedicated to components.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public interface ComponentServant
{
    /**
     **
     **/
    public ActivationContext
    activation_context();

    /**
     **
     **/
    public HomeServant
    the_home_servant();

    /**
     **
     **/
    public ComponentExecutor
    the_component_executor();

    /**
     **
     **/
    public org.omg.Components.CCMObject
    the_component_ref();

    /**
     **
     **/
    public org.omg.Components.PrimaryKeyBase
    the_registration_info();

    /**
     **
     **/
    public org.omg.CORBA.Object
    get_reference(java.lang.String uid);

    /**
     **
     **/
    public Interceptor
    get_native_interface(java.lang.String uid);

    /**
     **
     **/
    public void
    release_native_interface(Interceptor inter);

    /**
     ** Remove the associated component.
     **/
    public void
    remove()
        throws org.omg.Components.RemoveFailure;
}
