/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * This interface allows the OpenCCM ComponentServer to deal with
 * instantiated homes.
 *
 * TODO: This interface must be stabilized as soon as possible!
 *       Then it can change during next releases.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public interface HomeExecutorWithPK
       extends HomeExecutorBase
{
    /**
     **
     **/
    public org.omg.Components.EnterpriseComponent
    _get_enterprise_component(org.omg.Components.PrimaryKeyBase key)
    throws org.omg.Components.CCMException;

    /**
     ** 
     **/
    public org.omg.Components.EnterpriseComponent
    _find_enterprise_component(org.omg.Components.PrimaryKeyBase key)
    throws org.omg.Components.CCMException;

    /**
     ** 
     **/
    public void
    _remove_enterprise_component(org.omg.Components.PrimaryKeyBase key)
    throws org.omg.Components.CCMException;
}
