/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): Sylvain Leblanc, Romain Rouvoy________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * An home servant is conceptually an extension of the CORBA servant
 * but dedicated to homes.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public interface HomeServant
{
    /**
     **
     **/
    public SystemConfiguration
    the_home_configuration();

    /**
     **
     **/
    public SystemConfiguration
    the_component_configuration();

    /**
     **
     **/
    public SystemHomeFinder
    the_home_finder();

    /**
     **
     **/
    public HomeExecutorBase
    the_home_executor();

    /**
     **
     **/
    public PCA
    the_PCA();

    /**
     **
     **/
    public void
    the_PCA(PCA pca);

    /**
     **
     **/
    public org.omg.Components.CCMHome
    the_home_ref();

    /**
     **
     **/
    public void
    the_home_ref(org.omg.Components.CCMHome ref);

    /**
     **
     **/
    public org.omg.Components.Cookie
    the_registration_info();

    /**
     **
     **/
    public void
    the_registration_info(org.omg.Components.Cookie cookie);

    /**
     ** 
     **/
    public void 
    the_container_base(org.objectweb.ccm.Deployment.ContainerBase container);

    /**
     **
     **/
    public void 
    remove()
        throws org.omg.Components.RemoveFailure;
}
