/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * Implementation of the ::OpenCCM::Containers::PropertySet interface.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class PropertySetImpl
       extends PropertyImpl
       implements PropertySet
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private org.objectweb.ccm.util.Vector set_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    PropertySetImpl(java.lang.String id)
    {
        super(id);
        set_ = new org.objectweb.ccm.util.Vector();
    }

    // ==================================================================
    //
    // Public methods for the Property interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the PropertySet interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/PropertySet/add:1.0
    //
    /**
     **
     **/
    public PropertySet
    add(Property prop)
    {
        set_.add(prop);
        return this;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/PropertySet/get:1.0
    //
    /**
     **
     **/
    public Property
    get(java.lang.String id)
    throws UnknownProperty
    {
        java.util.Enumeration iter = set_.elements();
        Property prop = null;
        while (iter.hasMoreElements())
        {
            prop = (Property)iter.nextElement();
            if (prop.id().equals(id))
                return prop;
        }
        throw new UnknownProperty();
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/PropertySet/get_as_string:1.0
    //
    /**
     **
     **/
    public StringProperty
    get_as_string(java.lang.String id)
    throws UnknownProperty, BadPropertyKind
    {
        Property prop = get(id);
        try
        {
            return (StringProperty)prop;
     	}
        catch(java.lang.ClassCastException ex)
        {
            throw new BadPropertyKind();
        }
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/PropertySet/get_as_set:1.0
    //
    /**
     **
     **/
    public PropertySet
    get_as_set(String id)
    throws UnknownProperty, BadPropertyKind
    {
        Property prop = get(id);
        try
        {
            return (PropertySet)prop;
     	}
        catch(java.lang.ClassCastException ex)
        {
            throw new BadPropertyKind();
        }
    }
}
