/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment;

/**
 * This class implements the OMG IDL
 * ::Components::Deployment::ComponentServer interface.
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */
public class ComponentServerImpl
    extends org.omg.Components.Deployment.ComponentServerPOA
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected ComponentServerBase the_component_server_; 

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **  @param classLoader The class loader used to load home classes.
     **/
    public
    ComponentServerImpl(ServerImpl server)
    {
        the_component_server_ = new ComponentServerBase (server) ; 
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    public org.objectweb.ccm.Deployment.ComponentServerBase
	  _delegate()
    {
				return the_component_server_;
    }

    /**
     **
     **/
    public org.omg.Components.Deployment.ComponentServer
    asComponentServer()
    {
        return the_component_server_.asComponentServer();
    }

    // ==================================================================
    //
    // Methods for the ::Components::Deployment::ComponentServer interface.
    //
    // ==================================================================

    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/configuration:1.0
    //
    /**
     **  To obtain the component server configuration.
     **
     **/
    public org.omg.Components.ConfigValue[]
    configuration()
    {
        return the_component_server_.configuration () ;
    }

    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/configuration:1.0
    //
    /**
     **  To set the component server configuration.
     **  Note : configuration is a readonly attribute, but this allow us to
     **  set the configuration later in the instanciation process
     **  which can be useful as we don't have server activator yet.
     **
     **/
    public void
    configuration(org.omg.Components.ConfigValue[] config)
    {
        the_component_server_.configuration (config); 
    }

    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/get_server_activator:1.0
    //
    /**
     **  To obtain the server activator that has created this component server.
     **
     **/
    public org.omg.Components.Deployment.ServerActivator
    get_server_activator()
    {
        return the_component_server_.get_server_activator (); 
    }
    
    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/create_container:1.0
    //
    /**
     **  To create a container.
     **
     **/
    public org.omg.Components.Deployment.Container
    create_container(org.omg.Components.ConfigValue[] config)
				throws org.omg.Components.CreateFailure,
				       org.omg.Components.Deployment.InvalidConfiguration
    {
        return the_component_server_.create_container (config);
    }

    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/remove_container:1.0
    //
    /**
     **  To remove a container.
     **
     **/
    public void
    remove_container(org.omg.Components.Deployment.Container ref)
				throws org.omg.Components.RemoveFailure
    {
        the_component_server_.remove_container (ref); 
    }

    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/get_containers:1.0
    //
    /**
     **  To obtain all created containers references.
     **
     **/
    public org.omg.Components.Deployment.Container[]
    get_containers()
    {
        return the_component_server_.get_containers();
    }

    //
    //  IDL:omg.org/Components/Deployment/ComponentServer/remove:1.0
    //
    /**
     **  To remove this component server.
     **
     **/
    public void
    remove()
				throws org.omg.Components.RemoveFailure
    {
        the_component_server_.remove (); 
    }
} 








