/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Raphael Marvie, Philippe Merle.
Contributor(s): Mathieu Vadet______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment;

/**
 * Singleton class for access to the OpenCCM url class loader.
 *
 * @author <a href="mailto:Raphael.Marvie@lifl.fr">Raphael Marvie</a>
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class TheURLClassLoader
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **  The reference of the ComponentInstallation.
     **/
    static protected org.objectweb.ccm.util.URLClassLoader the_url_classloader_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    protected
    TheURLClassLoader()
    {
        the_url_classloader_ = null;
    }
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    static public org.objectweb.ccm.util.URLClassLoader
    getURLClassLoader()
    {
        if (the_url_classloader_==null)
            the_url_classloader_ = new org.objectweb.ccm.util.URLClassLoader();

        return the_url_classloader_;
    }

    /**
     **
     **/
    static void
    setURLClassLoader(org.objectweb.ccm.util.URLClassLoader cl)
    {
        the_url_classloader_ = cl;
    }
}
