/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment.listener; 


/**
 * 
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */
public class CCMHomeConfigurator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

		/**
		 ** Reference to the plugin chain
		 **
		 **/
    protected org.objectweb.ccm.Deployment.listener.CCMHomeListener listener_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

		/**
		 ** Default Constructor
		 **
		 **/
    public
	  CCMHomeConfigurator()
    {
				listener_ = null;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

		/**
		 ** Add a new listener to the end of the plugin chain
		 **
		 ** @param listener new listener to add
		 **/
    public void
	  add_listener(org.objectweb.ccm.Deployment.listener.CCMHomeListener listener)
    {	
				if (listener_ == null)
						listener_ = listener;
				else
						listener_.set_delegate(listener);	
    }

		/**
		 ** CCMHome CallBack 
		 ** <br> Configure the CCMHome 
		 **
		 ** @param home the CCMHome to configure
		 **/
    public void
	  configure_ccm_home(org.objectweb.ccm.Deployment.CCMHomeLocal home)
    {
				if (listener_ != null)
						listener_.configure_ccm_home(home);
				home.add_listener(new org.objectweb.ccm.Deployment.listener.CCMHomeListenerDefault(home));
    }

		/**
		 ** Reset the ComponentServer plugin chain
		 **
		 **/
		public void
		reset()
		{
				listener_ = null ;
		}
}







