/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment.listener; 

/**
 * Empty implementation of the ComponentServer interface
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */ 
public class ComponentServerListenerDefault
extends ComponentServerListenerBase
{
    /**
     * Constructor with parameter
     *
     * @param source the event source
     */ 
    public
    ComponentServerListenerDefault(org.objectweb.ccm.Deployment.ComponentServerLocal source)
    {
        super(source); 
    }

    /**
     * Provide a new instance of the class
     *
     * @return new instance
     */
    protected org.objectweb.ccm.Deployment.listener.ComponentServerListener
	_new()
    {
	return null;
    }
    

    /**
     * Provide the equivalent Container listener for the current listener
     *
     * @return the equivalent Container listener
     */
    public org.objectweb.ccm.Deployment.listener.ContainerListener 
	get_sub_listener()
    {
	return null;
    }

    /**
     * Event sent after the create function is called on ComponentServer object
     *
     * @param ref the object created
     */
    public void
    on_create (org.omg.Components.Deployment.Container cont_ref)
    {
        System.out.println ("ComponentServerListener::on_create\n"+cont_ref); 
    }
    
    /**
     * Event sent after the add function is called on ComponentServer object
     *
     * @param ref the object added
     */
    public void
    on_add (org.omg.Components.Deployment.Container cont_ref)
    {
        System.out.println ("ComponentServerListener::on_add\n"+cont_ref); 
    }
    
    /**
     * Event sent before the remove function is called on ComponentServer object
     *
     * @param ref the object removed
     */ 
    public void
    on_remove (org.omg.Components.Deployment.Container cont_ref)
    {
        System.out.println ("ComponentServerListener::on_remove\n"+cont_ref); 
    }
    
    /**
     * Event sent before the destruction of the related ComponentServer object 
     *
     */ 
    public void
    on_destroy ()
    {
        System.out.println ("ComponentServerListener::on_destroy\n"); 
    }
}
