/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment.listener; 


/**
 * Container Configurator Singleton
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */
public class TheContainerConfigurator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     * Reference to the configurator instance
     */
    protected static ContainerConfigurator configurator_ = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Set the instance of the configurator
     */
    public static void
	  set_instance(ContainerConfigurator configurator)
    {
				configurator_ = configurator ;
    }

    /**
     * Provide an instance of the configurator
     */
    public static ContainerConfigurator
	  get_instance()
    {
				if (configurator_ == null)
						configurator_ = new ContainerConfigurator();
				return configurator_;
    }
}
