/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment.listener.simple ; 


/**
 * Simple implementation for the
 * ::plugins::deployment::ComponentServerListener interface.
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */ 
public class ComponentServerListenerSimple
extends org.objectweb.ccm.Deployment.listener.ComponentServerListenerBase
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    /**
     * Constructor with parameter
     *
     * @param source the event source
     */ 
    public
    ComponentServerListenerSimple()
    {
        super(); 
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
		/**
     * Provide a new instance of the class
     *
     * @return new instance
     */
    protected org.objectweb.ccm.Deployment.listener.ComponentServerListener
  	_new()
    {
				return new ComponentServerListenerSimple();
    }
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for the ::Deployment::listener::ComponentServerListener interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Deployment/listener/ComponentServerListener/get_sub_listener:1.0
    //
    /**
     * Provide the equivalent Container listener for the current listener
     *
     * @return the equivalent Container listener
     */
    public org.objectweb.ccm.Deployment.listener.ContainerListener 
		get_sub_listener()
    {
				return new ContainerListenerSimple();
    }

    // ==================================================================
    //
    // Methods for the ::Deployment::listener::ComponentServerEvents interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Deployment/listener/ComponentServerEvents/on_create:1.0
    //
    /**
     * Event sent after the create function is called on ComponentServer object
     *
     * @param ref the object created
     */
    public void
    on_create (org.omg.Components.Deployment.Container cont_ref)
    {
        delegate_.on_create (cont_ref); 
        source_.add_container (cont_ref); 
    }
    
    //
    //  IDL:omg.org/Deployment/listener/ComponentServerEvents/on_add:1.0
    //
    /**
     * Event sent after the add function is called on ComponentServer object
     *
     * @param ref the object added
     */
    public void
    on_add (org.omg.Components.Deployment.Container cont_ref)
    {
        delegate_.on_add (cont_ref); 
    }
    
    //
    //  IDL:omg.org/Deployment/listener/ComponentServerEvents/on_remove:1.0
    //
    /**
     * Event sent before the remove function is called on ComponentServer object
     *
     * @param ref the object removed
     */ 
    public void
    on_remove (org.omg.Components.Deployment.Container cont_ref)
    {
        delegate_.on_remove (cont_ref); 
    }
    
    //
    //  IDL:omg.org/Deployment/listener/ComponentServerEvents/on_destroy:1.0
    //
    /**
     * Event sent before the destruction of the related ComponentServer object 
     *
     */ 
    public void
    on_destroy ()
    {
        delegate_.on_destroy (); 
    }
}
