/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment.listener.simple ; 

/**
 * Simple implementation for the
 * ::Deployment::listener::ContainerListener interface.
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */ 
public class ContainerListenerSimple
		extends org.objectweb.ccm.Deployment.listener.ContainerListenerBase
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    /**
     * Default Constructor
     *
     */ 
    public
    ContainerListenerSimple( )
    {
        super(); 
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    /**
     * Provide a new instance of the class
     *
     * @return new instance
     */
    protected org.objectweb.ccm.Deployment.listener.ContainerListener
  	_new()
    {
				return new ContainerListenerSimple();
    }
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for the ::Deployment::listener::ContainerListener interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Deployment/listener/ContainerListener/get_sub_listener:1.0
    //
    /**
     * Provide the equivalent CCMHome listener for the current listener
     *
     * @return the equivalent CCMHome listener
     */
    public org.objectweb.ccm.Deployment.listener.CCMHomeListener 
	  get_sub_listener()
    {
				return new CCMHomeListenerSimple();
    }

    // ==================================================================
    //
    // Methods for the ::Deployment::listener::ContainerEvents interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Deployment/listener/ContainerEvents/on_create:1.0
    //
    /**
     * Event sent after the create function is called on Container object
     *
     * @param ref the object created
     */ 
    public void
    on_create (org.omg.Components.CCMHome ref)
    {
        delegate_.on_create (ref);
        source_.add_home (ref); 
    }
    
    //
    //  IDL:omg.org/Deployment/listener/ContainerEvents/on_add:1.0
    //
    /**
     * Event sent after the add function is called on Container object
     *
     * @param ref the object added
     */ 
    public void
    on_add (org.omg.Components.CCMHome ref)
    {
        delegate_.on_add (ref); 
    }
    
    //
    //  IDL:omg.org/Deployment/listener/ContainerEvents/on_remove:1.0
    //
    /**
     * Event sent before the remove function is called on Container object
     *
     * @param ref the object removed
     */ 
    public void
    on_remove (org.omg.Components.CCMHome ref)
    {
        delegate_.on_remove (ref); 
    }
    
    //
    //  IDL:omg.org/Deployment/listener/ContainerEvents/on_destroy:1.0
    //
    /**
     * Event sent before the destruction of the related Container object 
     *
     */ 
    public void
    on_destroy ()
    {
        delegate_.on_destroy (); 
    }
}


