/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.IDL3;

/**
 * This class represents the CORBA::TypeCode object in the IDL3 layer.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class TypeKind
{
    // ==================================================================
    //
    // Public constant fields.
    //
    // ==================================================================

    /**
     **  Int constant for null CORBA::TypeCode kind.
     **/
    public static final int _tk_null = org.omg.CORBA.TCKind._tk_null;

    /**
     **  Int constant for void CORBA::TypeCode kind.
     **/
    public static final int _tk_void = org.omg.CORBA.TCKind._tk_void;

    /**
     **  Int constant for short CORBA::TypeCode kind.
     **/
    public static final int _tk_short = org.omg.CORBA.TCKind._tk_short;

    /**
     **  Int constant for long CORBA::TypeCode kind.
     **/
    public static final int _tk_long = org.omg.CORBA.TCKind._tk_long;

    /**
     **  Int constant for ushort CORBA::TypeCode kind.
     **/
    public static final int _tk_ushort = org.omg.CORBA.TCKind._tk_ushort;

    /**
     **  Int constant for ulong CORBA::TypeCode kind.
     **/
    public static final int _tk_ulong = org.omg.CORBA.TCKind._tk_ulong;

    /**
     **  Int constant for float CORBA::TypeCode kind.
     **/
    public static final int _tk_float = org.omg.CORBA.TCKind._tk_float;

    /**
     **  Int constant for double CORBA::TypeCode kind.
     **/
    public static final int _tk_double = org.omg.CORBA.TCKind._tk_double;

    /**
     **  Int constant for boolean CORBA::TypeCode kind.
     **/
    public static final int _tk_boolean = org.omg.CORBA.TCKind._tk_boolean;

    /**
     **  Int constant for char CORBA::TypeCode kind.
     **/
    public static final int _tk_char = org.omg.CORBA.TCKind._tk_char;

    /**
     **  Int constant for octet CORBA::TypeCode kind.
     **/
    public static final int _tk_octet = org.omg.CORBA.TCKind._tk_octet;

    /**
     **  Int constant for any CORBA::TypeCode kind.
     **/
    public static final int _tk_any = org.omg.CORBA.TCKind._tk_any;

    /**
     **  Int constant for TypeCode CORBA::TypeCode kind.
     **/
    public static final int _tk_TypeCode = org.omg.CORBA.TCKind._tk_TypeCode;

    /**
     **  Int constant for Principal CORBA::TypeCode kind.
     **/
    public static final int _tk_Principal = org.omg.CORBA.TCKind._tk_Principal;

    /**
     **  Int constant for object ref CORBA::TypeCode kind.
     **/
    public static final int _tk_objref = org.omg.CORBA.TCKind._tk_objref;

    /**
     **  Int constant for struct CORBA::TypeCode kind.
     **/
    public static final int _tk_struct = org.omg.CORBA.TCKind._tk_struct;

    /**
     **  Int constant for union CORBA::TypeCode kind.
     **/
    public static final int _tk_union = org.omg.CORBA.TCKind._tk_union;

    /**
     **  Int constant for enum CORBA::TypeCode kind.
     **/
    public static final int _tk_enum = org.omg.CORBA.TCKind._tk_enum;

    /**
     **  Int constant for string CORBA::TypeCode kind.
     **/
    public static final int _tk_string = org.omg.CORBA.TCKind._tk_string;

    /**
     **  Int constant for sequence CORBA::TypeCode kind.
     **/
    public static final int _tk_sequence = org.omg.CORBA.TCKind._tk_sequence;

    /**
     **  Int constant for array CORBA::TypeCode kind.
     **/
    public static final int _tk_array = org.omg.CORBA.TCKind._tk_array;

    /**
     **  Int constant for alias CORBA::TypeCode kind.
     **/
    public static final int _tk_alias = org.omg.CORBA.TCKind._tk_alias;

    /**
     **  Int constant for exception CORBA::TypeCode kind.
     **/
    public static final int _tk_exception = org.omg.CORBA.TCKind._tk_except;

    /**
     **  Int constant for long long CORBA::TypeCode kind.
     **/
    public static final int _tk_longlong = org.omg.CORBA.TCKind._tk_longlong;

    /**
     **  Int constant for ulong long CORBA::TypeCode kind.
     **/
    public static final int _tk_ulonglong = org.omg.CORBA.TCKind._tk_ulonglong;

    /**
     **  Int constant for long double CORBA::TypeCode kind.
     **/
    public static final int _tk_longdouble = org.omg.CORBA.TCKind._tk_longdouble;

    /**
     **  Int constant for wchar CORBA::TypeCode kind.
     **/
    public static final int _tk_wchar = org.omg.CORBA.TCKind._tk_wchar;

    /**
     **  Int constant for wstring CORBA::TypeCode kind.
     **/
    public static final int _tk_wstring = org.omg.CORBA.TCKind._tk_wstring;

    /**
     **  Int constant for fixed CORBA::TypeCode kind.
     **/
    public static final int _tk_fixed = org.omg.CORBA.TCKind._tk_fixed;

    /**
     **  Int constant for value box CORBA::TypeCode kind.
     **/
    public static final int _tk_value_box = org.omg.CORBA.TCKind._tk_value_box;

    /**
     **  Int constant for value CORBA::TypeCode kind.
     **/
    public static final int _tk_value = org.omg.CORBA.TCKind._tk_value;

    /**
     **  Int constant for native CORBA::TypeCode kind.
     **/
    public static final int _tk_native = org.omg.CORBA.TCKind._tk_native;

    /**
     **  Int constant for abstract interface CORBA::TypeCode kind.
     **/
    public static final int _tk_abstract_interface = org.omg.CORBA.TCKind._tk_abstract_interface;

    /**
     **  Int constant for interface CORBA::TypeCode kind.
     **/
    public static final int _tk_interface = 99;
    // not defined ! org.omg.CORBA.TCKind._tk_interface;

    /**
     **  Int constant for local interface CORBA::TypeCode kind.
     **/
    public static final int _tk_local_interface = 100;
    // not defined ! org.omg.CORBA.TCKind._tk_local_interface;

    /**
     **  Int constant for component CORBA::TypeCode kind.
     **/
    public static final int _tk_component = 101;
    // not defined ! org.omg.CORBA.TCKind._tk_component;

    /**
     **  Int constant for home CORBA::TypeCode kind.
     **/
    public static final int _tk_home = 102;
    // not defined ! org.omg.CORBA.TCKind._tk_home;

    /**
     **  Int constant for event CORBA::TypeCode kind.
     **/
    public static final int _tk_event = 103;
    // not defined ! org.omg.CORBA.TCKind._tk_event;

    // ==================================================================
    //
    // Public static methods.
    //
    // ==================================================================

    /**
     **
     **/
    public static String
    toString(int kind)
    {
        switch(kind)
        {
        case _tk_null :
            return "null";
        case _tk_void :
            return "void";
        case _tk_short :
            return "short";
        case _tk_long :
            return "long";
        case _tk_ushort :
            return "ushort";
        case _tk_ulong :
            return "ulong";
        case _tk_float :
            return "float";
        case _tk_double :
            return "double";
        case _tk_boolean :
            return "boolean";
        case _tk_char :
            return "char";
        case _tk_octet :
            return "octet";
        case _tk_any :
            return "any";
        case _tk_TypeCode :
            return "typecode";
        case _tk_Principal :
            return "principal";
        case _tk_objref :
            return "objref";
        case _tk_struct :
            return "struct";
        case _tk_union :
            return "union";
        case _tk_enum :
            return "enum";
        case _tk_string :
            return "string";
        case _tk_sequence :
            return "sequence";
        case _tk_array :
            return "array";
        case _tk_alias :
            return "alias";
        case _tk_exception :
            return "exception";
        case _tk_longlong :
            return "longlong";
        case _tk_ulonglong :
            return "ulonglong";
        case _tk_longdouble :
            return "longdouble";
        case _tk_wchar :
            return "wchar";
        case _tk_wstring :
            return "wstring";
        case _tk_fixed :
            return "fixed";
        case _tk_value_box :
            return "value_box";
        case _tk_value :
            return "value";
        case _tk_native :
            return "native";
        case _tk_abstract_interface :
            return "abstract_interface";
        case _tk_local_interface :
            return "local_interface";
        case _tk_interface :
            return "interface";
        case _tk_component :
            return "component";
        case _tk_home :
            return "home";
        case _tk_event :
            return "event";
        default :
            return "null";
        }
    }
}
