/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

import org.omg.CORBA.*;

/**
 * Abstract base class for anonymous CORBA::IDLType objects.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

abstract public class AnonymousIDLType
                extends IRObject_impl
                implements IDLTypeOperations
{
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    public
    AnonymousIDLType(IFR ifr)
    {
        // calls the IRObject_impl contructor.
        super(ifr);
    }

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // For IRObject_impl class.
    //
    // ==================================================================

    /**
        Decrement the reference counter.
     **/
    public void
    remove_ref()
    {
        super.remove_ref();

        // if there is no more dependency then
        // destroy this anonymous CORBA::IDLType.
        if (getRefCounter() == 0)
            destroy();
    }

    // ==================================================================
    //
    // For CORBA::IRObject interface.
    //
    // ==================================================================

    // same as in the IRObject_impl class.

    // ==================================================================
    //
    // For CORBA::IDLType interface.
    //
    // ==================================================================

    // implemented into subclasses.
}
