/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

/**
 * Implementation of the CORBA::ValueDef reference.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class EventDef_ref
       extends IDLType_ref
{
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public
    EventDef_ref()
    {
        super();
    }

    public
    EventDef_ref(EventDef_impl value)
    {
        super(value);
    }

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Static public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
        Obtain its implementation.
     **/
    public EventDef_impl
    getImpl()
    {
        return (EventDef_impl)(super.getBaseImpl());
    }

    /**
        Obtain its ValueDef reference.
     **/
    public org.omg.CORBA.ComponentIR.EventDef
    asEventDef()
    {
        if(impl_ == null) return null;
        return getImpl().asEventDef();
    }

    /**
        Obtain its repositoryID.
     **/
    public String
    getId()
    {
        if (impl_ == null) return "";
        return getImpl().id();
    }
}
