/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

import org.omg.CORBA.ExceptionDef;

/**
 * Implementation of the CORBA::ExceptionDef reference.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class ExceptionDef_ref
       extends IRObject_ref
{
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public
    ExceptionDef_ref()
    {
        super();
    }

    public
    ExceptionDef_ref(ExceptionDef_impl object)
    {
        super(object);
    }

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Static public methods.
    //
    // ==================================================================

    /**
        Cut the dependency to a set of exceptions.
     **/
    static public void
    cutDependencies(ExceptionDef_ref[] exceptions)
    {
        if (exceptions != null)
        {
            for(int i=0; i<exceptions.length; i++)
                exceptions[i].cutDependency();
        }
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
        Obtain its reference.
     **/
    public ExceptionDef_impl
    getImpl()
    {
        return (ExceptionDef_impl)(super.getBaseImpl());
    }

    /**
        Obtain its CORBA::ExceptionDef reference.
     **/
    public ExceptionDef
    asExceptionDef()
    {
        return getImpl().asExceptionDef();
    }
}
