/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

import org.omg.CORBA.*;

/**
 * Base class for contained objects in container with inheritance.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

abstract public class FeatureContained
                extends Contained_impl
{
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    public
    FeatureContained(IFR ifr,
                     Container_impl container)
    {
        // call the Contained_impl contructor.
        super(ifr, container);
    }

    // ==================================================================
    //
    // For CORBA::Contained interface.
    //
    // ==================================================================

    /**
        IDL:omg.org/CORBA/Contained/name:1.0
     **/
    public void
    name(String val)
    {
        // if not changed then return immediatelly. 
        if (val.equals(name_)) return;

        // check if the name already exists in the container.
	// Do not exclude inherited names.
        container_.checkName(val, false, false);

        // call the Contained::name() operation.
        super.name(val);
    }
}
