/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

import org.omg.CORBA.TypeCode;
import org.omg.CORBA.IDLType;

/**
 * Implementation of the CORBA::IDLType reference.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IDLType_ref
       extends IRObject_ref
{
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public
    IDLType_ref()
    {
        super();
    }

    public
    IDLType_ref(IRObject_impl object)
    {
        super(object);
    }

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
        Obtain its CORBA::TypeCode.
        TODO : remove -> replaced by next one for recursive typecodes management
     **/
/*
    public TypeCode
    getTypeCode()
    {
        if (impl_ == null) return null;
        return impl_.type();
    }
 */

    /**
        Obtain its CORBA::TypeCode.
     **/
    public TypeCode
    recursiveType(org.objectweb.ccm.util.Vector idSeq)
    {
        if (impl_ == null) return null;
        return impl_.recursiveType(idSeq);
    }

    /**
        Obtain its CORBA::TypeCode.
     **/
    public TypeCode
    recursiveType()
    {
        if (impl_ == null) return null;
        return impl_.type();
    }

    /**
        Obtain its CORBA::IDLType reference.
     **/
    public IDLType
    asIDLType()
    {
        if (impl_ == null) return null;
        return impl_.asIDLType();
    }
}
