/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

/**
 * Minor values for standard system exceptions.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public interface SystemExceptionMinorValues
{
    /**
     ** Standard OMG base.
     **/
    final public int OMGVMCID = 0x4f4d0000;

    /**
     ** LIFL base.
     ** Warning: This value can be in conflict with an existing ORB provider!
     **/
    final public int LIFLVMCID = 0x54320000;

    /**
     **  For CORBA::BAD_PARAM exceptions.
     **/

    final public int RidAlreadyDefined = OMGVMCID | 2;
    final public int NameAlreadyUsed = OMGVMCID | 3;
    final public int InvalidContainer = OMGVMCID | 4;
    final public int NameClashInInheritedContext = OMGVMCID | 5;
    final public int InvalidAbstractInterfaceInheritance = OMGVMCID | 11;

    final public int InvalidLocalInterfaceInheritance = OMGVMCID | 12;

    final public int NotLocalObject = LIFLVMCID | 1;
    final public int NameAlreadyUsedByImmediateScope = LIFLVMCID | 2;
    final public int NeedOnlyInParams = LIFLVMCID | 3;
    final public int NoExceptionsForOnewayOperation = LIFLVMCID | 4;
    final public int InvalidValueBoxType = LIFLVMCID | 5;

    final public int DuplicateDeclarator = LIFLVMCID | 100;

    /**
        For CORBA::BAD_INV_ORDER exceptions.
     **/
    final public int Dependency = OMGVMCID | 1;
    final public int CanNotBeDestroyed = OMGVMCID | 2;
    final public int IllegalRecursion = LIFLVMCID | 3;

    /**
     **  For CORBA::INTF_REPOS exceptions.
     **/
    final public int AmbiguousLookup = LIFLVMCID | 1;

};
