/*================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.plugins.transaction.deployment ;

import org.objectweb.ccm.plugins.transaction.deployment.TransactionManagerLocal ;

/**
 * Singleton to access to the transaction manager
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */
public class TheTransactionManager
{
		// ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
		/**
		 * Instance for the singleton
		 *
		 */
    protected static TransactionManagerImpl manager_ = null;

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
		/**
		 * Provide the reference of the active transaction manager
		 *
		 * @return the instance of the current transaction manager
		 */
    public static TransactionManagerLocal
    get_instance ()
    {
        if (manager_ == null)
        {
            manager_ = new TransactionManagerImpl ();
        }
        return manager_;
    }
}
