/*================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.plugins.transaction.deployment ;

/**
 * Manage the transactions started but not committed
 * 
 * @author  <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * 
 * @version  0.3
 */
public interface TransactionManagerLocal
{
	/**
	 * Provide the current resource manager
	 * 
	 * @return  the current resource manager
	 */
	public ResourceManagerLocal 
	getCurrent();

	/**
	 * Remove the resource manager from the transaction manager
	 * 
	 * @param  resource manager to remove
	 * 
	 * @exception  Components::RemoveFailure
	 */
	public void 
  remove_manager(ResourceManagerLocal ref)
		throws org.omg.Components.RemoveFailure;
}
