/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.plugins.transaction.deployment.util; 


/**
 * Definition of available treatment on a resource
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */
public class ResourcePrepare
implements ResourceTreatment
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
		/**
		 ** final vote
		 **/
		protected org.omg.CosTransactions.Vote the_vote_;


    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
		/**
		 * Default Constructor
		 */
		public
		ResourcePrepare()
		{
				the_vote_ = org.omg.CosTransactions.Vote.VoteCommit;
		}


		// ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
		/**
		 * Provide the final vote for all the resources of the vector
		 *
		 * @return the final vote (Commit or Rollback)
		 */
		public org.omg.CosTransactions.Vote
		final_vote()
		{
				return the_vote_;
		}


    // ==================================================================
    //
    // Methods for the ResourceTreatment interface.
    //
    // ==================================================================
		//
		// JAVA:ResourceTreatment/apply
		//
    /**
     * Definition of the treatment to apply on the specified resource
     *
     * @param resource resource concerned by the treatment
     *
     */ 
    public void
    apply (org.omg.CosTransactions.Resource resource)
    throws Exception
    {
				try
				{
						org.omg.CosTransactions.Vote _vote = resource.prepare();
						if (_vote == org.omg.CosTransactions.Vote.VoteRollback)
								the_vote_ = org.omg.CosTransactions.Vote.VoteRollback ;
				} catch(Exception ex) {
						the_vote_ = org.omg.CosTransactions.Vote.VoteRollback ;
				}
		}
}







