/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.plugins.transaction.deployment.util; 


/**
 * implementation of a vector specialized in managing resources
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.3
 */
public class ResourceVector
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
		/**
		 ** List of resource
		 **/
    protected org.objectweb.ccm.util.Vector list_; 
    
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
		/**
		 ** Default Constructor
		 **/
    public ResourceVector ()
    {
        list_ = new org.objectweb.ccm.util.Vector() ; 
    }

		// ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
		/**
		 ** Add a new resource to the vector
		 **
		 ** @param resource resource to add
		 **/
    public void
    addElement (org.omg.CosTransactions.Resource resource)
    {
        list_.addElement (resource); 

    }

		/**
		 ** Remove a resource from the vector
		 **
		 ** @param resource resource to remove
		 **/
    public void
    removeElement (org.omg.CosTransactions.Resource resource)
    {
        list_.removeElement (resource);  
    }

		/**
		 ** Apply a specific treatment to the vector
		 **
		 ** @param action treatment to apply on every element of the vector
		 **/
    public void
    apply (ResourceTreatment action)
        throws Exception
    {
				// The list is cloned in order to avoid concurrent access to the list
				org.omg.CosTransactions.Resource[] _clone = (org.omg.CosTransactions.Resource[]) list_.toArray(new org.omg.CosTransactions.Resource[0]);
				
        for (int i=0 ; i<_clone.length ; i++)
        {
            action.apply (_clone[i]) ;    
        }
    } 
}




