/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.scripts;

/**
 * A options manager implementation for OMG IDL compiler.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IDL2OptionsManager
       extends IDL3OptionsManager
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **  @param indentation The indentation.
     **  @param commandName The command name.
     **/
    public
    IDL2OptionsManager(String indentation,
                       String commandName)
    {
        super(indentation);
        addOption(new org.objectweb.ccm.util.compiler.Option("-h", 0,
                  "-h                Display this help."));
        addOption(new org.objectweb.ccm.util.compiler.Option("-o",1,
                  "-o <file>         Display the mapping on file <file>."));
        addOption(new org.objectweb.ccm.util.compiler.Option("-i",1,
                  "-i <file>         Add <file> in an include statement.")); 
        addOption(new org.objectweb.ccm.util.compiler.Option("-f", 1,
                  "-f <prop.file>   Define the file to use when generating the IDL import/include instructions."));
        objectName_ = "";
        commandName_ = commandName;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
}
