/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.scripts;

/**
 * This class manages the OpenCCM OMG IDL compiler.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IDLCompiler
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **  MUST BE COMMENTED with JavaDoc!
     **/
    private IDL3OptionsManager manager_;

    /**
     **  MUST BE COMMENTED with JavaDoc!
     **/
    private String version_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **  @param manager The manager.
     **  @param version The version.
     **/
    public
    IDLCompiler(IDL3OptionsManager manager,
                String version)
    {
        manager_ = manager;
        version_ = version;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     **  MUST BE COMMENTED with JavaDoc!
     **/
    protected void
    message(String text)
    {
        System.out.println(version_ + ": " + text);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **  Run the parser on the input file.
     **
     **  @param commandLine The command line arguments.
     **
     **  @return TODO
     **/
    public boolean
    run(String[] commandLine)
    {
        if (manager_.analyse(commandLine) == -1)
            return false;

        return true;
    }

    /**
     **  Obtain the option manager.
     **/
    public IDL3OptionsManager
    getManager()
    {
        return manager_;
    }
}
