/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.scripts;

/**
 * This class is launched by the idl3_start script.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IR3Install
       extends org.objectweb.ccm.CORBA.ApplicationServer
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    IR3Install()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================


    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     ** The main bootstrap method.
     **/
    public static void
    main(String[] args)
    {
        IR3Install ir3 = new IR3Install();
        int status = ir3.start(args);
	System.exit(status);
    }

    // ==================================================================
    //
    //  Methods for the org.objectweb.ccm.CORBA.ApplicationServer class.
    //
    // ==================================================================

    /**
     **  Before running the CORBA::ORB.
     **
     **  @param args The command line arguments.
     **
     **  @return The status.
     **/
    public int
    before_run(String[] args)
    {
        // Create an OMG IDL3 repository.
        org.objectweb.ccm.IR3.IFR repositoryServer =
            new org.objectweb.ccm.IR3.IFR();

        org.omg.CORBA.ComponentIR.Repository repositoryRef =
                  repositoryServer.getRepository().asComponentRepository();

        // Output the IOR of the IR3.
        org.objectweb.ccm.CORBA.TheORB.save_IOR(repositoryRef, args[0]);

        org.objectweb.ccm.CORBA.TheORB.bindToCorbaloc("DefaultRepository",  repositoryRef);       
        
        System.out.println("The OpenCCM's OMG IDL3 Repository is ready.");
	return 0;
    }

    /**
     **  After running the CORBA::ORB.
     **/
    public void
    after_run()
    {
    }
}
