/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.scripts;

/**
 * This class is launched by the ir3_xmi script.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IR3toXMI
       extends org.objectweb.ccm.CORBA.Application
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    IR3toXMI()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     ** The main bootstrap method.
     **/
    public static void
    main(String[] args)
    {
        IR3toXMI ir3 = new IR3toXMI();
        ir3.start(args);
    }

    // ==================================================================
    //
    //  Methods for the org.objectweb.ccm.CORBA.Application class.
    //
    // ==================================================================

    /**
     **  Run the application.
     **
     **  @param args The command line arguments.
     **
     **  @return The status.
     **/
    public int
    run(String[] args)
    {
        // Obtain the Interface Repository.
        org.objectweb.ccm.ComponentRepository repositoryRef =
            org.objectweb.ccm.ComponentRepositoryHelper.narrow(
                org.objectweb.ccm.CORBA.TheInterfaceRepository.getRepository());

        // Start an IDL3 Repository
        org.objectweb.ccm.IDL3.Repository rep = 
            new org.objectweb.ccm.IDL3.Repository(repositoryRef.as_IDL3_repository());


        //
        //  For the moment, the command line MUST be :
        //     ir3_xmi obj_name model_name
        //
        try
        {
            org.objectweb.ccm.visitorIDL3.xmi.IDL3_XMI mi = 
                new org.objectweb.ccm.visitorIDL3.xmi.IDL3_XMI(rep);

            mi.generate(args[0],
                        "stdout",
                        args[1]);
        }
        catch(fr.lifl.cim.jidlscript.lang.JISError ex)
        {
            System.err.println(ex.exception.toString());
            return 1;
        }

	return 0;
    }
}
