/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.visitorIDL3.common;

/**
 * .
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class Generator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private Printer printer_;

    /**
     **
     **/
    private org.objectweb.ccm.IDL3.Repository repository_;

    /**
     **
     **/
    private java.lang.String template_location_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    Generator(org.objectweb.ccm.IDL3.Repository repository)
    {
        // init internal state.
        repository_ = repository;
        printer_ = null;
        //
        //  TODO : change the system property name.
        //
        template_location_ = System.getProperty("ccm.templates");
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public void
    setPrinter(Printer printer)
    {
        printer_ = printer;
    }

    /**
     **
     **/
    public java.lang.String
    getTemplateLocation()
    {
        return template_location_;
    }

    /**
     **
     **/
    public java.lang.String
    visitObj(java.lang.String name)
    {
        org.objectweb.ccm.IDL3.Declaration decl = null;

        if (name.equals("::"))
            decl = repository_;
        else
            decl = repository_.lookup(name);

        if (decl==null)
        {
            java.lang.String msg = 
                "error in class org.objectweb.ccm.visitorIDL3.Generator\n"+
                "   operation : visit_obj\n"+
                "   message : object " + name + " not found : aborting generation !";
            throw new Error(msg);
        }

        java.lang.String[] aliases = { "obj" };
        java.lang.Object[] objs = { decl };
        printer_.map("OBJECT", aliases, objs);

        return "";
    }
}
