/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.visitorIDL3.idl;

import org.objectweb.ccm.visitorIDL3.common.*;

/**
 * .
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IDL2Printer
       extends IDL3Printer
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    IDL2Printer(Generator gen,
                char call_char,
                char comment_char,
                java.lang.String indent,
                java.lang.String filename)
    throws fr.lifl.cim.jidlscript.lang.JISError
    {
        super(gen, call_char, comment_char, indent);

        // load the template file.
        super.loadFile(filename);

        // set the "self" alias in root scope on this object.
        super.setAlias("self", this);
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public java.lang.String
    printCORBAImport()
    {
        super.printImmediately("#include \"IFR_3_0.idl\"\\n");
        return "";
    }

    /**
     **
     **/
    public java.lang.String
    printComponentsImport()
    {
        super.printImmediately("#include \"Components.idl\"\\n");
        return "";
    }

    /**
     **
     **/
    public java.lang.String
    printTypeCodeImport()
    {
        super.printImmediately("#include \"TypeCode.idl\"\\n");
        return "";
    }

    /**
     **
     **/
    public int
    forward_check()
    {
        //
        //  TODO : do not forward struct and unions because no orb supports it yet !
        //
        return (org.objectweb.ccm.IDL3.DeclarationKind._dk_interface +
                org.objectweb.ccm.IDL3.DeclarationKind._dk_local_interface +
                org.objectweb.ccm.IDL3.DeclarationKind._dk_abstract_interface +
                org.objectweb.ccm.IDL3.DeclarationKind._dk_component +
                org.objectweb.ccm.IDL3.DeclarationKind._dk_value + 
                //                org.objectweb.ccm.IDL3.DeclarationKind._dk_struct +
                //                org.objectweb.ccm.IDL3.DeclarationKind._dk_union +
                org.objectweb.ccm.IDL3.DeclarationKind._dk_event);
    }

    /**
     **
     **/
    public java.lang.String
    which()
    {
        return "ir3_idl2";
    }

    /**
     **
     **/
    public java.lang.String
    imported()
    {
        java.lang.String[] objs = ((IDL3_IDL2)getGenerator()).getIncluded();
        java.lang.String res = "";
        for (int i=0;i<objs.length;i++)
            res = res + "#include \""+objs[i]+"\"\\n";

        if (!res.equals(""))
            res = res + "\\n";

        return res;
    }

    /**
     **
     **/
    public java.lang.String
    imported(org.objectweb.ccm.util.Vector v)
    {
        java.lang.String res = "";
        for (java.util.Enumeration e = v.elements(); e.hasMoreElements();)
        {
            java.util.StringTokenizer st = 
                new java.util.StringTokenizer((java.lang.String) e.nextElement());
            if (st.countTokens() == 2) {
                // skip the first token
                st.nextToken();
                res += "#include <" + st.nextToken() + ">\\n";
            }
        }

        if (!res.equals(""))
            res = res + "\\n";

        return res;
    }

    /**
     **
     **/
    public java.lang.String[]
    getPropertyFilesList()
    {
        return (((IDL3_IDL2) getGenerator()).getPropertyFiles());
    }
}
