/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.visitorIDL3.idl;

import org.objectweb.ccm.visitorIDL3.common.*;

/**
 * .
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IDL3_IDL2
       extends Generator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private java.lang.String filename_;

    /**
     **
     **/
    private java.lang.String[] included_;

    /**
     **
     **/
    private java.lang.String[] propfiles_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    IDL3_IDL2(org.objectweb.ccm.IDL3.Repository repository)
    throws fr.lifl.cim.jidlscript.lang.JISError
    {
        super(repository);
        IDL2Printer printer = new IDL2Printer(this, '$', '#', "    ", "idl3.template");
        setPrinter(printer);
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public void
    setIncluded(java.lang.String[] included)
    {
        included_ = included;
    }

    /**
     **
     **/
    public void
    setFilename(java.lang.String filename)
    {
        filename_ = filename;
    }

    /**
     **
     **/
    public void
    setPropertyFiles(java.lang.String[] propfiles)
    {
        propfiles_ = propfiles;
    }

    /**
     **
     **/
    public java.lang.String[]
    getIncluded()
    {
        return included_;
    }

    /**
     **
     **/
    public java.lang.String
    getFilename()
    {
        return filename_;
    }

    /**
     **
     **/
    public java.lang.String[]
    getPropertyFiles()
    {
        return propfiles_;
    }

    /**
     **
     **/
    public void
    generate(java.lang.String name,
             java.lang.String filename,
             java.lang.String[] included,
             java.lang.String[] propfiles)
    {
        setIncluded(included);
        setFilename(filename);
        setPropertyFiles(propfiles);
        super.visitObj(name);
    }
}
