/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.visitorIDL3.java;

import org.objectweb.ccm.visitorIDL3.common.*;

/**
 * .
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class JavaTranslator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected org.objectweb.ccm.util.Table abs_names_;

    /**
     ** Java keywords table.
     **/
     protected org.objectweb.ccm.util.Table keywords_;
    

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    JavaTranslator()
    {
        abs_names_ = new org.objectweb.ccm.util.Table();
        keywords_ = new org.objectweb.ccm.util.Table();
        keywords_.put("public", new Object());
        keywords_.put("protected", new Object());
        keywords_.put("private", new Object());
        keywords_.put("class", new Object());
        keywords_.put("interface", new Object());
        keywords_.put("abstract", new Object());
        keywords_.put("boolean", new Object());
        keywords_.put("break", new Object());
        keywords_.put("byte", new Object());
        keywords_.put("case", new Object());
        keywords_.put("catch", new Object());
        keywords_.put("char", new Object());
        keywords_.put("const", new Object());
        keywords_.put("continue", new Object());
        keywords_.put("default", new Object());
        keywords_.put("do", new Object());
        keywords_.put("double", new Object());
        keywords_.put("else", new Object());
        keywords_.put("extends", new Object());
        keywords_.put("final", new Object());
        keywords_.put("finally", new Object());
        keywords_.put("float", new Object());
        keywords_.put("for", new Object());
        keywords_.put("goto", new Object());
        keywords_.put("if", new Object());
        keywords_.put("implements", new Object());
        keywords_.put("import", new Object());
        keywords_.put("instanceof", new Object());
        keywords_.put("int", new Object());
        keywords_.put("long", new Object());
        keywords_.put("native", new Object());
        keywords_.put("new", new Object());
        keywords_.put("package", new Object());
        keywords_.put("return", new Object());
        keywords_.put("short", new Object());
        keywords_.put("static", new Object());
        keywords_.put("super", new Object());
        keywords_.put("switch", new Object());
        keywords_.put("synchronized", new Object());
        keywords_.put("this", new Object());
        keywords_.put("throw", new Object());
        keywords_.put("throws", new Object());
        keywords_.put("transient", new Object());
        keywords_.put("try", new Object());
        keywords_.put("void", new Object());
        keywords_.put("volatile", new Object());
        keywords_.put("while", new Object());
        keywords_.put("true", new Object());
        keywords_.put("false", new Object());
        keywords_.put("null", new Object());
        keywords_.put("clone", new Object());
        keywords_.put("equals", new Object());
        keywords_.put("finalize", new Object());
        keywords_.put("getClass", new Object());
        keywords_.put("hashCode", new Object());
        keywords_.put("notify", new Object());
        keywords_.put("notifyAll", new Object());
        keywords_.put("toString", new Object());
        keywords_.put("wait", new Object());
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public java.lang.String
    toJava(org.objectweb.ccm.IDL3.TypeRef typeref)
    {
        switch(typeref.getTypeKind())
        {
            case org.objectweb.ccm.IDL3.TypeKind._tk_null :
                return "null";
            case org.objectweb.ccm.IDL3.TypeKind._tk_void :
                return "void";
            case org.objectweb.ccm.IDL3.TypeKind._tk_short :
                return "short";
            case org.objectweb.ccm.IDL3.TypeKind._tk_ushort :
                return "short";
            case org.objectweb.ccm.IDL3.TypeKind._tk_long :
                return "int";
            case org.objectweb.ccm.IDL3.TypeKind._tk_ulong :
                return "int";
            case org.objectweb.ccm.IDL3.TypeKind._tk_longlong :
                return "long";
            case org.objectweb.ccm.IDL3.TypeKind._tk_ulonglong :
                return "long";
            case org.objectweb.ccm.IDL3.TypeKind._tk_float :
                return "float";
            case org.objectweb.ccm.IDL3.TypeKind._tk_double :
                return "double";
            case org.objectweb.ccm.IDL3.TypeKind._tk_longdouble :
                return "double";
            case org.objectweb.ccm.IDL3.TypeKind._tk_boolean :
                return "boolean";
            case org.objectweb.ccm.IDL3.TypeKind._tk_char :
                return "char";
            case org.objectweb.ccm.IDL3.TypeKind._tk_wchar :
                return "char";
            case org.objectweb.ccm.IDL3.TypeKind._tk_octet :
                return "byte";
            case org.objectweb.ccm.IDL3.TypeKind._tk_any :
                return "org.omg.CORBA.Any";
            case org.objectweb.ccm.IDL3.TypeKind._tk_Principal :
                return "org.omg.CORBA.Principal";
            case org.objectweb.ccm.IDL3.TypeKind._tk_TypeCode :
                return "org.omg.CORBA.TypeCode";
            case org.objectweb.ccm.IDL3.TypeKind._tk_objref :
                return "org.omg.CORBA.Object";
            case org.objectweb.ccm.IDL3.TypeKind._tk_string :
                return "java.lang.String";
            case org.objectweb.ccm.IDL3.TypeKind._tk_wstring :
                return "java.lang.String";
            case org.objectweb.ccm.IDL3.TypeKind._tk_fixed :
                return "java.Math.BigDecimal";

            case org.objectweb.ccm.IDL3.TypeKind._tk_struct :
            case org.objectweb.ccm.IDL3.TypeKind._tk_union :
            case org.objectweb.ccm.IDL3.TypeKind._tk_enum :
            case org.objectweb.ccm.IDL3.TypeKind._tk_exception :
            case org.objectweb.ccm.IDL3.TypeKind._tk_value_box :
            case org.objectweb.ccm.IDL3.TypeKind._tk_value :
            case org.objectweb.ccm.IDL3.TypeKind._tk_native :
            case org.objectweb.ccm.IDL3.TypeKind._tk_abstract_interface :
            case org.objectweb.ccm.IDL3.TypeKind._tk_local_interface :
            case org.objectweb.ccm.IDL3.TypeKind._tk_interface :
            case org.objectweb.ccm.IDL3.TypeKind._tk_component :
            case org.objectweb.ccm.IDL3.TypeKind._tk_home :
            case org.objectweb.ccm.IDL3.TypeKind._tk_event :
                org.objectweb.ccm.IDL3.Declaration decl = (org.objectweb.ccm.IDL3.Declaration)typeref;
                return getAbsoluteName(decl);

            case org.objectweb.ccm.IDL3.TypeKind._tk_alias :
                org.objectweb.ccm.IDL3.AliasDecl alias = (org.objectweb.ccm.IDL3.AliasDecl)typeref;
                return toJava(alias.getType());

            case org.objectweb.ccm.IDL3.TypeKind._tk_sequence :
            case org.objectweb.ccm.IDL3.TypeKind._tk_array :
                org.objectweb.ccm.IDL3.TypeRefImpl impl= (org.objectweb.ccm.IDL3.TypeRefImpl)typeref;
                java.lang.String str = toJava(impl.getContentType());
                return str+"[]";
            default :
                return "";
        }
    }

    /**
     **
     **/
    public java.lang.String
    toJava(org.objectweb.ccm.IDL3.TypeRef type,
           int mode)
    {
        if (mode==org.objectweb.ccm.IDL3.OperationDecl.PARAM_IN)
            return toJava(type);

        switch(type.getTypeKind())
        {
            case org.objectweb.ccm.IDL3.TypeKind._tk_null :
            case org.objectweb.ccm.IDL3.TypeKind._tk_void :
                throw new Error("IDL null and void types could not be used for out or inout parameters!!!");

            case org.objectweb.ccm.IDL3.TypeKind._tk_short :
                return "org.omg.CORBA.ShortHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_ushort :
                return "org.omg.CORBA.ShortHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_long :
                return "org.omg.CORBA.IntHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_ulong :
                return "org.omg.CORBA.IntHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_longlong :
                return "org.omg.CORBA.LongHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_ulonglong :
                return "org.omg.CORBA.LongHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_float :
                return "org.omg.CORBA.FloatHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_double :
                return "org.omg.CORBA.DoubleHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_longdouble :
                throw new Error("Java mapping for IDL longdouble is unspecified!!!");

            case org.objectweb.ccm.IDL3.TypeKind._tk_boolean :
                return "org.omg.CORBA.BooleanHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_char :
                return "org.omg.CORBA.CharHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_wchar :
                return "org.omg.CORBA.CharHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_octet :
                return "org.omg.CORBA.ByteHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_any :
                return "org.omg.CORBA.AnyHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_Principal :
                return "org.omg.CORBA.PrincipalHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_TypeCode :
                return "org.omg.CORBA.TypeCodeHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_objref :
                return "org.omg.CORBA.ObjectHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_string :
                return "org.omg.CORBA.StringHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_wstring :
                return "org.omg.CORBA.StringHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_fixed :
                return "org.omg.CORBA.FixedHolder";

            case org.objectweb.ccm.IDL3.TypeKind._tk_alias :
	    {
                org.objectweb.ccm.IDL3.TypeRef ct = 
                    ((org.objectweb.ccm.IDL3.AliasDecl)type).getType();
                if ((ct.getTypeKind()==org.objectweb.ccm.IDL3.TypeKind._tk_array) ||
                    (ct.getTypeKind()==org.objectweb.ccm.IDL3.TypeKind._tk_sequence))
                    return getAbsoluteName((org.objectweb.ccm.IDL3.AliasDecl)type) + "Holder";
                else
                    return toJava(ct, mode);
            }

            case org.objectweb.ccm.IDL3.TypeKind._tk_sequence :
            case org.objectweb.ccm.IDL3.TypeKind._tk_array :
                throw new Error("Not implemented!!!");

            case org.objectweb.ccm.IDL3.TypeKind._tk_struct :
            case org.objectweb.ccm.IDL3.TypeKind._tk_union :
            case org.objectweb.ccm.IDL3.TypeKind._tk_enum :
            case org.objectweb.ccm.IDL3.TypeKind._tk_exception :
            case org.objectweb.ccm.IDL3.TypeKind._tk_value_box :
            case org.objectweb.ccm.IDL3.TypeKind._tk_value :
            case org.objectweb.ccm.IDL3.TypeKind._tk_native :
            case org.objectweb.ccm.IDL3.TypeKind._tk_abstract_interface :
            case org.objectweb.ccm.IDL3.TypeKind._tk_local_interface :
            case org.objectweb.ccm.IDL3.TypeKind._tk_interface :
            case org.objectweb.ccm.IDL3.TypeKind._tk_component :
            case org.objectweb.ccm.IDL3.TypeKind._tk_home :
            case org.objectweb.ccm.IDL3.TypeKind._tk_event :
                return getAbsoluteName((org.objectweb.ccm.IDL3.Declaration)type) + "Holder";

            default :
                throw new Error("Other cases are not supported!!!");
        }
    }

    /**
     **
     **/
    public java.lang.String
    checkKeywords(java.lang.String id)
    {

        if (keywords_.containsKey(id))
           return "_"+id;

        return id;
    }

    /**
     **
     **/
    public java.lang.String
    getAbsoluteName(org.objectweb.ccm.IDL3.Declaration decl)
    {
        if (decl==null)
            return "";

        // check if the absolute name has already been generated.
        java.lang.String res = null;
        res = (java.lang.String)abs_names_.get(decl.getId());
        if (res!=null)
            return res;

        // translate the IDL prefix into a java prefix.
        res = "";
        java.lang.String prefix = decl.getPrefix();
        int idx, idx2;
        if (!prefix.equals(""))
        {
            idx = prefix.indexOf('.');
            idx2 = 0;
            while (idx!=-1)
            {
                res = prefix.substring(idx2, idx+1) + res;
                idx2 = idx+1;
                idx = prefix.indexOf('.', idx2);
            }
            res = prefix.substring(idx2) + '.' + res;
        }

        // translate the IDL scoped name into a Java absolute name
        java.lang.String abs_name = decl.getAbsoluteName();
        idx = abs_name.indexOf(':', 2);
        idx2 = 2;
        while (idx!=-1)
        {
            res = res + abs_name.substring(idx2, idx) + '.';
            idx2 = idx+2;
            idx = abs_name.indexOf(':', idx2);
        }
        res = res + abs_name.substring(idx2);

        // check special cases ie nested types within interfaces
        org.objectweb.ccm.IDL3.Scope parent = decl.getParent();
        int parent_kind = parent.getDeclKind();
        int decl_kind = decl.getDeclKind();
        if (decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_constant)
        {
            if ((parent_kind!=org.objectweb.ccm.IDL3.DeclarationKind._dk_interface) &&
                (parent_kind!=org.objectweb.ccm.IDL3.DeclarationKind._dk_abstract_interface) &&
                (parent_kind!=org.objectweb.ccm.IDL3.DeclarationKind._dk_local_interface))
                res = res + ".value";
        }
        else if ((decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_exception) ||
                 (decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_alias) ||
                 (decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_struct) ||
                 (decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_union) ||
                 (decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_enum) ||
                 (decl_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_native))
        {
            if ((parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_interface) ||
                (parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_abstract_interface) ||
                (parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_local_interface) ||
                (parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_home) ||
                (parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_value) ||
                (parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_event) ||
                (parent_kind==org.objectweb.ccm.IDL3.DeclarationKind._dk_component))
            {
                idx = res.lastIndexOf('.');
                res = res.substring(0, idx) + "Package" + res.substring(idx);
            }
        }

        // store the computed absolute name
        abs_names_.put(decl.getId(), res);
        return res;
    }

    /**
     **
     **/
    public java.lang.String
    getPackage(org.objectweb.ccm.IDL3.Declaration decl)
    {
        java.lang.String abs_name = getAbsoluteName(decl);
        int idx = abs_name.lastIndexOf('.');
        if (idx==-1)
            return "";

        return abs_name.substring(0, idx);
    }

    /**
     **
     **/
    public java.lang.String
    getAsDirectory(org.objectweb.ccm.IDL3.Declaration decl)
    {
        java.lang.String abs_name = getAbsoluteName(decl);
        int idx = abs_name.indexOf('.');
        if (idx==-1)
            return "./";

        java.lang.String dir = "";
        int idx2 = 0;
        while (idx!=-1)
        {
            dir = dir + abs_name.substring(idx2, idx) + '/';
            idx2 = idx+1;
            idx = abs_name.indexOf('.', idx2);
        }

        return dir;
    }
}
