/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.ccm.visitorIDL3.xmi;

import org.objectweb.ccm.visitorIDL3.common.*;

/**
 * .
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IDL3_XMI
       extends Generator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private java.lang.String filename_;

    /**
     **
     **/
    private java.lang.String model_name_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    IDL3_XMI(org.objectweb.ccm.IDL3.Repository repository)
    throws fr.lifl.cim.jidlscript.lang.JISError
    {
        super(repository);
        XMIPrinter printer = new XMIPrinter(this, "    ");
        setPrinter(printer);
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public void
    setModelName(java.lang.String model_name)
    {
        model_name_ = model_name;
    }

    /**
     **
     **/
    public void
    setFilename(java.lang.String filename)
    {
        filename_ = filename;
    }

    /**
     **
     **/
    public java.lang.String
    getModelName()
    {
        return model_name_;
    }

    /**
     **
     **/
    public java.lang.String
    getFilename()
    {
        return filename_;
    }

    /**
     **
     **/
    public void
    generate(java.lang.String name,
             java.lang.String filename,
             java.lang.String model_name)
    {
        setModelName(model_name);
        setFilename(filename);
        visitObj(name);
    }
}
