/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.ast.lib;

/** To use AST AbstractStorageHomeDecl. */
import org.objectweb.corba.ast.api.AbstractStorageHomeDecl;

/**
 * AbstractStorageHomeListImpl is a wrapper class for
 * lists of AbstractStorageHomeDecl.
 *
 *
 * Inherits from:
 *
 * - ListImpl: The base class for all lists.
 *
 * - AbstractStorageHomeList: OMG IDL for lists of AbstractStorageHomeDecl.
 *
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.1
 */

public class AbstractStorageHomeListImpl
       extends ListBaseImpl
       implements org.objectweb.corba.ast.api.AbstractStorageHomeList
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     * The default constructor.
     */
    public
    AbstractStorageHomeListImpl()
    {
        // Call the ListBaseImpl constructor.
        super();
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for OMG IDL org.objectweb.corba.ast.api.List
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for OMG IDL org.objectweb.corba.ast.api.AbstractStorageHomeList
    //
    // ==================================================================

    /**
     * Add an AbstractStorageHomeDecl to this list.
     *
     * @param ash The AbstractStorageHomeDecl to add to the list.
     */
    public void
    add(AbstractStorageHomeDecl ash)
    {
        super.addObject(ash);
    }

    /**
     * Obtain all the AbstractStorageHomeDecl declarations added to this list.
     *
     * @return All the AbstractStorageHomeDecl declarations added to this list.
     */
    public AbstractStorageHomeDecl[]
    getAbstractStorageHomes()
    {
       return (AbstractStorageHomeDecl[])super.
              toArray(new AbstractStorageHomeDecl[0]);
    }
}
