/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.ast.lib;

/** To use AST AbstractStorageTypeDecl. */
import org.objectweb.corba.ast.api.AbstractStorageTypeDecl;

/**
 * AbstractStorageTypeListImpl is a wrapper class for
 * lists of AbstractStorageTypeDecl.
 *
 *
 * Inherits from:
 *
 * - ListImpl: The base class for all lists.
 *
 * - AbstractStorageTypeList: OMG IDL for lists of AbstractStorageTypeDecl.
 *
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.1
 */

public class AbstractStorageTypeListImpl
       extends ListBaseImpl
       implements org.objectweb.corba.ast.api.AbstractStorageTypeList
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     * The default constructor.
     */
    public
    AbstractStorageTypeListImpl()
    {
        // Call the ListBaseImpl constructor.
        super();
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for OMG IDL org.objectweb.corba.ast.api.List
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for OMG IDL org.objectweb.corba.ast.api.AbstractStorageTypeList
    //
    // ==================================================================

    /**
     * Add an AbstractStorageTypeDecl to this list.
     *
     * @param ast The AbstractStorageTypeDecl to add to the list.
     */
    public void
    add(AbstractStorageTypeDecl ast)
    {
        super.addObject(ast);
    }

    /**
     * Obtain all the AbstractStorageTypeDecl declarations added to this list.
     *
     * @return All the AbstractStorageTypeDecl declarations added to this list.
     */
    public AbstractStorageTypeDecl[]
    getAbstractStorageTypes()
    {
       return (AbstractStorageTypeDecl[])super.
              toArray(new AbstractStorageTypeDecl[0]);
    }
}
