/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet, Christophe Demarey.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.ast.lib;


/**
 * This class defines kinds of Declaration objects.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *         <a=href="Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.3
 */

public abstract class DeclarationKindImpl
           implements org.objectweb.corba.ast.api.DeclarationKind
{

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Retrieve the type in a String format
     *
     * @return the type in a String format
     */
    public static String
    toString(long kind)
    {
        if( kind == dk_null ){
            return "null";
        }else if( kind == dk_module ){
            return "module";
        }else if( kind == dk_abstract_interface ){
            return "abstract_interface";
        }else if( kind == dk_local_interface ){
            return "local_interface";
        }else if( kind == dk_interface ){
            return "interface";
        }else if( kind == dk_alias ){
            return "alias";
        }else if( kind == dk_attribute ){
            return "attribute";
        }else if( kind == dk_constant ){
            return "constant";
        }else if( kind == dk_enum ){
            return "enum";
        }else if( kind == dk_exception ){
            return "exception";
        }else if( kind == dk_native ){
            return "native";
        }else if( kind == dk_operation ){
            return "operation";
        }else if( kind == dk_struct ){
            return "struct";
        }else if( kind == dk_union ){
            return "union";
        }else if( kind == dk_value_box ){
            return "value_box";
        }else if( kind == dk_value ){
            return "value";
        }else if( kind == dk_value_member ){
            return "value_member";
        }else if( kind == dk_component ){
            return "component";
        }else if( kind == dk_consumes ){
            return "consumes";
        }else if( kind == dk_emits ){
            return "emits";
        }else if( kind == dk_publishes ){
            return "publishes";
        }else if( kind == dk_provides ){
            return "provides";
        }else if( kind == dk_uses ){
            return "uses";
        }else if( kind == dk_home ){
            return "home";
        }else if( kind == dk_factory ){
            return "factory";
        }else if( kind == dk_finder ){
            return "finder";
        }else if( kind == dk_event ){
            return "event";
        }else if( kind == dk_repository ){
            return "repository";
        }else if( kind == dk_abstract_storage_home ){
            return "abstract_storage_home";
        }else if( kind == dk_abstract_storage_type ){
            return "abstract_storage_type";
        }else if( kind == dk_psdl_operation ){
            return "psdl_operation";
        }else if( kind == dk_storage_home ){
            return "storage_home";
        }else if( kind == dk_storage_home_factory ){
            return "storage_home_factory";
        }else if( kind == dk_storage_home_key ){
            return "storage_home_key";
        }else if( kind == dk_storage_type ){
            return "storage_type";
        }else if( kind == dk_storage_type_state_member ){
            return "storage_type_state_member";
        }else if( kind == dk_storage_type_store_directive ){
            return "storage_type_store_directive";
        }else if( kind == dk_composition ){
            return "composition";
        }else if( kind == dk_executor ){
            return "executor";
        }else if( kind == dk_home_executor ){
            return "home_executor";
        }else if( kind == dk_proxy_home ){
            return "proxy_home";
        }else if( kind == dk_segment ){
            return "segment";
        }else{
            return "null";
        }
    }
}
