/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.ast.lib;

/**
 * WithNameImpl is a wrapper class for objects containing an associated name.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.1
 */

public class WithNameImpl
       extends ObjectBase
       implements org.objectweb.corba.ast.api.WithName
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The associated name. */
    protected String name_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /** The default constructor. */
    public
    WithNameImpl()
    {
        // Init internal state.
        name_ = null;
    }

    /**
     * The constructor.
     *
     * @param name The associated name.
     */
    public
    WithNameImpl(String name)
    {
        // Init internal state.
        name_ = name;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for OMG IDL org.objectweb.corba.ast.api.WithName
    //
    // ==================================================================

    /**
     * Set the associated name.
     *
     * @param name The associated name.
     */
    public void
    setName(String name)
    {
        name_ = name;
    }

    /**
     * Obtain the associated name.
     *
     * @return The associated name.
     */
    public String
    getName()
    {
        return name_;
    }
}
