/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Demarey Christophe.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.command.api;

/**
 * This interface define a standard command wich can be run.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */

public interface Command
{
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     *  Display a message on the standard output if printMsg is True.
     *
     * @param text - The message to print.
     *
     **/
    public void message(String text);

    /**
     *  Display a message on the error output.
     *
     * @param text - The message to print.
     *
     **/
    public void error(String text);

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Analyze command line.
     *
     * @param args - Arguments of the command.
     *
     **/
    public String[] parseArguments(String[] args);
}
