/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.command.api;

/**
 * This interface allows you to generate idl3 for a declaration from the repository.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 1.0
 */

public interface IR3toIDL3Operations
         extends GeneratorBaseOperations
{
    /**
     * Generate idl3 for a scope.
     * IR must be initialized first with method "initRepository()".
     *
     * @param decl_name - The scope to be generated.
     * @param outputfile - The file name to write in.
     * @param imports - IR declarations to import.
     *
     * @return The status : true if ok, else false.
     **/
    public boolean
    generate_idl3(String decl_name, String outputfile, String[] imports);
}
