/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.generator.idl;

/** To access AST DeclarationKind. */
import org.objectweb.corba.ast.api.DeclarationKind;

public class IDL2Generator extends IDL3Generator
{

    // ===========================================================
    //
    // Internal State.
    //
    // ===========================================================


    // ===========================================================
    //
    // Constructors.
    //
    // ===========================================================

    /**
     * The default constructor.
     *
     * @param root - The file scope containing all declarations.
     */

    public IDL2Generator(org.objectweb.corba.ast.api.Scope root)
    {
        // Call the IDL3Generator constructor
        super(root);
    }

    // ===========================================================
    //
    // Internal methods.
    //
    // ===========================================================


    // ===========================================================
    //
    // Useful methods for IDL2 Mapping.
    //
    // ===========================================================

    /**
     * Utility method to check forward declarations.
     *
     * @return The associated search mask.
     **/
    public long
    forward_check()
    {
        //
        //  TODO : do not forward struct and unions because no orb supports it yet !
        //
        return ( DeclarationKind.dk_interface +
                 DeclarationKind.dk_local_interface +
                 DeclarationKind.dk_abstract_interface +
                 DeclarationKind.dk_component +
                 DeclarationKind.dk_value +
                 //                DeclarationKind.dk_struct +
                 //                DeclarationKind.dk_union +
                 DeclarationKind.dk_event );
    }

    // ===========================================================
    //
    // Methods for IDL2 Mapping.
    //
    // ===========================================================


    // ===========================================================
    //
    // Public methods.
    //
    // ===========================================================

}
