/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.generator.idl;

public interface IDL3GeneratorOperations
{
    /**
     * Initialize the generator.
     *
     * @param outputfile - The name where declarations will be generated.
     * @param app_name - The application's name.
     **/
    public void
    initialize(String outputfile, String app_name);

    /**
     * Generates contents of a scope.
     * name must be a valid declaration name.
     *
     * @param name - The name of the declaration to visit.
     **/
    public void
    generate(String name)
    throws org.objectweb.corba.generator.common.GenerationException;

    /**
     * Generates contents of the root scope.
     * Declarations types must match to limited types.
     *
     * @param limited_types - A logical combination of DeclarationKind.
     **/
    public void
    generate(long limited_types)
    throws org.objectweb.corba.generator.common.GenerationException;
}
