/*====================================================================

ObjectWeb Util Package.
Copyright (C) 2002 INRIA & USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.lib;

/**
 * This is an abstract default implementation of the interface
 * org.objectweb.util.api.Printable.
 *
 * Subclasses must implement the
 * DefaultStringBufferizableBase.appendInternalState method.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.1
 */

public abstract class DefaultPrintableBase
              extends DefaultStringBufferizableBase
           implements org.objectweb.util.api.Printable
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /** The default constructor. */
    public
    DefaultPrintableBase()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for interface org.objectweb.util.api.Printable
    //
    // ==================================================================

    /**
     * Prints the target object to a java.io.PrintStream output stream.
     *
     * @param stream The java.io.PrintStream output stream.
     */
    public void
    print(java.io.PrintStream stream)
    {
      stream.print(toString());
    }

    // ==================================================================
    //
    // Other public methods.
    //
    // ==================================================================
}
