@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Deinstallation of the OpenCCM Platform.
rem #
rem # ====================================================================

setlocal

rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

echo The OpenCCM Platform will be deinstalled.

rem # Check if the OpenCCM's IR3 is started.
if exist %OpenCCM_CONFIG_DIR%\IR3.PID call ir3_stop

rem # Check if the Name Service is started.
if exist %OpenCCM_CONFIG_DIR%\NameService.PID call ns_stop

rem # Check if the Transaction Service is started.
if exist %OpenCCM_CONFIG_DIR%\TransactionService.PID call ots_stop

rem # TODO: Stop all started Java Component Servers.

rem # Remove the OpenCCM configuration directory.
echo Removing the %OpenCCM_CONFIG_DIR% directory.
rmdir /q /s %OpenCCM_CONFIG_DIR%

echo The OpenCCM Platform is deinstalled.
