@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Starting the OpenCCM's OMG IDL3 Repository.
rem #
rem # ====================================================================

setlocal

rem # Check if the OpenCCM's IR3 is already started.
if not exist %OpenCCM_CONFIG_DIR%\IR3.IOR goto not_started

echo Error: The OpenCCM's OMG IDL3 Repository is already started!
goto :eof

:not_started

echo The OpenCCM's OMG IDL3 Repository will be started.

rem # Check if the OpenCCM configuration directory doesn't exist.
if exist %OpenCCM_CONFIG_DIR% goto cfg_exist

echo Creating the %OpenCCM_CONFIG_DIR% directory.
mkdir %OpenCCM_CONFIG_DIR%

:cfg_exist

echo Launching the OpenCCM's IR3.
set args="org.objectweb.ccm.scripts.IR3Install %OpenCCM_CONFIG_DIR%\IR3.IOR "
call jvm fork "IR3" %args% %OpenCCM_CONFIG_DIR%\IR3.output %OpenCCM_CONFIG_DIR%\IR3.PID

echo Feeding the OpenCCM's IR3 with the IFR_3_0.idl file.
call ir3_feed -D__OMG_IDL3__ %OpenCCM_HOMEDIR%\idl\IFR_3_0.idl

echo Feeding the OpenCCM's IR3 with the Components.idl file.
call ir3_feed -D__OMG_IDL3__ %OpenCCM_HOMEDIR%\idl\Components.idl

echo IR3_STARTED > %OpenCCM_CONFIG_DIR%\IR3.start
echo The OpenCCM's OMG IDL3 Repository is started.


