@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Stopping the OpenCCM's OMG IDL3 Repository.
rem #
rem # ====================================================================

setlocal

rem Check if the OpenCCM's IR3 is started.
call %OpenCCM_HOMEDIR%\bin\ir3_started
if %IR3_STARTED%==0 goto :eof

rem echo Please, close IR3 window.
rem pause

echo The OpenCCM's OMG IDL3 Repository will be stopped.

rem # Shutdown the OpenCCM IR3 process.
call %OpenCCM_HOMEDIR%\bin\shutdown file:%OpenCCM_CONFIG_DIR%\IR3.IOR

rem Remove the associated files.
del %OpenCCM_CONFIG_DIR%\IR3.PID
del %OpenCCM_CONFIG_DIR%\IR3.IOR
del %OpenCCM_CONFIG_DIR%\IR3.output
del %OpenCCM_CONFIG_DIR%\IR3.start
rem del %OpenCCM_CONFIG_DIR%\IR3.output.tmp

rem Check if the OpenCCM Platform was not installed.
if exist %OpenCCM_CONFIG_DIR%\ComponentServers goto stopped

rem Remove the OpenCCM configuration directory.
echo Removing the %OpenCCM_CONFIG_DIR% directory.
rmdir /s /q %OpenCCM_CONFIG_DIR%

:stopped
echo The OpenCCM's OMG IDL3 Repository is stopped.
