@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): Jerome Offroy-------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Stopping an OpenCCM Java Component Server.
rem #
rem # ====================================================================

setlocal

if "%1"=="-h" goto :help
if "%1"=="" goto :help
goto :no_help

:help
echo usage: jcs_stop ^<server_name^>
goto :eof

:no_help

set JCS_PATH=%OpenCCM_CONFIG_DIR%\ComponentServers\%1

rem # Check if this Java Component Server is already started.
if exist %JCS_PATH%.PID goto :jcs_exist

echo Error: The Java Component Server %1 is not started!
goto :eof

:jcs_exist
echo The Java Component Server %1 will be stopped.

rem # Shutdown the Component Server.
rem call %OpenCCM_HOMEDIR%\bin\shutdown file:%JCS_PATH%.IOR
kill F%JCS_PATH%.PID > nul

rem wait for window to release the files use by the process killed (1s)
call sleep 2 
rem # Remove the associated files.
del %JCS_PATH%.IOR %JCS_PATH%.PID %JCS_PATH%.output %JCS_PATH%.output.tmp

rmdir /s /q %JCS_PATH%.archive_cache

echo The Java Component Server %1 is stopped.
