/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Sylvain Leblanc.
Contributor(s): ______________________________________.

====================================================================*/

package DiningPhilosophers;

/**
 * This is the implementation of the OMG IDL3
 * DiningPhilosophers::PhilosopherHome home type.
 *
 * This class inherits from the local CCM_PhilosopherHome interface
 * generated by the OpenCCM's IDL3 to IDL2 mapping generator.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a> 
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a> 
 *
 * @version 2.0
 */

public class PhilosopherHomePdaImpl
     extends org.omg.CORBA.LocalObject
  implements CCM_PhilosopherHome 
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /** The default constructor. */
    public
    PhilosopherHomePdaImpl()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for OMG IDL DiningPhilosophers::CCM_PhilosopherHome
    //
    // ==================================================================

    /**
     * Create a component executor.
     *
     * @return The EntrepriseComponent created executor.
     */
    public org.omg.Components.EnterpriseComponent
    create()
    {
        return new PhilosopherPdaImpl();
    }

    /**
     * Implementation of the 'new' factory operation.
     *
     * @param name The name of the philosopher to create.
     *
     * @return The EntrepriseComponent created executor.
     */
    public org.omg.Components.EnterpriseComponent
    _new(String name)
    {
        return new PhilosopherPdaImpl(name);
    }

    // ==================================================================
    //
    // Methods for the deployment.
    //
    // ==================================================================

    /**
     * This method is called by the OpenCCM Component Server
     * to create a home instance.
     */
    public static org.omg.Components.HomeExecutorBase
    create_home()
    {
        return new PhilosopherHomePdaImpl();
    }

    // Executed once at the loading of this class
    // by the OpenCCM Component Server.
    static
    {
        // Required to register the StatusInfo valuetype factory to the ORB.
        StatusInfoFactoryHelper.register(new StatusInfoFactory());
    }
}
