/* Generated By:JavaCC: Do not edit this line. Parser.java */
package org.objectweb.ccm.IDL3;

/**
 * Lexical and syntaxic analyser.
 * This class accesses the Interface Repository only through the IDL3 package classes.
 * This allows us to modify the IR without changing this class.
 *
 * @author <a=href="Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 *
 * @date 2001
 */

public class Parser implements ParserConstants {
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  Constructor with FileInputStream, Repository and ErrorManager.
     **
     **  @param str The file to parse.
     **  @param rep The IDL3 Repository to use for accessing the IR3.
     **  @param error The IDL3 ErrorManager that manages errors and warnings display.
     **/
    public
    Parser(java.io.FileInputStream str,
           Repository rep,
           ErrorManager error)
    {
        this(str);
        FileScope fs = rep.startFileScope("");
        globalScope_ = fs;
        currentScope_ = fs;
        ptf_ = rep;
        repository_ = rep;
        error_ = error;
        currentPrefix_ = null;
        scope_passed = 0;
        scopes_ = new java.util.Stack();
        fileScopes_ = new java.util.Stack();
        prefix_ = new java.util.Stack();
        forward_scopes_ = new java.util.Hashtable();
        keywords_ = new java.util.Hashtable();

        // the value 73 must be verified in ParserConstants
        // it's the index of the last keyword
        for (int i=8;i<73;i++)
        {
            keywords_.put(ParserConstants.tokenImage[i].toUpperCase(),ParserConstants.tokenImage[i]);
        }

        // the jj_input_stream variable denotes the input stream of the parser.
        // Warning: it's generated by JavaCC.
        token_source = new ParserTokenManager(jj_input_stream, this);
    }

    // ==================================================================
    //
    // Internal State.
    //
    // ==================================================================

    /**
     **  The IDL3 Repository.
     **/
    private Repository repository_;

    /**
     **  The current scope.
     **/
    private Scope currentScope_;

    /**
     **  To store Scope objects for recursive calls in the grammar.
     **/
    private java.util.Stack scopes_;

    /**
     **  The global scope.
     **/
    private Scope globalScope_;

    /**
     **  To obtain the CORBA::TypeRef of a base type or a template type.
     **/
    private PrimitiveTypeFactory ptf_;

    /**
     **  For forward declarations checking.
     **/
    private java.util.Hashtable forward_scopes_;

    /**
     **  For keyword collisions checking.
     **/
    private java.util.Hashtable keywords_;

    /**
     **  The ErrorManager reference.
     **/
    private ErrorManager error_;

    /**
     **  To store FileScope objects when an included file is detected.
     **/
    private java.util.Stack fileScopes_;

    /**
     **  The current prefix.
     **/
    private String currentPrefix_;

    /**
     **  To store prefix when an included file is detected.
     **/
    private java.util.Stack prefix_;


    /**
     **  To know how many scopes were not opened due to SystemException.
     **/
    private int scope_passed;

    // ==================================================================
    //
    // Public methods in relation with the ErrorManager.
    //
    // ==================================================================

    /**
     **  To set the ErrorManager that will be used by the parser for error and warning reporting.
     **/
    public final void
    setErrorManager(ErrorManager error)
    {
        error_ = error;
    }

    /**
     **  To obtain the ErrorManager.
     **/
    public final ErrorManager
    getErrorManager()
    {
        return error_;
    }

    /**
     ** Change the source filename.
     **/
    public final void
    setFileName(String fileName)
    {
       error_.setFileName(fileName);
    }

    // ==================================================================
    //
    // Public methods in relation with Scopes.
    //
    // ==================================================================

    /**
     **  Push the current scope on the stack and set scope as the current scope.
     **
     **  @param scope the new current scope.
     **/
    public void
    pushScope(Scope scope)
    {
        scopes_.push(currentScope_);
        prefix_.push(currentPrefix_);
        currentScope_ = scope;
        currentPrefix_ = null;
    }

    /**
     **  Pop the first scope from the stack and set it as the current scope.
     **/
    public void
    popScope()
    {
        currentScope_ = (Scope)scopes_.pop();
        currentPrefix_ = (String)prefix_.pop();
    }

    // ==================================================================
    //
    // Public methods in relation with the macros.
    //
    // ==================================================================

    /**
     **  This method is called by the Token Manager when he encounters the include begin mark.
     **/
    public void
    pushFileScope(String fileName)
    {
        FileScope fs = currentScope_.startFileScope(fileName);
        ((FileScope)globalScope_).addIncluded(fs);

        fileScopes_.push(globalScope_);
        scopes_.push(currentScope_);
        prefix_.push(currentPrefix_);
        currentScope_ = fs;
        globalScope_ = fs;
        currentPrefix_ = null;
    }

    /**
     **  This method is called by the Token Manager when he encounters the include end mark.
     **/
    public void
    popFileScope()
    {
        globalScope_ = (Scope)fileScopes_.pop();
        currentScope_ = (Scope)scopes_.pop();
        currentPrefix_ = (String)prefix_.pop();
    }

    /**
     **  To set the prefix for incoming declarations.
     **  Note: used by pragma prefix macro.
     **/
    public void
    setPrefix(String prefix)
    {
        currentPrefix_ = prefix;
    }

    /**
     **  To set the prefix for the specified declaration.
     **  Note: used by typePrefix rule.
     **/
    public void
    setPrefix(Declaration decl, String prefix)
    {
        decl.setPrefix(prefix);
    }

    /**
     **  To set the Id of a declaration.
     **  Note: used by pragma id macro.
     **
     **  @param name the name of a declaration.
     **/
    public void
    setId(String name, String id)
    {
        Declaration decl = currentScope_.find(name);
        if (decl == null)
            error(name + " must be declared.");
        else
            decl.setId(id);
    }

    /**
     **  To set the Id of a declaration.
     **  Note: used by typeId rule.
     **/
    public void
    setId(Declaration decl, String id)
    {
        decl.setId(id);
    }

    /**
     **  To set the version of a declaration.
     **  Note: used by pragma version macro.
     **
     **  @param name the name of a declaration.
     **/
    public void
    setVersion(String name, String version)
    {
        Declaration decl = currentScope_.find(name);
        if (decl == null)
            error(name + " must be declared.");
        else
            decl.setVersion(version);
    }

    // ==================================================================
    //
    // Internal methods in relation with the keywords.
    //
    // ==================================================================

    /**
     ** To test if an identifier collapses with a keyword.
     **/
    private final String
    collapse(String id)
    {
       String newid;
       // escape identifiers => turns off keyword checking
       if (id.charAt(0)=='_') return id.substring(1);
       // test if id is in the keyword hashtable
       newid="\""+id+"\"";
       newid=newid.toUpperCase();
       if (keywords_.containsKey(newid))
       {
          error("identifier "+getToken(0)+" collapses with keyword "+(String)keywords_.get(newid));
       }
       return id;
    }

    // ==================================================================
    //
    // Internal methods in relation with the Error Manager.
    //
    // ==================================================================

    /**
     ** Display a warning.
     **/
    private final void
    warning(String message)
    {
       error_.warning(token.beginLine,message);
    }

    /**
     ** Display a warning with a line number.
     **/
    private final void
    warning(int line,String message)
    {
       error_.warning(line,message);
    }

    /**
     ** Display an warning for a Declaration.
     **/
    private final void
    warning(Declaration decl, String message)
    {
        error_.warning(token.beginLine,
                       decl.getAbsoluteName() + ' ' + message);
    }

    /**
     ** Display an error.
     **/
    private final void
    error(String message)
    {
        error_.error(token.beginLine, message);
    }

    /**
     ** Display an error for a Declaration.
     **/
    private final void
    error(Declaration decl, String message)
    {
        error_.error(token.beginLine,
                     decl.getAbsoluteName() + ' ' + message);
    }

    /**
     ** Display an error for a SystemException.
     **/
    private final void
    error(org.omg.CORBA.SystemException sysExc)
    {
        error_.error(token.beginLine, sysExc);
    }

    // ==================================================================
    //
    // Internal methods in relation with the filter class.
    //
    // ==================================================================

    /**
     ** Create a Declaration.
     **/
    private final void
    createDeclaration(Declaration decl)
    {
        try
        {
            decl.setPrefix(currentPrefix_);
            decl.create();
        }
        catch(org.omg.CORBA.SystemException exc1)
        {
            error_.error(token.beginLine, exc1, decl);
        }
/*
        catch(Error exc2)
        {
            error_.error(token.beginLine, exc2.getMessage());
        }
        catch(java.lang.NullPointerException exc)
        {}
 */
    }

    /**
     ** Create a Forward Scope.
     **/
    private final void
    createForwardScope(ForwardScope forward)
    {
        try
        {
            forward.setPrefix(currentPrefix_);
            forward.setForward(true);
            forward.create();
            forward_scopes_.put(forward.getAbsoluteName(), forward);
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error_.error(token.beginLine, exc, forward);
        }
    }

    /**
     ** Check if forward scope declarations are completed.
     **/
    private final void
    checkForwardScopes()
    {
        for(java.util.Enumeration e = forward_scopes_.elements();
            e.hasMoreElements(); )
        {
           ForwardScope scope = (ForwardScope)e.nextElement();
           if (!scope.isCompleted())
               error_.error(token.beginLine, "forward declaration " +
                            scope.getAbsoluteName() + " not completed");
        }
    }

    /**
     ** Open a new Scope.
     **/
    private final void
    openScope(Scope scope)
    {
        try
        {
            if (scope instanceof ForwardScope)
            {
                ForwardScope fscope = (ForwardScope)scope;
                fscope.setForward(true);
                fscope.create();
                fscope.setForward(false);
            }

            scope.setPrefix(currentPrefix_);
            pushScope(scope);
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error_.error(token.beginLine, exc, scope);
            scope_passed++;
        }
    }

    /**
     ** Close a Scope.
     **/
    private final void
    closeScope()
    {
        if (scope_passed != 0)
        {
            scope_passed--;
            return;
        }
        try
        {
            currentScope_.create();
            popScope();
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error_.error(token.beginLine, exc, currentScope_);
        }
    }

    // ==================================================================
    //
    // Internal methods in relation with the translation of escaped 
    // sequences.
    //
    // ==================================================================

    /**
     ** Check if a character is a digit in radix 16.
     **/
    private final boolean
    isDigit16(char ch)
    {
       return Character.isDigit(ch) ||
              (Character.toUpperCase(ch)>='A' && Character.toUpperCase(ch)<='F');
    }

    /**
     ** Check if a character is a digit in radix 8.
     **/
    private final boolean
    isDigit8(char ch)
    {
       return Character.isDigit(ch) && ch <'8';
    }

    /**
     ** Translate all the escaped sequences of a String .
     **/
    private final String
    translateString(String input)
    {
      int i=0;
      StringBuffer result = new StringBuffer(input.length());
      while (i<input.length()) {
        if(input.charAt(i)!='\\') result.append(input.charAt(i));
        else {
          i++;
          switch(input.charAt(i))
          {
            case 'n'  : result.append('\n'); break;
            case 't'  : result.append('\t'); break;
            case 'v'  : result.append('\u000b'); break;
            case 'b'  : result.append('\u0008'); break;
            case 'r'  : result.append('\r'); break;
            case 'f'  : result.append('\f'); break;
            case 'a'  : result.append('\u0007'); break;
            case '\\' : result.append('\\'); break;
            case '?'  : result.append('?'); break;
            case '\'' : result.append('\''); break;
            case '\"' : result.append('\"'); break;
            case 'u'  :
            case 'x'  :
            {
              int j=i+1;
              while ( isDigit16(input.charAt(j) )) j++;
              result.append((char)Long.parseLong(input.substring(i+1,j),16));
              i=j-1;
              break;
            }
            default :
            {
              int j=i;
              while ( isDigit8(input.charAt(j) )) j++;
              result.append((char)Long.parseLong(input.substring(i,j),8));
              i=j-1;
              break;
            }
          }
        }
        i++;
      }
      return result.toString();
    }

  int was_expected(ParseException e,int[] type) throws ParseException {
   int[][] expected = e. expectedTokenSequences;
   for (int i=0;i<expected.length;i++)
   {
       for (int j=0;j<expected[i].length;j++)
       {
           for (int k=0;k<type.length;k++)
           {
               if (expected[i][j]==type[k])
                  return k;
           }
       }
   }
   return -1;
  }

  void error_manager(ParseException e) throws ParseException {
   Token t=getToken(0);
   int[] types = {LPAREN, RPAREN, LBRACKET, RBRACKET, GTSIGN, LTSIGN,
                  LBRACE, RBRACE, SEMICOLON};
   int ret;
   if ((ret=was_expected(e,types))!=-1)
   {
       error(ParserConstants.tokenImage[types[ret]] + " expected");
   }
   else
   {
       t=getToken(1);
       error("unexpected token " + "\"" + t.image + "\"");
   }
   t=getToken(0);
   while (t.kind != SEMICOLON)
   {
       t = getNextToken();
   }
  }

  void token_error_manager(TokenMgrError e) throws ParseException {
   Token t = getToken(1);
   warning(t.beginLine,"unknown macro");
  }

// ==================================================================
/**
 ** new production rules for identifier and some literals.
 **/
// ==================================================================
  final public String string_literal() throws ParseException {
    Token t;
    StringBuffer s = new StringBuffer("");
    String tmp;
    label_1:
    while (true) {
      t = jj_consume_token(STRING_LITERAL);
        tmp = translateString(t.image);
        s.append(tmp.substring(1,tmp.length()-1));
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_LITERAL:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
    }
        {if (true) return s.toString();}
    throw new Error("Missing return statement in function");
  }

  final public String wide_string_literal() throws ParseException {
    Token t;
    StringBuffer s = new StringBuffer("");
    String tmp;
    t = jj_consume_token(WIDE_STRING_LITERAL);
        tmp = translateString(t.image);
        s.append(tmp.substring(2,tmp.length()-1));
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      tmp = string_literal();
        s.append(tmp);
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
        {if (true) return s.toString();}
    throw new Error("Missing return statement in function");
  }

  final public String getIdentifier() throws ParseException {
    Token t;
    t = jj_consume_token(IDENTIFIER);
        {if (true) return collapse(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public void setInitializerName(Initializer id) throws ParseException {
    Token t;
    t = jj_consume_token(IDENTIFIER);
        id.setName(collapse(t.image));
  }

/**
 **  <type_name> ::= <scoped_name>
 **/
  final public TypeRef type_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof TypeRef)
            {if (true) return (TypeRef)decl;}

        error(decl, "must be a type name");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  <exception_name> ::= <scoped_name>
 **/
  final public ExceptionRef exception_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof ExceptionRef)
            {if (true) return (ExceptionRef)decl;}

        error(decl, "must be an exception name");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  <component_name> ::= <scoped_name>
 **/
  final public ComponentRef component_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof ComponentRef)
            {if (true) return (ComponentRef)decl;}

        error(decl, "must be a component type");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  <event_name> ::= <scoped_name>
 **/
  final public EventRef event_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof EventRef)
            {if (true) return (EventRef)decl;}

        error(decl, "must be a event type");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  <home_name> ::= <scoped_name>
 **/
  final public HomeRef home_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof HomeRef)
            {if (true) return (HomeRef)decl;}

        error(decl, "must be a home type");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  <imported_name> ::=  <identifier>
 **                     | "::" <identifier>
 **                     | <imported_name> "::" <identifier>
 **/
  final public String imported_name() throws ParseException {
    String id = null;
    String tmp = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DCOLON:
      jj_consume_token(DCOLON);
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    tmp = getIdentifier();
                                id=tmp;
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DCOLON:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_2;
      }
      jj_consume_token(DCOLON);
      tmp = getIdentifier();
                              id=id+"::"+tmp;
    }
        {if (true) return id;}
    throw new Error("Missing return statement in function");
  }

// ==================================================================
/**
 ** OMG IDL 2.4 Grammar
 **/
// ==================================================================

/**
 **  (1) <specification> ::= <importx>* <definition>+
 **/
  final public FileScope specification() throws ParseException {
    try {
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IMPORT:
          ;
          break;
        default:
          jj_la1[4] = jj_gen;
          break label_3;
        }
        importx();
      }
    } catch (ParseException e) {
         error_manager(e);
    } catch (TokenMgrError e) {
         token_error_manager(e);
    }
    label_4:
    while (true) {
      definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case TYPEID:
      case TYPEPREFIX:
      case COMPONENT:
      case EVENT:
      case HOME:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_4;
      }
    }
    checkForwardScopes();

    Token t = getNextToken();
    if (t.kind != EOF)
        error_.error(t.beginLine, " definition expected");

    {if (true) return (FileScope)globalScope_;}
    throw new Error("Missing return statement in function");
  }

/**
 ** (2) <definition> ::= <type_dcl> ";"
 **                  |   <const_dcl> ";"
 **                  |   <except_dcl> ";"
 **                  |   <interface> ";"
 **                  |   <module> ";"
 **                  |   <value> ";"
 **
 **                  |   <type_id_dcl> ";"
 **                  |   <type_prefix_dcl> ";"
 **                  |   <event> ";"
 **
 **                  |   <component> ";"
 **                  |   <home_dcl> ";"
 **/
  final public void definition() throws ParseException {
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ENUM:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
        type_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case CONST:
        const_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case EXCEPTION:
        except_dcl();
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[6] = jj_gen;
        if (jj_2_1(2)) {
          interfacex();
          jj_consume_token(SEMICOLON);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MODULE:
            module();
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[7] = jj_gen;
            if (jj_2_2(4)) {
              value();
              jj_consume_token(SEMICOLON);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case TYPEID:
                type_id_dcl();
                jj_consume_token(SEMICOLON);
                break;
              case TYPEPREFIX:
                type_prefix_dcl();
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[8] = jj_gen;
                if (jj_2_3(4)) {
                  event();
                  jj_consume_token(SEMICOLON);
                } else {
                  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                  case COMPONENT:
                    component();
                    jj_consume_token(SEMICOLON);
                    break;
                  case HOME:
                    home_dcl();
                    jj_consume_token(SEMICOLON);
                    break;
                  default:
                    jj_la1[9] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                  }
                }
              }
            }
          }
        }
      }
    } catch (ParseException e) {
         error_manager(e);
    } catch (TokenMgrError e) {
         token_error_manager(e);
    }
  }

/**
 **  (3) <module> ::= "module" <identifier> "{" <definition>+ "}"
 **/
  final public void module() throws ParseException {
    ModuleDecl module=null;
    String name;
    jj_consume_token(MODULE);
    name = getIdentifier();
        module = currentScope_.declareModule(name);
        openScope(module);
    jj_consume_token(LBRACE);
    label_5:
    while (true) {
      definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case TYPEID:
      case TYPEPREFIX:
      case COMPONENT:
      case EVENT:
      case HOME:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_5;
      }
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 **  (4) <interface> ::= <interface_dcl>
 **                  |   <forward_dcl>
 **/
  final public void interfacex() throws ParseException {
    if (jj_2_4(4)) {
      interface_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case INTERFACE:
      case LOCAL:
        forward_dcl();
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (5) <interface_dcl> ::= <interface_header> "{" <interface_body> "}"
 **/
  final public void interface_dcl() throws ParseException {
    InterfaceDecl itf=null;
    itf = interface_header();
        openScope(itf);
    jj_consume_token(LBRACE);
    interface_body();
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 **  (6) <forward_dcl> ::= [ "abstract" | "local" ] "interface" <identifier>
 **/
  final public void forward_dcl() throws ParseException {
    InterfaceDecl itf;
    itf = declare_interface();
          createForwardScope(itf);
  }

/**
 **  <declare_interface> ::= [ "abstract" | "local" ] "interface" <identifier>
 **/
  final public InterfaceDecl declare_interface() throws ParseException {
    InterfaceDecl itf=null;
    boolean is_abstract = false;
    boolean is_local = false;
    String name;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
    case LOCAL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                 is_abstract = true;
        break;
      case LOCAL:
        jj_consume_token(LOCAL);
              is_local = true;
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    jj_consume_token(INTERFACE);
    name = getIdentifier();
        try
        {
            if(is_abstract)
                itf = currentScope_.declareAbstractInterface(name);
            else if(is_local)
                itf = currentScope_.declareLocalInterface(name);
            else
                itf = currentScope_.declareInterface(name);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return itf;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (7) <interface_header> ::= [ "abstract" | "local" ]
 **                             "interface" <identifier>
 **                             [ <interface_inheritance_spec> ]
 **/
  final public InterfaceDecl interface_header() throws ParseException {
    InterfaceDecl itf=null;
    itf = declare_interface();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      interface_inheritance_spec(itf);
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
        {if (true) return itf;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (8) <interface_body> ::= <export>*
 **/
  final public void interface_body() throws ParseException {
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[15] = jj_gen;
        break label_6;
      }
      export();
    }
  }

/**
 **  (9) <export> ::= <type_dcl> ";"
 **               |   <const_dcl> ";"
 **               |   <except_dcl> ";"
 **               |   <attr_dcl> ";"
 **               |   <op_dcl> ";"
 **
 **               |   <type_id_dcl> ";"
 **               |   <type_prefix_dcl> ";"
 **/
  final public void export() throws ParseException {
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ENUM:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
        type_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case CONST:
        const_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case EXCEPTION:
        except_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case ATTRIBUTE:
      case READONLY:
        attr_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case SHORT:
      case STRING:
      case UNSIGNED:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case IDENTIFIER:
      case DCOLON:
        op_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case TYPEID:
        type_id_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case TYPEPREFIX:
        type_prefix_dcl();
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (ParseException e) {
        error_manager(e);
    } catch (TokenMgrError e) {
        token_error_manager(e);
    }
  }

/**
 **  (10) <interface_inheritance_spec> ::= ":" <interface_name>
 **                                            { "," <interface_name> }*
 **/
  final public void interface_inheritance_spec(InterfaceDecl itf) throws ParseException {
    InterfaceRef itfRef=null;
    jj_consume_token(COLON);
    itfRef = interface_name();
       itf.addInterface(itfRef);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[17] = jj_gen;
        break label_7;
      }
      jj_consume_token(COMMA);
      itfRef = interface_name();
       itf.addInterface(itfRef);
    }
  }

/**
 **  (11) interface_name ::= <scoped_name>
 **/
  final public InterfaceRef interface_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof InterfaceRef)
            {if (true) return (InterfaceRef)decl;}

        error(decl, "must be an interface");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (12) <scoped_name> ::= <identifier>
 **                    |   "::" <identifier>
 **                    |    <scoped_name> "::" <identifier>
 **
 **  Note: Recursivity is removed into our implementation.
 **/
  final public Declaration scoped_name() throws ParseException {
    Declaration decl = null;
    Declaration decl1 = null;
    Scope current = currentScope_;
    String id;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DCOLON:
      jj_consume_token(DCOLON);
           current = globalScope_;
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    id = getIdentifier();
        decl = current.find(id);
        if (decl == null)
        {
            error(id + " must be declared");
            {if (true) return null;}
        }
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DCOLON:
        ;
        break;
      default:
        jj_la1[19] = jj_gen;
        break label_8;
      }
      jj_consume_token(DCOLON);
      id = getIdentifier();
          if (!(decl instanceof Scope))
          {
              error(decl.getAbsoluteName() + "is not a scope");
              {if (true) return null;}
          }
          decl1 = ((Scope)decl).find(id);
          if (decl1==null)
          {
              error(decl.getAbsoluteName() + "::" + id  + " must be declared");
              {if (true) return null;}
          }
          decl = decl1;
    }
        {if (true) return decl;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (13) <value> ::= ( <value_dcl> | <value_abs_dcl> | <value_box_dcl>
 **               |     <value_forward_dcl> )
 **/
  final public void value() throws ParseException {
    if (jj_2_5(4)) {
      value_dcl();
    } else if (jj_2_6(4)) {
      value_abs_dcl();
    } else if (jj_2_7(4)) {
      value_box_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case VALUETYPE:
        value_forward_dcl();
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (14) <value_forward_dcl> ::= [ "abstract" ] "valuetype" <identifier>
 **/
  final public void value_forward_dcl() throws ParseException {
    ValueDecl value = null;
    String name;
    boolean is_abstract = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
      jj_consume_token(ABSTRACT);
                 is_abstract = true;
      break;
    default:
      jj_la1[21] = jj_gen;
      ;
    }
    jj_consume_token(VALUETYPE);
    name = getIdentifier();
        try
        {
            value = currentScope_.declareValue(name);
            if (is_abstract)
                value.setAbstract();
            createForwardScope(value);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
  }

/**
 **  (15) <value_box_dcl> ::= "valuetype" <identifier> <type_spec>
 **/
  final public void value_box_dcl() throws ParseException {
    ValueBoxDecl valuebox = null;
    TypeRef type = null;
    String name = null;
    jj_consume_token(VALUETYPE);
    name = getIdentifier();
    type = type_spec();
        valuebox = currentScope_.startValueBox(name);
        valuebox.setType(type);
        createDeclaration(valuebox);
  }

/**
 **  (16) <value_abs_dcl> ::= "abstract" "valuetype" <identifier>
 **                                                  [ <value_inheritance_spec> ]
 **                                                  "{" <export>* "}"
 **/
  final public void value_abs_dcl() throws ParseException {
    ValueDecl value = null;
    String name;
    if (jj_2_8(4)) {
      jj_consume_token(ABSTRACT);
      jj_consume_token(VALUETYPE);
      name = getIdentifier();
        try
        {
            value = currentScope_.declareValue(name);
            value.setAbstract();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        openScope(value);
      jj_consume_token(LBRACE);
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANY:
        case ATTRIBUTE:
        case BOOLEAN:
        case CHAR:
        case CONST:
        case DOUBLE:
        case ENUM:
        case EXCEPTION:
        case FLOAT:
        case LONG:
        case NATIVE:
        case OBJECT:
        case OCTET:
        case ONEWAY:
        case READONLY:
        case SHORT:
        case STRING:
        case STRUCT:
        case TYPEDEF:
        case UNSIGNED:
        case UNION:
        case VALUEBASE:
        case VOID:
        case WCHAR:
        case WSTRING:
        case TYPEID:
        case TYPEPREFIX:
        case IDENTIFIER:
        case DCOLON:
          ;
          break;
        default:
          jj_la1[22] = jj_gen;
          break label_9;
        }
        export();
      }
      jj_consume_token(RBRACE);
        closeScope();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
        jj_consume_token(VALUETYPE);
        name = getIdentifier();
        try
        {
            value = currentScope_.declareValue(name);
            value.setAbstract();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        value_inheritance_spec(value);
        openScope(value);
        jj_consume_token(LBRACE);
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ANY:
          case ATTRIBUTE:
          case BOOLEAN:
          case CHAR:
          case CONST:
          case DOUBLE:
          case ENUM:
          case EXCEPTION:
          case FLOAT:
          case LONG:
          case NATIVE:
          case OBJECT:
          case OCTET:
          case ONEWAY:
          case READONLY:
          case SHORT:
          case STRING:
          case STRUCT:
          case TYPEDEF:
          case UNSIGNED:
          case UNION:
          case VALUEBASE:
          case VOID:
          case WCHAR:
          case WSTRING:
          case TYPEID:
          case TYPEPREFIX:
          case IDENTIFIER:
          case DCOLON:
            ;
            break;
          default:
            jj_la1[23] = jj_gen;
            break label_10;
          }
          export();
        }
        jj_consume_token(RBRACE);
        closeScope();
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (17) <value_dcl> ::= <value_header> "{" <value_element>* "}"
 **/
  final public void value_dcl() throws ParseException {
    ValueDecl value = null;
    value = value_header();
        openScope(value);
    jj_consume_token(LBRACE);
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FACTORY:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case PRIVATE:
      case PUBLIC:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_11;
      }
      value_element();
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 **  (18) <value_header> ::= [ "custom" ] "valuetype" <identifier>
 **                                                   [ <value_inheritance_spec> ]
 **/
  final public ValueDecl value_header() throws ParseException {
    ValueDecl value = null;
    boolean is_custom = false;
    String name;
    if (jj_2_9(4)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
        jj_consume_token(CUSTOM);
                            is_custom = true;
        break;
      default:
        jj_la1[26] = jj_gen;
        ;
      }
      jj_consume_token(VALUETYPE);
      name = getIdentifier();
        try
        {
            value = currentScope_.declareValue(name);
            if (is_custom)
                value.setCustom();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
      value_inheritance_spec(value);
        {if (true) return value;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
      case VALUETYPE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CUSTOM:
          jj_consume_token(CUSTOM);
               is_custom = true;
          break;
        default:
          jj_la1[27] = jj_gen;
          ;
        }
        jj_consume_token(VALUETYPE);
        name = getIdentifier();
        try
        {
            value = currentScope_.declareValue(name);
            if (is_custom)
                value.setCustom();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return value;}
        break;
      default:
        jj_la1[28] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

/**
 **  (19) <value_inheritance_spec> ::= [ ":" [ "truncatable" ] <value_name>
 **                                          { "," <value_name> }* ]
 **                                    [ "supports" <interface_name>
 **                                                 { "," <interface_name> }* ]
 **/
  final public void value_inheritance_spec(ValueDecl value) throws ParseException {
    ValueRef valueRef=null;
    InterfaceRef itfRef=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUNCATABLE:
        jj_consume_token(TRUNCATABLE);
                          value.isTruncatable();
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      valueRef = value_name();
        if (valueRef != null)
        {
            if (valueRef.getValueDef().is_abstract())
                value.addAbstractValue(valueRef);
            else
                value.setBaseValue(valueRef);
        }
      label_12:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[30] = jj_gen;
          break label_12;
        }
        jj_consume_token(COMMA);
        valueRef = value_name();
        value.addAbstractValue(valueRef);
      }
      break;
    default:
      jj_la1[31] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUPPORTS:
      jj_consume_token(SUPPORTS);
      itfRef = interface_name();
        value.addInterface(itfRef);
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[32] = jj_gen;
          break label_13;
        }
        jj_consume_token(COMMA);
        itfRef = interface_name();
        value.addInterface(itfRef);
      }
      break;
    default:
      jj_la1[33] = jj_gen;
      ;
    }
  }

/**
 **  (20) <value_name> ::= <scoped_name>
 **/
  final public ValueRef value_name() throws ParseException {
    Declaration decl = null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof ValueRef)
            {if (true) return (ValueRef)decl;}

        error(decl, "must be a valuetype");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (21) <value_member> ::= <export>
 **                      |   <state_member>
 **                      |   <init_dcl>
 **/
  final public void value_element() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case ATTRIBUTE:
    case BOOLEAN:
    case CHAR:
    case CONST:
    case DOUBLE:
    case ENUM:
    case EXCEPTION:
    case FLOAT:
    case LONG:
    case NATIVE:
    case OBJECT:
    case OCTET:
    case ONEWAY:
    case READONLY:
    case SHORT:
    case STRING:
    case STRUCT:
    case TYPEDEF:
    case UNSIGNED:
    case UNION:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case TYPEID:
    case TYPEPREFIX:
    case IDENTIFIER:
    case DCOLON:
      export();
      break;
    case PRIVATE:
    case PUBLIC:
      state_member();
      break;
    case FACTORY:
      init_dcl();
      break;
    default:
      jj_la1[34] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 **  (22) <state_member> ::= ( "public" | "private" ) <type_spec> <declarators> ";"
 **/
  final public void state_member() throws ParseException {
    DeclaratorList declList=null;
    TypeRef type=null;
    boolean is_public=false;
    boolean is_private=false;
    ValueDecl value = (ValueDecl)currentScope_;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PUBLIC:
      jj_consume_token(PUBLIC);
               is_public=true;
      break;
    case PRIVATE:
      jj_consume_token(PRIVATE);
                                               is_private=true;
      break;
    default:
      jj_la1[35] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    type = type_spec();
    declList = declarators(type);
    jj_consume_token(SEMICOLON);
        for(int i=0; i<declList.size(); i++)
        {
            ValueMemberDecl vm = value.startValueMember(declList.nameAt(i));
            if(is_public) vm.setPublic();
            if(is_private) vm.setPrivate();
            vm.setType(declList.typeAt(i));
            createDeclaration(vm);
        }
  }

/**
 **  (23) <init_dcl> ::= "factory" <identifier> "(" [ <init_param_dcls> ] ")" ";"
 **/
  final public void init_dcl() throws ParseException {
    Initializer init = null;
    String name = null;
    ValueDeclImpl val = (ValueDeclImpl)currentScope_;
    jj_consume_token(FACTORY);
    name = getIdentifier();
        init = currentScope_.startInitializer(name);
        val.addInitializer(init);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      init_param_dcls(init);
      break;
    default:
      jj_la1[36] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
  }

/**
 **  (24) <init_param_dcls> ::= <init_param_dcls> { "," <init_param_dcls> }*
 **/
  final public void init_param_dcls(WithInParameters init) throws ParseException {
    init_param_dcl(init);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[37] = jj_gen;
        break label_14;
      }
      jj_consume_token(COMMA);
      init_param_dcl(init);
    }
  }

/**
 **  (25) <init_param_dcl> ::= <init_param_attribute> <param_type_spec>
 **                                                    <simple_declarator>
 **
 **  (26) <init_param_attribute> ::= "in"
 **/
  final public void init_param_dcl(WithInParameters init) throws ParseException {
    TypeRef type = null;
    String id = null;
    jj_consume_token(IN);
    type = param_type_spec();
    id = simple_declarator();
        init.addInParam(id, type);
  }

/**
 **  (27) <const_dcl> ::= "const" <const_type> <identifier> "=" <const_exp>
 **/
  final public void const_dcl() throws ParseException {
  ConstantDecl constant = null;
  AnyValue value = null;
  String name = null;
  TypeRef type;
    jj_consume_token(CONST);
    type = const_type();
    name = getIdentifier();
    jj_consume_token(ASSIGN);
    value = const_exp();
        constant = currentScope_.startConstant(name);
        constant.setType(type);
        constant.setAnyValue(value);
        createDeclaration(constant);
  }

/**
 **  (28) <const_type> ::= <integer_type>
 **                    |   <char_type>
 **                    |   <wide_char_type>
 **                    |   <boolean_type>
 **                    |   <floating_pt_type>
 **                    |   <string_type>
 **                    |   <wide_string_type>
 **                    |   <fixed_pt_const_type>
 **                    |   <scoped_name>
 **                    |   <octet_type>
 **/
  final public TypeRef const_type() throws ParseException {
  TypeRef type=null;
    if (jj_2_10(2)) {
      type = floating_pt_type();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHAR:
        type = char_type();
        break;
      case WCHAR:
        type = wide_char_type();
        break;
      case BOOLEAN:
        type = boolean_type();
        break;
      case LONG:
      case SHORT:
      case UNSIGNED:
        type = integer_type();
        break;
      case STRING:
        type = string_type();
        break;
      case WSTRING:
        type = wide_string_type();
        break;
      case FIXED:
        type = fixed_pt_const_type();
        break;
      case IDENTIFIER:
      case DCOLON:
        type = type_name();
        break;
      case OCTET:
        type = octet_type();
        break;
      default:
        jj_la1[38] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (29) <const_exp> ::= <or_expr>
 **/
  final public AnyValue const_exp() throws ParseException {
    AnyValue v;
    v = or_expr();
        {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (30) <or_expr> ::= <xor_expr>
 **                 |   <or_expr> "|" <xor_expr>
 **/
  final public AnyValue or_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = xor_expr();
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PIPE:
        ;
        break;
      default:
        jj_la1[39] = jj_gen;
        break label_15;
      }
      jj_consume_token(PIPE);
      v2 = xor_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() | v2.getAsInteger());
            else
                error("invalid operand for binary operator |");
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (31) <xor_expr> ::= <and_expr>
 **                  |   <xor_expr> "^" <and_expr>
 **/
  final public AnyValue xor_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = and_expr();
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CICUMFLEX:
        ;
        break;
      default:
        jj_la1[40] = jj_gen;
        break label_16;
      }
      jj_consume_token(CICUMFLEX);
      v2 = and_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() ^ v2.getAsInteger());
            else
                error("invalid operand for binary operator ^");
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (32) <and_expr> ::= <shift_expr>
 **                  |   <and_expr> "&" <shift_expr>
 **/
  final public AnyValue and_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = shift_expr();
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AMPERSAND:
        ;
        break;
      default:
        jj_la1[41] = jj_gen;
        break label_17;
      }
      jj_consume_token(AMPERSAND);
      v2 = shift_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() & v2.getAsInteger());
            else
                error("invalid operand for binary operator &");
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (33) <shift_expr> ::= <add_expr>
 **                    |   <shift_expr> ">>" <add_expr>
 **                    |   <shift_expr> "<<" <add_expr>
 **/
  final public AnyValue shift_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = add_expr();
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RSHIFT:
      case LSHIFT:
        ;
        break;
      default:
        jj_la1[42] = jj_gen;
        break label_18;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RSHIFT:
        jj_consume_token(RSHIFT);
        v2 = add_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() >> v2.getAsInteger());
            else
                error("invalid operand for binary operator >>");
        break;
      case LSHIFT:
        jj_consume_token(LSHIFT);
        v2 = add_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() << v2.getAsInteger());
            else
                error("invalid operand for binary operator <<");
        break;
      default:
        jj_la1[43] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (34) <add_expr> ::= <mult_expr>
 **                  |   <add_expr> "+" <mult_expr>
 **                  |   <add_expr> "-" <mult_expr>
 **/
  final public AnyValue add_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = mult_expr();
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[44] = jj_gen;
        break label_19;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
        v2 = mult_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() + v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() + v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() + v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() + v2.getAsFloating());
            else
                error("invalid operand for binary operator +");
        break;
      case MINUS:
        jj_consume_token(MINUS);
        v2 = mult_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() - v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() - v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() - v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() - v2.getAsFloating());
            else
                error("invalid operand for binary operator -");
        break;
      default:
        jj_la1[45] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (35) <mult_expr> ::= <unary_expr>
 **                   |   <mult_expr> "*" <unary_expr>
 **                   |   <mult_expr> "/" <unary_expr>
 **                   |   <mult_expr> "%" <unary_expr>
 **/
  final public AnyValue mult_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = unary_expr();
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
      case REM:
        ;
        break;
      default:
        jj_la1[46] = jj_gen;
        break label_20;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
        v2 = unary_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() * v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() * v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() * v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() * v2.getAsFloating());
            else
                error("invalid operand for binary operator *");
        break;
      case SLASH:
        jj_consume_token(SLASH);
        v2 = unary_expr();
             if(v1.isInteger() && v2.isInteger())
                v1.setAsFloating(v1.getAsInteger() / v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() / v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() / v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() / v2.getAsFloating());
            else
                error("invalid operand for binary operator /");
        break;
      case REM:
        jj_consume_token(REM);
        v2 = unary_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() % v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() % v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() % v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() % v2.getAsFloating());
            else
                error("invalid operand for binary operator %");
        break;
      default:
        jj_la1[47] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (36) <unary_expr> ::= <unary_operator> <primary_expr>
 **                    |   <primary_expr>
 **
 **  (37) <unary_operator> ::= "-" | "+" | "~"
 **/
  final public AnyValue unary_expr() throws ParseException {
    AnyValue value=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FALSE:
    case TRUE:
    case INTEGER_LITERAL:
    case STRING_LITERAL:
    case WIDE_STRING_LITERAL:
    case CHARACTER_LITERAL:
    case WIDE_CHARACTER_LITERAL:
    case FLOATING_PT_LITERAL:
    case FIXED_PT_LITERAL:
    case IDENTIFIER:
    case LPAREN:
    case DCOLON:
      value = primary_expr();
      break;
    case MINUS:
      jj_consume_token(MINUS);
      value = primary_expr();
        if (value.isInteger())
            value.setAsInteger(-value.getAsInteger());
        else if (value.isFloating())
            value.setAsFloating(-value.getAsFloating());
        else
            error("wrong argument type for unary minus");
      break;
    case PLUS:
      jj_consume_token(PLUS);
      value = primary_expr();
        if (!value.isInteger() && !value.isFloating())
            error("wrong argument type for unary plus");
      break;
    case TILDE:
      jj_consume_token(TILDE);
      value = primary_expr();
        if (value.isInteger())
            value.setAsInteger(~value.getAsInteger());
        else
            error("wrong argument type for bit-complement");
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (38) <primary_expr> ::= <scoped_name>
 **                      |   <literal>
 **                      |   "(" <const_exp> ")"
 **/
  final public AnyValue primary_expr() throws ParseException {
    AnyValue value=null;
    Declaration decl;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      decl = scoped_name();
        if(decl != null)
        {
            if (decl instanceof AnyValueDecl)
                value = ((AnyValueDecl)decl).getAnyValue();
            else
                error(decl, "must be a constant name or enumerator");
        }
        if(value == null)
        {
            value = new AnyValue();
            value.setAsInteger(0);
        }
      break;
    case FALSE:
    case TRUE:
    case INTEGER_LITERAL:
    case STRING_LITERAL:
    case WIDE_STRING_LITERAL:
    case CHARACTER_LITERAL:
    case WIDE_CHARACTER_LITERAL:
    case FLOATING_PT_LITERAL:
    case FIXED_PT_LITERAL:
      value = literal();
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      value = const_exp();
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (39) <literal> ::= <integer_literal>
 **                 |   <string_literal>
 **                 |   <wide_string_literal>
 **                 |   <character_literal>
 **                 |   <wide_character_literal>
 **                 |   <fixed_pt_literal>
 **                 |   <floating_pt_literal>
 **                 |   <boolean_literal>
 **
 **  (40) <boolean_literal> ::= "TRUE"
 **                         |   "FALSE"
 **/
  final public AnyValue literal() throws ParseException {
    AnyValue value = new AnyValue();
    Token t;
    String s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      t = jj_consume_token(INTEGER_LITERAL);
        s = t.image.toLowerCase();
        if (s.startsWith("0x"))
            value.setAsInteger(Long.parseLong(s.substring(2,s.length()),16));
        else if (s.startsWith("0"))
            value.setAsInteger(Long.parseLong(s,8));
        else
            value.setAsInteger(Long.parseLong(s,10));
      break;
    default:
      jj_la1[50] = jj_gen;
      if (jj_2_11(2)) {
        s = string_literal();
        value.setAsString(s);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case WIDE_STRING_LITERAL:
          s = wide_string_literal();
        value.setAsWString(s);
          break;
        default:
          jj_la1[51] = jj_gen;
          if (jj_2_12(2)) {
            t = jj_consume_token(CHARACTER_LITERAL);
        s = translateString(t.image);
        value.setAsChar(s.charAt(1));
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case WIDE_CHARACTER_LITERAL:
              t = jj_consume_token(WIDE_CHARACTER_LITERAL);
        s = translateString(t.image);
        value.setAsWChar(s.charAt(2));
              break;
            default:
              jj_la1[52] = jj_gen;
              if (jj_2_13(2)) {
                t = jj_consume_token(FIXED_PT_LITERAL);
        s = t.image;
        value.setAsFixed(s.substring(0,s.length()-1));
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case FLOATING_PT_LITERAL:
                  t = jj_consume_token(FLOATING_PT_LITERAL);
        value.setAsFloating(Double.parseDouble(t.image));
                  break;
                case TRUE:
                  jj_consume_token(TRUE);
        value.setAsBoolean(true);
                  break;
                case FALSE:
                  jj_consume_token(FALSE);
        value.setAsBoolean(false);
                  break;
                default:
                  jj_la1[53] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
            }
          }
        }
      }
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (41) <positive_int_const> ::= <const_exp>
 **/
  final public int positive_int_const() throws ParseException {
     AnyValue value;
    value = const_exp();
        if (value.isInteger())
        {
             long integer = value.getAsInteger();
             if(integer >= 0)
                 {if (true) return (int)integer;}
        }
        error("positive constant required");
        {if (true) return 1;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (42) <type_dcl> ::= "typedef" <type_declarator>
 **                  |   <constr_forward_dcl>
 **                  |   <struct_type>
 **                  |   <union_type>
 **                  |   <enum_type>
 **                  |   "native" <simple_declarator>
 **/
  final public void type_dcl() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYPEDEF:
      jj_consume_token(TYPEDEF);
      type_declarator();
      break;
    default:
      jj_la1[54] = jj_gen;
      if (jj_2_14(3)) {
        struct_type();
      } else if (jj_2_15(3)) {
        union_type();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STRUCT:
        case UNION:
          constr_forward_dcl();
          break;
        case ENUM:
          enum_type();
          break;
        case NATIVE:
        NativeDecl n = null;
        String name = null;
          jj_consume_token(NATIVE);
          name = getIdentifier();
        n = currentScope_.startNative(name);
        createDeclaration(n);
          break;
        default:
          jj_la1[55] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

/**
 **  (43) <type_declarator> ::= <type_spec> <declarators>
 **/
  final public void type_declarator() throws ParseException {
    TypeRef type=null;
    DeclaratorList declList=null;
    type = type_spec();
    declList = declarators(type);
        for(int i=0; i<declList.size(); i++)
        {
            AliasDecl alias = currentScope_.startAlias(declList.nameAt(i));
            alias.setType(declList.typeAt(i));
            createDeclaration(alias);
        }
  }

/**
 **  (44) <type_spec> ::= <simple_type_spec>
 **                   |   <constr_type_spec>
 **/
  final public TypeRef type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FIXED:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SEQUENCE:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      type = simple_type_spec();
      break;
    case ENUM:
    case STRUCT:
    case UNION:
      type = constr_type_spec();
      break;
    default:
      jj_la1[56] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (45) <simple_type_spec> ::= <base_type_spec>
 **                          |   <template_type_spec>
 **                          |   <scoped_name>
 **/
  final public TypeRef simple_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
      type = base_type_spec();
      break;
    case FIXED:
    case SEQUENCE:
    case STRING:
    case WSTRING:
      type = template_type_spec();
      break;
    case IDENTIFIER:
    case DCOLON:
      type = type_name();
      break;
    default:
      jj_la1[57] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (46) <base_type_spec> ::= <floating_pt_type>
 **                        |   <integer_type>
 **                        |   <char_type>
 **                        |   <wide_char_type>
 **                        |   <boolean_type>
 **                        |   <octet_type>
 **                        |   <any_type>
 **                        |   <object_type>
 **                        |   <value_base_type>
 **/
  final public TypeRef base_type_spec() throws ParseException {
    TypeRef type;
    if (jj_2_16(2)) {
      type = floating_pt_type();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LONG:
      case SHORT:
      case UNSIGNED:
        type = integer_type();
        break;
      case CHAR:
        type = char_type();
        break;
      case WCHAR:
        type = wide_char_type();
        break;
      case BOOLEAN:
        type = boolean_type();
        break;
      case OCTET:
        type = octet_type();
        break;
      case ANY:
        type = any_type();
        break;
      case OBJECT:
        type = object_type();
        break;
      case VALUEBASE:
        type = value_base_type();
        break;
      default:
        jj_la1[58] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (47) <template_type_spec> ::= <sequence_type>
 **                            |   <string_type>
 **                            |   <wide_string_type>
 **                            |   <fixed_pt_type>
 **/
  final public TypeRef template_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEQUENCE:
      type = sequence_type();
      break;
    case STRING:
      type = string_type();
      break;
    case WSTRING:
      type = wide_string_type();
      break;
    case FIXED:
      type = fixed_pt_type();
      break;
    default:
      jj_la1[59] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (48) <constr_type_spec> ::= <struct_type>
 **                          |   <union_type>
 **                          |   <enum_type>
 **/
  final public TypeRef constr_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRUCT:
      type = struct_type();
      break;
    case UNION:
      type = union_type();
      break;
    case ENUM:
      type = enum_type();
      break;
    default:
      jj_la1[60] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (49) <declarators> ::= <declarator> { "," <declarator> }*
 **/
  final public DeclaratorList declarators(TypeRef baseType) throws ParseException {
    DeclaratorList declList = new DeclaratorList();
    declarator(declList, baseType);
    label_21:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[61] = jj_gen;
        break label_21;
      }
      jj_consume_token(COMMA);
      declarator(declList, baseType);
    }
        {if (true) return declList;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (50) <declarator> ::= <simple_declarator>
 **                    |   <complex_declarator>
 **/
  final public void declarator(DeclaratorList declList, TypeRef baseType) throws ParseException {
  String name;
    if (jj_2_17(2)) {
      complex_declarator(declList, baseType);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        name = simple_declarator();
        declList.addDeclarator(name, baseType);
        break;
      default:
        jj_la1[62] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (51) <simple_declarator> ::= <identifier>
 **/
  final public String simple_declarator() throws ParseException {
    String n;
    n = getIdentifier();
        {if (true) return n;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (52) <complex_declarator> ::= <array_declarator>
 **/
  final public void complex_declarator(DeclaratorList declList, TypeRef baseType) throws ParseException {
    array_declarator(declList, baseType);
  }

/**
 **  (53) <floating_pt_type> ::= "float"
 **                          |   "double"
 **                          |   "long" "double"
 **/
  final public TypeRef floating_pt_type() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FLOAT:
      jj_consume_token(FLOAT);
        {if (true) return ptf_.type_float();}
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
        {if (true) return ptf_.type_double();}
      break;
    case LONG:
      jj_consume_token(LONG);
      jj_consume_token(DOUBLE);
        {if (true) return ptf_.type_long_double();}
      break;
    default:
      jj_la1[63] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 **  (54) <integer_type> ::= <signed_int>
 **                      |   <unsigned_int>
 **
 **  (55) <signed_int>   ::= <signed_short_int>
 **                      |   <signed_long_int>
 **                      |   <signed_longlong_int>
 **
 **  (56) <signed_short_int> ::= "short"
 **
 **  (57) <signed_long_int>  ::= "long"
 **
 **  (58) <signed_longlong_int> ::= "long" "long"
 **
 **  (59) <unsigned_int>   ::= <unsigned_short_int>
 **                        |   <unsigned_long_int>
 **                        |   <unsigned_longlong_int>
 **
 **  (60) <unsigned_short_int> ::= "unsigned" "short"
 **
 **  (61) <unsigned_long_int>  ::= "unsigned" "long"
 **
 **  (62) <unsigned_longlong_int> ::= "unsigned" "long" "long"
 **/
  final public TypeRef integer_type() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SHORT:
      jj_consume_token(SHORT);
        {if (true) return ptf_.type_short();}
      break;
    default:
      jj_la1[64] = jj_gen;
      if (jj_2_18(2)) {
        jj_consume_token(LONG);
        jj_consume_token(LONG);
        {if (true) return ptf_.type_long_long();}
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LONG:
          jj_consume_token(LONG);
        {if (true) return ptf_.type_long();}
          break;
        default:
          jj_la1[65] = jj_gen;
          if (jj_2_19(2)) {
            jj_consume_token(UNSIGNED);
            jj_consume_token(SHORT);
        {if (true) return ptf_.type_unsigned_short();}
          } else if (jj_2_20(3)) {
            jj_consume_token(UNSIGNED);
            jj_consume_token(LONG);
            jj_consume_token(LONG);
        {if (true) return ptf_.type_unsigned_long_long();}
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case UNSIGNED:
              jj_consume_token(UNSIGNED);
              jj_consume_token(LONG);
        {if (true) return ptf_.type_unsigned_long();}
              break;
            default:
              jj_la1[66] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      }
    }
    throw new Error("Missing return statement in function");
  }

/**
 **  (63) <char_type> ::= "char"
 **/
  final public TypeRef char_type() throws ParseException {
    jj_consume_token(CHAR);
        {if (true) return ptf_.type_char();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (64) <wide_char_type> ::= "wchar"
 **/
  final public TypeRef wide_char_type() throws ParseException {
    jj_consume_token(WCHAR);
        {if (true) return ptf_.type_wchar();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (65) <boolean_type> ::= "boolean"
 **/
  final public TypeRef boolean_type() throws ParseException {
    jj_consume_token(BOOLEAN);
        {if (true) return ptf_.type_boolean();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (66) <octet_type> ::= "octet"
 **/
  final public TypeRef octet_type() throws ParseException {
    jj_consume_token(OCTET);
        {if (true) return ptf_.type_octet();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (67) <any_type> ::= "any"
 **/
  final public TypeRef any_type() throws ParseException {
    jj_consume_token(ANY);
        {if (true) return ptf_.type_any();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (68) <object_type> ::= "Object"
 **/
  final public TypeRef object_type() throws ParseException {
    jj_consume_token(OBJECT);
        {if (true) return ptf_.type_Object();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (69) <struct_type> ::= "struct" <identifier> "{" <member_list> "}"
 **/
  final public TypeRef struct_type() throws ParseException {
    StructDecl struct = null;
    String name = "";
    jj_consume_token(STRUCT);
    name = getIdentifier();
        struct = currentScope_.declareStruct(name);
        openScope(struct);
    jj_consume_token(LBRACE);
    member_list();
    jj_consume_token(RBRACE);
        closeScope();
        {if (true) return (TypeRef)struct;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (70) <member_list> ::= <member>+
 **/
  final public void member_list() throws ParseException {
    StructDecl struct = (StructDecl)currentScope_;
    label_22:
    while (true) {
      member(struct.getMembers());
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case ENUM:
      case FIXED:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case SEQUENCE:
      case SHORT:
      case STRING:
      case STRUCT:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case WCHAR:
      case WSTRING:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[67] = jj_gen;
        break label_22;
      }
    }
  }

/**
 **  (71) <member> ::= <type_spec> <declarators> ";"
 **/
  final public void member(StructMembers list) throws ParseException {
    TypeRef type;
    DeclaratorList declList;
    type = type_spec();
    declList = declarators(type);
    jj_consume_token(SEMICOLON);
        for(int i=0; i<declList.size(); i++)
        {
            list.addMember(declList.nameAt(i), declList.typeAt(i));
        }
  }

/**
 **  (72) <union_type> ::= "union" <identifier> "switch" "(" <switch_type_spec> ")"
 **                                            "{" <switch_body> "}"
 **/
  final public TypeRef union_type() throws ParseException {
    UnionDecl union = null;
    String name = "";
    TypeRef type=null;
    jj_consume_token(UNION);
    name = getIdentifier();
    jj_consume_token(SWITCH);
    jj_consume_token(LPAREN);
    type = switch_type_spec();
    jj_consume_token(RPAREN);
        union = currentScope_.declareUnion(name);
        union.setDiscriminator(type);
        openScope(union);
    jj_consume_token(LBRACE);
    switch_body();
    jj_consume_token(RBRACE);
        closeScope();
        {if (true) return (TypeRef)union;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (73) <switch_type_spec> ::= <integer_type>
 **                          |   <char_type>
 **                          |   <boolean_type>
 **                          |   <enum_type>
 **                          |   <scoped_name>
 **/
  final public TypeRef switch_type_spec() throws ParseException {
  TypeRef type=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LONG:
    case SHORT:
    case UNSIGNED:
      type = integer_type();
      break;
    case CHAR:
      type = char_type();
      break;
    case BOOLEAN:
      type = boolean_type();
      break;
    case ENUM:
      type = enum_type();
      break;
    case IDENTIFIER:
    case DCOLON:
      type = type_name();
      break;
    default:
      jj_la1[68] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (74) <switch_body> ::= <case>+
 **/
  final public void switch_body() throws ParseException {
    label_23:
    while (true) {
      casex();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case DEFAULTX:
        ;
        break;
      default:
        jj_la1[69] = jj_gen;
        break label_23;
      }
    }
  }

/**
 **  (75) <case> ::= <case_label>+ <element_spec> ";"
 **/
  final public void casex() throws ParseException {
    java.util.Vector labels = new java.util.Vector();
    AnyValue label;
    label_24:
    while (true) {
      label = case_label();
                         labels.addElement(label);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case DEFAULTX:
        ;
        break;
      default:
        jj_la1[70] = jj_gen;
        break label_24;
      }
    }
    element_spec(labels);
    jj_consume_token(SEMICOLON);
  }

/**
 **  (76) <case_label> ::=  "case" <const_exp> ":"
 **                    |    "default" ":"
 **/
  final public AnyValue case_label() throws ParseException {
    AnyValue value = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CASE:
      jj_consume_token(CASE);
      value = const_exp();
      jj_consume_token(COLON);
      break;
    case DEFAULTX:
      jj_consume_token(DEFAULTX);
      jj_consume_token(COLON);
        value = new AnyValue();
      break;
    default:
      jj_la1[71] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (77) <element_spec> ::= <type_spec> <declarator>
 **/
  final public void element_spec(java.util.Vector labels) throws ParseException {
    TypeRef type;
    DeclaratorList declList = new DeclaratorList();
    UnionDecl union = (UnionDecl)currentScope_;
    type = type_spec();
    declarator(declList, type);
        String name = declList.nameAt(0);
        type = declList.typeAt(0);

        for(int i=0; i<labels.size(); i++)
        {
            try
            {
                union.addMember(name, type, (AnyValue)labels.elementAt(i));
            }
            catch(org.omg.CORBA.SystemException exc)
            {
                error(exc);
            }
        }
  }

/**
 **  (78) <enum_type> ::= "enum" <identifier> "{" <enumerator>
 **                                               { "," <enumerator> }* "}"
 **
 **  (79) <enumerator> ::= <identifier>
 **/
  final public TypeRef enum_type() throws ParseException {
    EnumDecl enum = null;
    String enumerator=null;
    String name = null;
    jj_consume_token(ENUM);
    name = getIdentifier();
    jj_consume_token(LBRACE);
    enumerator = getIdentifier();
        enum = currentScope_.startEnum(name);
        enum.addMember(enumerator);
    label_25:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[72] = jj_gen;
        break label_25;
      }
      jj_consume_token(COMMA);
      enumerator = getIdentifier();
        enum.addMember(enumerator);
    }
    jj_consume_token(RBRACE);
        createDeclaration(enum);
        {if (true) return (TypeRef)enum;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (80) <sequence_type> ::= "sequence" "<" <simple_type_spec> ","
 **                                          <positive_int_const> ">"
 **                       |   "sequence" "<" <simple_type_spec> ">"
 **/
  final public TypeRef sequence_type() throws ParseException {
    TypeRef base=null;
    int length=0;
    jj_consume_token(SEQUENCE);
    jj_consume_token(LTSIGN);
    base = simple_type_spec();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      length = positive_int_const();
      break;
    default:
      jj_la1[73] = jj_gen;
      ;
    }
    jj_consume_token(GTSIGN);
        try
        {
            {if (true) return ptf_.createSequence(length, base);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (81) <string_type> ::= "string" "<" <positive_int_const> ">"
 **                     |   "string"
 **/
  final public TypeRef string_type() throws ParseException {
    int length = -1;
    jj_consume_token(STRING);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LTSIGN:
      jj_consume_token(LTSIGN);
      length = positive_int_const();
      jj_consume_token(GTSIGN);
      break;
    default:
      jj_la1[74] = jj_gen;
      ;
    }
        try
        {
            if (length == -1)
                {if (true) return ptf_.type_string();}
            else
                {if (true) return ptf_.createString(length);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (82) <wide_string_type> ::= "wstring" "<" <positive_int_const> ">"
 **                      |   "wstring"
 **/
  final public TypeRef wide_string_type() throws ParseException {
  int length = -1;
    jj_consume_token(WSTRING);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LTSIGN:
      jj_consume_token(LTSIGN);
      length = positive_int_const();
      jj_consume_token(GTSIGN);
      break;
    default:
      jj_la1[75] = jj_gen;
      ;
    }
        try
        {
            if (length == -1)
                {if (true) return ptf_.type_wstring();}
            else
                {if (true) return ptf_.createWstring(length);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (83) <array_declarator> ::= <identifier> <fixed_array_size>+
 **
 **  (84) <fixed_array_size> ::= "[" <positive_int_pos> "]"
 **/
  final public void array_declarator(DeclaratorList declList, TypeRef type) throws ParseException {
    String id;
    int size;
    id = getIdentifier();
    label_26:
    while (true) {
      jj_consume_token(LBRACKET);
      size = positive_int_const();
        try
        {
            type = ptf_.createArray(size, type);
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
      jj_consume_token(RBRACKET);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[76] = jj_gen;
        break label_26;
      }
    }
        declList.addDeclarator(id, type);
  }

/**
 **  (85) <attr_dcl> ::= <readonly_attr_spec>
 **                   |   <attr_spec>
 **/
  final public void attr_dcl() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case READONLY:
      readonly_attr_spec();
      break;
    case ATTRIBUTE:
      attr_spec();
      break;
    default:
      jj_la1[77] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 **  (86) <except_dcl> ::= "exception" <identifier> "{" <member>* "}"
 **/
  final public void except_dcl() throws ParseException {
    ExceptionDecl exception = null;
    String name = null;
    jj_consume_token(EXCEPTION);
    name = getIdentifier();
        exception = currentScope_.startException(name);
        openScope(exception);
    jj_consume_token(LBRACE);
    label_27:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case ENUM:
      case FIXED:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case SEQUENCE:
      case SHORT:
      case STRING:
      case STRUCT:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case WCHAR:
      case WSTRING:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[78] = jj_gen;
        break label_27;
      }
      member(exception.getMembers());
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 **  (87) <op_dcl> ::= [ <op_attribute> ] <op_type_spec> <identifier>
 **                                       <parameter_dcls>
 **                                       [ <raises_expr> ] [ <context_expr> ]
 **
 **  (88) <op_attribute> ::= "oneway"
 **/
  final public void op_dcl() throws ParseException {
    OperationDecl op = null;
    String name = null;
    boolean oneway = false;
    TypeRef type = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ONEWAY:
      jj_consume_token(ONEWAY);
               oneway = true;
      break;
    default:
      jj_la1[79] = jj_gen;
      ;
    }
    type = op_type_spec();
    name = getIdentifier();
        op = currentScope_.startOperation(name);
        if (oneway) op.setOneway();
        op.setResultType(type);
    parameter_dcls(op);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(op.getExceptionList());
      break;
    default:
      jj_la1[80] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONTEXT:
      context_expr(op);
      break;
    default:
      jj_la1[81] = jj_gen;
      ;
    }
        createDeclaration(op);
  }

/**
 **  (89) <op_type_spec> ::= <param_type_spec>
 **                      |   "void"
 **/
  final public TypeRef op_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      type = param_type_spec();
        {if (true) return type;}
      break;
    case VOID:
      jj_consume_token(VOID);
        {if (true) return ptf_.type_void();}
      break;
    default:
      jj_la1[82] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 **  (90) <parameter_dcls> ::= "(" <param_dcl> { "," <param_dcl> }* ")"
 **                        |   "(" ")"
 **/
  final public void parameter_dcls(OperationDecl op) throws ParseException {
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
    case INOUT:
    case OUT:
      param_dcl(op);
      label_28:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[83] = jj_gen;
          break label_28;
        }
        jj_consume_token(COMMA);
        param_dcl(op);
      }
      break;
    default:
      jj_la1[84] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
  }

/**
 **  (91) <param_dcl> ::= <param_attribute> <param_type_spec> <simple_declarator>
 **
 **  (92) <param_attribute> ::= "in" | "out" | "inout"
 **/
  final public void param_dcl(OperationDecl op) throws ParseException {
    TypeRef type=null;
    String id=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      jj_consume_token(IN);
      type = param_type_spec();
      id = simple_declarator();
        op.addInParam(id, type);
      break;
    case OUT:
      jj_consume_token(OUT);
      type = param_type_spec();
      id = simple_declarator();
        op.addOutParam(id, type);
      break;
    case INOUT:
      jj_consume_token(INOUT);
      type = param_type_spec();
      id = simple_declarator();
        op.addInOutParam(id, type);
      break;
    default:
      jj_la1[85] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 **  (93) <raises_expr> ::= "raises" "(" <scoped_name>
 **                                      { "," <scoped_name> }* ")"
 **/
  final public void raises_expr(ExceptionList excList) throws ParseException {
    ExceptionRef excRef=null;
    jj_consume_token(RAISES);
    jj_consume_token(LPAREN);
    excRef = exception_name();
        excList.add(excRef);
    label_29:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[86] = jj_gen;
        break label_29;
      }
      jj_consume_token(COMMA);
      excRef = exception_name();
        excList.add(excRef);
    }
    jj_consume_token(RPAREN);
  }

/**
 **  (94) <context_expr> ::= "context" "(" <string_literal>
 **                                        { "," <string_literal> }* ")"
 **/
  final public void context_expr(OperationDecl op) throws ParseException {
    String s=null;
    jj_consume_token(CONTEXT);
    jj_consume_token(LPAREN);
    s = string_literal();
        op.addContext(s);
    label_30:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[87] = jj_gen;
        break label_30;
      }
      jj_consume_token(COMMA);
      s = string_literal();
        op.addContext(s);
    }
    jj_consume_token(RPAREN);
  }

/**
 **  (95) <param_type_spec> ::= <base_type_spec>
 **                         |   <string_type>
 **                         |   <wide_string_type>
 **                         |   <scoped_name>
 **/
  final public TypeRef param_type_spec() throws ParseException {
    TypeRef type=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
      type = base_type_spec();
      break;
    case STRING:
      type = string_type();
      break;
    case WSTRING:
      type = wide_string_type();
      break;
    case IDENTIFIER:
    case DCOLON:
      type = type_name();
      break;
    default:
      jj_la1[88] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (96) <fixed_pt_type> ::= "fixed" "<" <positive_int_const> ","
 **                                       <positive_int_const> ">"
 **/
  final public TypeRef fixed_pt_type() throws ParseException {
    int digits=0;
    int scale=0;
    jj_consume_token(FIXED);
    jj_consume_token(LTSIGN);
    digits = positive_int_const();
    jj_consume_token(COMMA);
    scale = positive_int_const();
    jj_consume_token(GTSIGN);
        try
        {
            {if (true) return ptf_.createFixed((short)digits, (short)scale);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (97) <fixed_pt_const_type> ::= "fixed"
 **/
  final public TypeRef fixed_pt_const_type() throws ParseException {
    jj_consume_token(FIXED);
        try
        {
            {if (true) return ptf_.createFixed((short)0, (short)0);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (98) <value_base_type> ::= "ValueBase"
 **/
  final public TypeRef value_base_type() throws ParseException {
    jj_consume_token(VALUEBASE);
        {if (true) return ptf_.type_value_base();}
    throw new Error("Missing return statement in function");
  }

/**
 **  (99) <constr_forward_dcl> ::= "struct" <identifier>
 **                             |   "union" <identifier>
 **/
  final public void constr_forward_dcl() throws ParseException {
    Declaration decl = null;
    String name = "";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRUCT:
      jj_consume_token(STRUCT);
      name = getIdentifier();
        decl = currentScope_.declareStruct(name);
      break;
    case UNION:
      jj_consume_token(UNION);
      name = getIdentifier();
        decl = currentScope_.declareUnion(name);
      break;
    default:
      jj_la1[89] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        createForwardScope((ForwardScope)decl);
  }

// ==================================================================
/**
 ** OMG IDL 3.0 Grammar
 **/
// ==================================================================

/**
 **  (100) <importx> ::= "import" <imported_scope> ";"
 **/
  final public void importx() throws ParseException {
    jj_consume_token(IMPORT);
    imported_scope();
    jj_consume_token(SEMICOLON);
  }

/**
 **  (101) <imported_scope> ::= <scoped_name> | <string_literal>
 **/
  final public void imported_scope() throws ParseException {
    String s = null;
    Declaration decl = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      s = imported_name();
        decl = repository_.load(globalScope_, s);
      break;
    case STRING_LITERAL:
      s = string_literal();
        decl = repository_.loadId(globalScope_, s);
      break;
    default:
      jj_la1[90] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        if (decl==null)
            error(s + " not found or with bad DefinitionKind");
  }

/**
 **  (102) <type_id_dcl> ::= "typeid" <scoped_name> <string_literal>
 **/
  final public void type_id_dcl() throws ParseException {
    Declaration decl;
    String id;
    jj_consume_token(TYPEID);
    decl = scoped_name();
    id = string_literal();
        setId(decl,id);
  }

/**
 **  (103) <type_prefix_dcl> ::= "typeprefix" <scoped_name> <string_literal>
 **/
  final public void type_prefix_dcl() throws ParseException {
    Declaration decl;
    String prefix;
    jj_consume_token(TYPEPREFIX);
    decl = scoped_name();
    prefix = string_literal();
        setPrefix(decl,prefix);
  }

/**
 **  (104) <readonly_attr_spec> ::= "readonly" "attribute" <param_type_spec>
 **                                               <readonly_attr_declarator>
 **/
  final public void readonly_attr_spec() throws ParseException {
    TypeRef type;
    jj_consume_token(READONLY);
    jj_consume_token(ATTRIBUTE);
    type = param_type_spec();
    readonly_attr_declarator(type);
  }

/**
 **  (105) <readonly_attr_declarator> ::= <simple_declarator> [ <raises_expr> ]
 **                                   |   <simple_declarator> { ","
 **                                                      <simple_declarator> }*
 **/
  final public void readonly_attr_declarator(TypeRef type) throws ParseException {
    AttributeDecl attr = null;
    String name = null;
    name = getIdentifier();
        attr = currentScope_.startAttribute(name);
        attr.setReadonly();
        attr.setType(type);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(attr.getGetExceptionList());
            createDeclaration(attr);
      break;
    default:
      jj_la1[92] = jj_gen;
           createDeclaration(attr);
      label_31:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[91] = jj_gen;
          break label_31;
        }
        jj_consume_token(COMMA);
        name = getIdentifier();
           attr = currentScope_.startAttribute(name);
           attr.setReadonly();
           attr.setType(type);
           createDeclaration(attr);
      }
    }
  }

/**
 **  (106) <attr_spec> ::= "attribute" <param_type_spec> <attr_declarator>
 **/
  final public void attr_spec() throws ParseException {
    TypeRef type;
    jj_consume_token(ATTRIBUTE);
    type = param_type_spec();
    attr_declarator(type);
  }

/**
 **  (107) <attr_declarator> ::= <simple_declarator> <attr_raises_expr>
 **                          |   <simple_declarator> { "," <simple_declarator> }*
 **/
  final public void attr_declarator(TypeRef type) throws ParseException {
    AttributeDecl attr = null;
    String name = null;
    name = getIdentifier();
        attr = currentScope_.startAttribute(name);
        attr.setType(type);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GETRAISES:
    case SETRAISES:
      attr_raises_expr(attr);
           createDeclaration(attr);
      break;
    default:
      jj_la1[94] = jj_gen;
           createDeclaration(attr);
      label_32:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[93] = jj_gen;
          break label_32;
        }
        jj_consume_token(COMMA);
        name = getIdentifier();
           attr = currentScope_.startAttribute(name);
           attr.setType(type);
           createDeclaration(attr);
      }
    }
  }

/**
 **  (108) <attr_raises_expr> ::= <get_excep_expr> [ <set_excep_expr> ]
 **                           |   <set_excep_expr>
 **/
  final public void attr_raises_expr(AttributeDecl attr) throws ParseException {
    ExceptionList getExcList = attr.getGetExceptionList();
    ExceptionList setExcList = attr.getSetExceptionList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GETRAISES:
      get_excep_expr(getExcList);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SETRAISES:
        set_excep_expr(setExcList);
        break;
      default:
        jj_la1[95] = jj_gen;
        ;
      }
      break;
    case SETRAISES:
      set_excep_expr(setExcList);
      break;
    default:
      jj_la1[96] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 **  (109) <get_excep_expr> ::= "getraises" <exception_list>
 **/
  final public void get_excep_expr(ExceptionList excList) throws ParseException {
    jj_consume_token(GETRAISES);
    exception_list(excList);
  }

/**
 **  (110) <set_excep_expr> ::= "setraises" <exception_list>
 **/
  final public void set_excep_expr(ExceptionList excList) throws ParseException {
    jj_consume_token(SETRAISES);
    exception_list(excList);
  }

/**
 **  (111) <exception_list> ::= "(" <scoped_name> { "," <scoped_name> }* ")"
 **/
  final public void exception_list(ExceptionList excList) throws ParseException {
  ExceptionRef exc;
    jj_consume_token(LPAREN);
    exc = exception_name();
        excList.add(exc);
    label_33:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[97] = jj_gen;
        break label_33;
      }
      jj_consume_token(COMMA);
      exc = exception_name();
        excList.add(exc);
    }
    jj_consume_token(RPAREN);
  }

// ==================================================================
/**
 ** OMG CCM IDL Grammar
 **/
// ==================================================================

/**
 **  (112) <component> ::= <component_dcl>
 **                    |   <component_forward_dcl>
 **/
  final public void component() throws ParseException {
    if (jj_2_21(4)) {
      component_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPONENT:
        component_forward_dcl();
        break;
      default:
        jj_la1[98] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (113) <component_forward_dcl> ::= "component" <identifier>
 **/
  final public void component_forward_dcl() throws ParseException {
    ComponentDecl component = null;
    String name;
    jj_consume_token(COMPONENT);
    name = getIdentifier();
        try
        {
            component = currentScope_.declareComponent(name);
            createForwardScope(component);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
  }

/**
 **  (114) <component_dcl> ::= <component_header> "{" <component_body> "}"
 **/
  final public void component_dcl() throws ParseException {
    ComponentDecl component = null;
    component = component_header();
       openScope(component);
    jj_consume_token(LBRACE);
    component_body();
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 **  (115) <component_header> ::= "component" <identifier>
 **                                    [ <component_inheritance_spec> ]
 **                                    [ <supported_interface_spec> ]
 **/
  final public ComponentDecl component_header() throws ParseException {
    String name;
    ComponentDecl component = null;
    jj_consume_token(COMPONENT);
    name = getIdentifier();
        try
        {
            component = currentScope_.declareComponent(name);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      component_inheritance_spec(component);
      break;
    default:
      jj_la1[99] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUPPORTS:
      supported_interface_spec_for_component(component);
      break;
    default:
      jj_la1[100] = jj_gen;
      ;
    }
        {if (true) return component;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (116) <supported_interface_spec> ::= "supports" <scoped_name>
 **                                                  { "," <scoped_name> }*
 **
 **  Note : for ComponentDecl
 **/
  final public void supported_interface_spec_for_component(ComponentDecl component) throws ParseException {
    InterfaceRef itf;
    jj_consume_token(SUPPORTS);
    itf = interface_name();
        component.addSupportedInterface(itf);
    label_34:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[101] = jj_gen;
        break label_34;
      }
      jj_consume_token(COMMA);
      itf = interface_name();
        component.addSupportedInterface(itf);
    }
  }

/**
 **  (116) <supported_interface_spec> ::= "supports" <scoped_name>
 **                                                  { "," <scoped_name> }*
 **
 **  Note : for HomeDecl
 **/
  final public void supported_interface_spec_for_home(HomeDecl home) throws ParseException {
    InterfaceRef itf;
    jj_consume_token(SUPPORTS);
    itf = interface_name();
        home.addSupportedInterface(itf);
    label_35:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[102] = jj_gen;
        break label_35;
      }
      jj_consume_token(COMMA);
      itf = interface_name();
        home.addSupportedInterface(itf);
    }
  }

/**
 **  (117) <component_inheritance_spec> ::= ":" <scoped_name>
 **/
  final public void component_inheritance_spec(ComponentDecl component) throws ParseException {
    ComponentRef base;
    jj_consume_token(COLON);
    base = component_name();
        component.setBaseComponent(base);
  }

/**
 **  (118) <component_body>  ::= <component_export>*
 **/
  final public void component_body() throws ParseException {
    label_36:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ATTRIBUTE:
      case READONLY:
      case PROVIDES:
      case USES:
      case EMITS:
      case PUBLISHES:
      case CONSUMES:
        ;
        break;
      default:
        jj_la1[103] = jj_gen;
        break label_36;
      }
      component_export();
    }
  }

/**
 **  (119) <component_export> ::= <provides_dcl> ";"
 **                           |   <uses_dcl> ";"
 **                           |   <emits_dcl> ";"
 **                           |   <publishes_dcl> ";"
 **                           |   <consumes_dcl> ";"
 **                           |   <attr_dcl> ";"
 **/
  final public void component_export() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROVIDES:
      provides_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case USES:
      uses_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case EMITS:
      emits_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case PUBLISHES:
      publishes_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case CONSUMES:
      consumes_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case ATTRIBUTE:
    case READONLY:
      attr_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[104] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 **  (120) <provides_dcl> ::= "provides" <interface_type> <identifier>
 **/
  final public void provides_dcl() throws ParseException {
    ProvidesDecl provides = null;
    InterfaceRef itf = null;
    String name = null;
    jj_consume_token(PROVIDES);
    itf = interface_type();
    name = getIdentifier();
        provides = currentScope_.startProvides(name);
        provides.setInterface(itf);
        createDeclaration(provides);
  }

/**
 **  (121) <interface_type> ::= <scoped_name> | "Object"
 **
 ** Warning: I don't understand why a provides/uses port can be Object!
 **          This is not compliant with the IFR 3.0 specification!
 **/
  final public InterfaceRef interface_type() throws ParseException {
    InterfaceRef itf;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      itf = interface_name();
        {if (true) return itf;}
      break;
    case OBJECT:
      jj_consume_token(OBJECT);
        {if (true) return null;} /* ARGH !!!!! */

      break;
    default:
      jj_la1[105] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 **  (122) <uses_dcl> ::= "uses" [ "multiple" ] <interface_type> <identifier>
 **/
  final public void uses_dcl() throws ParseException {
    UsesDecl uses = null;
    InterfaceRef itf;
    boolean multiple = false;
    String name=  null;
    jj_consume_token(USES);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MULTIPLE:
      jj_consume_token(MULTIPLE);
                        multiple = true;
      break;
    default:
      jj_la1[106] = jj_gen;
      ;
    }
    itf = interface_type();
    name = getIdentifier();
        uses = currentScope_.startUses(name);
        if (multiple) uses.setMultiple();
        uses.setInterface(itf);
        createDeclaration(uses);
  }

/**
 **  (123) <emits_dcl> ::= "emits" <scoped_name> <identifier>
 **/
  final public void emits_dcl() throws ParseException {
    EmitsDecl emits = null;
    EventRef event;
    String name = null;
    jj_consume_token(EMITS);
    event = event_name();
    name = getIdentifier();
        emits = currentScope_.startEmits(name);
        emits.setEvent(event);
        createDeclaration(emits);
  }

/**
 **  (124) <publishes_dcl> ::= "publishes" <scoped_name> <identifier>
 **/
  final public void publishes_dcl() throws ParseException {
    PublishesDecl publishes = null;
    EventRef event;
    String name = null;
    jj_consume_token(PUBLISHES);
    event = event_name();
    name = getIdentifier();
        publishes = currentScope_.startPublishes(name);
        publishes.setEvent(event);
        createDeclaration(publishes);
  }

/**
 **  (125) <consumes_dcl> ::= "consumes" <scoped_name> <identifier>
 **/
  final public void consumes_dcl() throws ParseException {
    ConsumesDecl consumes = null;
    EventRef event;
    String name = null;
    jj_consume_token(CONSUMES);
    event = event_name();
    name = getIdentifier();
        consumes = currentScope_.startConsumes(name);
        consumes.setEvent(event);
        createDeclaration(consumes);
  }

/**
 **  (126) <home_dcl> ::= <home_header> <home_body>
 **/
  final public void home_dcl() throws ParseException {
    HomeDecl home = null;
    home = home_header();
        openScope(home);
    home_body();
        closeScope();
  }

/**
 **  (127) <home_header> ::= "home" <identifier> 
 **                          [ <home_inheritance_spec> ]
 **                          [ <supported_interface_spec> ]
 **                          "manages" <scoped_name>
 **                          [ <primary_key_spec> ]
 **/
  final public HomeDecl home_header() throws ParseException {
    ComponentRef managed;
    HomeDecl home = null;
    String name = null;
    jj_consume_token(HOME);
    name = getIdentifier();
        home = currentScope_.startHome(name);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      home_inheritance_spec(home);
      break;
    default:
      jj_la1[107] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUPPORTS:
      supported_interface_spec_for_home(home);
      break;
    default:
      jj_la1[108] = jj_gen;
      ;
    }
    jj_consume_token(MANAGES);
    managed = component_name();
        home.setManagedComponent(managed);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIMARYKEY:
      primary_key_spec(home);
      break;
    default:
      jj_la1[109] = jj_gen;
      ;
    }
        {if (true) return home;}
    throw new Error("Missing return statement in function");
  }

/**
 **  (128) <home_inheritance_spec> ::= ":" <scoped_name>
 **/
  final public void home_inheritance_spec(HomeDecl home) throws ParseException {
    HomeRef base;
    jj_consume_token(COLON);
    base = home_name();
        home.setBaseHome(base);
  }

/**
 **  (129) <primary_key_spec> ::= "primarykey" <scoped_name>
 **/
  final public void primary_key_spec(HomeDecl home) throws ParseException {
    ValueRef primary;
    jj_consume_token(PRIMARYKEY);
    primary = value_name();
        home.setPrimaryKey(primary);
  }

/**
 **  (130) <home_body> ::= "{" <home_export>* "}"
 **/
  final public void home_body() throws ParseException {
    jj_consume_token(LBRACE);
    label_37:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FACTORY:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case FINDER:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[110] = jj_gen;
        break label_37;
      }
      home_export();
    }
    jj_consume_token(RBRACE);
  }

/**
 **  (131) <home_export> ::= <export>
 **                      |   <factory_dcl> ";"
 **                      |   <finder_dcl> ";"
 **/
  final public void home_export() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case ATTRIBUTE:
    case BOOLEAN:
    case CHAR:
    case CONST:
    case DOUBLE:
    case ENUM:
    case EXCEPTION:
    case FLOAT:
    case LONG:
    case NATIVE:
    case OBJECT:
    case OCTET:
    case ONEWAY:
    case READONLY:
    case SHORT:
    case STRING:
    case STRUCT:
    case TYPEDEF:
    case UNSIGNED:
    case UNION:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case TYPEID:
    case TYPEPREFIX:
    case IDENTIFIER:
    case DCOLON:
      export();
      break;
    case FACTORY:
      factory_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case FINDER:
      finder_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[111] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 **  (132) <factory_dcl> ::= "factory" <identifier> "(" [ <init_params_dcls> ] ")"
 **                                                 [ <raises_expr> ]
 **/
  final public void factory_dcl() throws ParseException {
    FactoryDecl factory = null;
    String name = null;
    jj_consume_token(FACTORY);
    name = getIdentifier();
        factory = currentScope_.startFactory(name);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      init_param_dcls(factory);
      break;
    default:
      jj_la1[112] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(factory.getExceptionList());
      break;
    default:
      jj_la1[113] = jj_gen;
      ;
    }
        createDeclaration(factory);
  }

/**
 **  (133) <finder_dcl> ::= "finder" <identifier> "(" [ <init_params_dcls> ] ")"
 **                                               [ <raises_expr> ]
 **/
  final public void finder_dcl() throws ParseException {
    FinderDecl finder = null;
    String name = null;
    jj_consume_token(FINDER);
    name = getIdentifier();
        finder = currentScope_.startFinder(name);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      init_param_dcls(finder);
      break;
    default:
      jj_la1[114] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(finder.getExceptionList());
      break;
    default:
      jj_la1[115] = jj_gen;
      ;
    }
        createDeclaration(finder);
  }

/**
 **  (134) <event> ::= <event_dcl>
 **                    | <event_abs_dcl>
 **                    | <event_forward_dcl>
 **/
  final public void event() throws ParseException {
    if (jj_2_22(4)) {
      event_dcl();
    } else if (jj_2_23(4)) {
      event_abs_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case EVENT:
        event_forward_dcl();
        break;
      default:
        jj_la1[116] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (135) <event_forward_dcl> ::= [ "abstract" ] "eventtype" <identifier>
 **/
  final public void event_forward_dcl() throws ParseException {
    EventDecl event = null;
    String name;
    boolean is_abstract = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
      jj_consume_token(ABSTRACT);
                 is_abstract = true;
      break;
    default:
      jj_la1[117] = jj_gen;
      ;
    }
    jj_consume_token(EVENT);
    name = getIdentifier();
        try
        {
            event = currentScope_.declareEvent(name);
            if (is_abstract)
                event.setAbstract();
            createForwardScope(event);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
  }

/**
 **  (136) <event_abs_dcl> ::= "abstract" "eventtype" <identifier>
 **                            [ <value_inheritance_spec> ]
 **                            "{" <export>* "}"
 **/
  final public void event_abs_dcl() throws ParseException {
    EventDecl event = null;
    String name;
    if (jj_2_24(4)) {
      jj_consume_token(ABSTRACT);
      jj_consume_token(EVENT);
      name = getIdentifier();
        try
        {
            event = currentScope_.declareEvent(name);
            event.setAbstract();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        openScope(event);
      jj_consume_token(LBRACE);
      label_38:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANY:
        case ATTRIBUTE:
        case BOOLEAN:
        case CHAR:
        case CONST:
        case DOUBLE:
        case ENUM:
        case EXCEPTION:
        case FLOAT:
        case LONG:
        case NATIVE:
        case OBJECT:
        case OCTET:
        case ONEWAY:
        case READONLY:
        case SHORT:
        case STRING:
        case STRUCT:
        case TYPEDEF:
        case UNSIGNED:
        case UNION:
        case VALUEBASE:
        case VOID:
        case WCHAR:
        case WSTRING:
        case TYPEID:
        case TYPEPREFIX:
        case IDENTIFIER:
        case DCOLON:
          ;
          break;
        default:
          jj_la1[118] = jj_gen;
          break label_38;
        }
        export();
      }
      jj_consume_token(RBRACE);
        closeScope();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
        jj_consume_token(EVENT);
        name = getIdentifier();
        try
        {
            event = currentScope_.declareEvent(name);
            event.setAbstract();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        value_inheritance_spec(event);
        openScope(event);
        jj_consume_token(LBRACE);
        label_39:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ANY:
          case ATTRIBUTE:
          case BOOLEAN:
          case CHAR:
          case CONST:
          case DOUBLE:
          case ENUM:
          case EXCEPTION:
          case FLOAT:
          case LONG:
          case NATIVE:
          case OBJECT:
          case OCTET:
          case ONEWAY:
          case READONLY:
          case SHORT:
          case STRING:
          case STRUCT:
          case TYPEDEF:
          case UNSIGNED:
          case UNION:
          case VALUEBASE:
          case VOID:
          case WCHAR:
          case WSTRING:
          case TYPEID:
          case TYPEPREFIX:
          case IDENTIFIER:
          case DCOLON:
            ;
            break;
          default:
            jj_la1[119] = jj_gen;
            break label_39;
          }
          export();
        }
        jj_consume_token(RBRACE);
        closeScope();
        break;
      default:
        jj_la1[120] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 **  (137) <event_dcl> ::= <event_header> "{" <value_element>* "}"
 **/
  final public void event_dcl() throws ParseException {
    EventDecl event = null;
    event = event_header();
        openScope(event);
    jj_consume_token(LBRACE);
    label_40:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FACTORY:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case PRIVATE:
      case PUBLIC:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[121] = jj_gen;
        break label_40;
      }
      value_element();
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 **  (138) <event_header> ::= [ "custom" ] "eventtype" <identifier>
 **                           [ <value_inheritance_spec> ]
 **/
  final public EventDecl event_header() throws ParseException {
    EventDecl event = null;
    boolean is_custom = false;
    String name;
    if (jj_2_25(4)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
        jj_consume_token(CUSTOM);
                            is_custom = true;
        break;
      default:
        jj_la1[122] = jj_gen;
        ;
      }
      jj_consume_token(EVENT);
      name = getIdentifier();
        try
        {
            event = currentScope_.declareEvent(name);
            if (is_custom)
                event.setCustom();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
      value_inheritance_spec(event);
        {if (true) return event;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
      case EVENT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CUSTOM:
          jj_consume_token(CUSTOM);
               is_custom = true;
          break;
        default:
          jj_la1[123] = jj_gen;
          ;
        }
        jj_consume_token(EVENT);
        name = getIdentifier();
        try
        {
            event = currentScope_.declareEvent(name);
            if (is_custom)
                event.setCustom();
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return event;}
        break;
      default:
        jj_la1[124] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  final private boolean jj_3R_116() {
    if (jj_scan_token(LOCAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_101() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_115() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_190() {
    if (jj_scan_token(VALUEBASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_101()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_70() {
    if (jj_scan_token(SUPPORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_131() {
    if (jj_3R_152()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_130() {
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_91() {
    if (jj_scan_token(TRUNCATABLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_24() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_109() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_129()) {
    jj_scanpos = xsp;
    if (jj_3R_130()) {
    jj_scanpos = xsp;
    if (jj_3R_131()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() {
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_91()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_92()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_69()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_70()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_112() {
    if (jj_scan_token(SUPPORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_177() {
    if (jj_3R_194()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_176() {
    if (jj_3R_193()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_175() {
    if (jj_3R_192()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_3R_63()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_174() {
    if (jj_3R_191()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_100() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_150() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_194() {
    if (jj_scan_token(FIXED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_100()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_96() {
    if (jj_3R_112()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_95() {
    if (jj_3R_111()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_104() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_87() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_104()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_3R_83()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_3R_190()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_95()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_96()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_23() {
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_207() {
    if (jj_3R_151()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_172() {
    if (jj_3R_189()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_22() {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_22()) {
    jj_scanpos = xsp;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_206() {
    if (jj_3R_193()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_171() {
    if (jj_3R_188()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_3R_192()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_3R_187()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_204() {
    if (jj_3R_149()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_169() {
    if (jj_3R_186()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_168() {
    if (jj_3R_185()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_198() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_204()) {
    jj_scanpos = xsp;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_167() {
    if (jj_3R_184()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3R_87()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_9() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_49()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_50()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_3R_183()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_16() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_149() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3R_166()) {
    jj_scanpos = xsp;
    if (jj_3R_167()) {
    jj_scanpos = xsp;
    if (jj_3R_168()) {
    jj_scanpos = xsp;
    if (jj_3R_169()) {
    jj_scanpos = xsp;
    if (jj_3R_170()) {
    jj_scanpos = xsp;
    if (jj_3R_171()) {
    jj_scanpos = xsp;
    if (jj_3R_172()) {
    jj_scanpos = xsp;
    if (jj_3R_173()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_3R_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_3R_88()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_66()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_43()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_3R_151()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_127() {
    if (jj_3R_150()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_126() {
    if (jj_3R_149()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_108() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) {
    jj_scanpos = xsp;
    if (jj_3R_128()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    if (jj_scan_token(UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SWITCH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_21() {
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_90() {
    if (jj_3R_109()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_50()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_89() {
    if (jj_3R_108()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_68()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_182() {
    if (jj_scan_token(VOID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_161() {
    if (jj_scan_token(NATIVE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_181() {
    if (jj_3R_198()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_165() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_3R_152()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_159() {
    if (jj_3R_178()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_scan_token(STRUCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_140() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_158()) {
    jj_scanpos = xsp;
    if (jj_3_14()) {
    jj_scanpos = xsp;
    if (jj_3_15()) {
    jj_scanpos = xsp;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) {
    jj_scanpos = xsp;
    if (jj_3R_161()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_158() {
    if (jj_scan_token(TYPEDEF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_189() {
    if (jj_scan_token(OBJECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_99() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_99()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_scan_token(ONEWAY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_144() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_164()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_165()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_scan_token(ANY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    if (jj_3R_82()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_5()) {
    jj_scanpos = xsp;
    if (jj_3_6()) {
    jj_scanpos = xsp;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_187() {
    if (jj_scan_token(OCTET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_scan_token(EXCEPTION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_186() {
    if (jj_scan_token(BOOLEAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_scan_token(CONSUMES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_180() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_3R_180()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_195() {
    if (jj_scan_token(DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_185() {
    if (jj_scan_token(WCHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_3R_179()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_13() {
    if (jj_scan_token(FIXED_PT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_143() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_132() {
    if (jj_scan_token(DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_156() {
    if (jj_scan_token(PUBLISHES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_110() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_132()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_195()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_184() {
    if (jj_scan_token(CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_201() {
    if (jj_scan_token(UNSIGNED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_94() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_75() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_94()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_94()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_scan_token(CONST)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_scan_token(EMITS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_20() {
    if (jj_scan_token(UNSIGNED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_19() {
    if (jj_scan_token(UNSIGNED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SHORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_200() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_203() {
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_179() {
    if (jj_scan_token(READONLY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_199() {
    if (jj_scan_token(SHORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_183() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_199()) {
    jj_scanpos = xsp;
    if (jj_3_18()) {
    jj_scanpos = xsp;
    if (jj_3R_200()) {
    jj_scanpos = xsp;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3_20()) {
    jj_scanpos = xsp;
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_scan_token(USES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_193() {
    if (jj_scan_token(WSTRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_203()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_146() {
    if (jj_scan_token(TYPEPREFIX)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_151() {
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_202() {
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_145() {
    if (jj_scan_token(TYPEID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_125() {
    if (jj_scan_token(FACTORY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_114() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_3R_146()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_98() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_114()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_192() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_202()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_122() {
    if (jj_3R_145()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_121() {
    if (jj_3R_144()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_73() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOUBLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_3R_143()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_119() {
    if (jj_3R_142()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_scan_token(DOUBLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_117() {
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_118() {
    if (jj_3R_141()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_153() {
    if (jj_scan_token(PROVIDES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) {
    jj_scanpos = xsp;
    if (jj_3R_119()) {
    jj_scanpos = xsp;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) {
    jj_scanpos = xsp;
    if (jj_3R_122()) {
    jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_3R_102()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_71()) {
    jj_scanpos = xsp;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_147() {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_78() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_25() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_59()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_50()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_124() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_147()) {
    jj_scanpos = xsp;
    if (jj_3R_148()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_139() {
    if (jj_3R_143()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_3R_157()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_191() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_86() {
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_137() {
    if (jj_3R_156()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_86()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_136() {
    if (jj_3R_155()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() {
    if (jj_3R_88()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_135() {
    if (jj_3R_154()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_113() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_134()) {
    jj_scanpos = xsp;
    if (jj_3R_135()) {
    jj_scanpos = xsp;
    if (jj_3R_136()) {
    jj_scanpos = xsp;
    if (jj_3R_137()) {
    jj_scanpos = xsp;
    if (jj_3R_138()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_134() {
    if (jj_3R_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_107() {
    if (jj_3R_125()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_88() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_79()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_85()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_3R_113()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    Token xsp;
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_74()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_77() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_97()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_197() {
    if (jj_scan_token(UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_152() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_196() {
    if (jj_scan_token(STRUCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_92() {
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_111() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_133()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_178() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_196()) {
    jj_scanpos = xsp;
    if (jj_3R_197()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_50()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[125];
  final private int[] jj_la1_0 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x0,0x340ca08,0x200c200,0x1000000,0x0,0x0,0x340ca08,0x400008,0x8,0x8,0x0,0x1e88e370,0x1e88e370,0x0,0x0,0x0,0x8,0x8,0x1e88e370,0x1e88e370,0x8,0xde89e370,0x800,0x800,0x800,0x0,0x0,0x0,0x0,0x0,0xde89e370,0xc0000000,0x100000,0x0,0x8840140,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000,0x20000,0x0,0x0,0x0,0x20000,0x0,0x2004000,0xc8c6150,0xc8c2150,0xc800150,0x40000,0x4000,0x0,0x0,0x882000,0x0,0x800000,0x0,0xc8c6150,0x804140,0x1080,0x1080,0x1080,0x0,0x0,0x0,0x0,0x0,0x20,0xc8c6150,0x10000000,0x0,0x400,0xc882150,0x0,0x20300000,0x20300000,0x0,0x0,0xc882150,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20,0x20,0x4000000,0x0,0x0,0x0,0x0,0x1e89e370,0x1e89e370,0x100000,0x0,0x100000,0x0,0x8,0x8,0x1e88e370,0x1e88e370,0x8,0xde89e370,0x800,0x800,0x800,};
  final private int[] jj_la1_2 = {0x0,0x0,0x0,0x0,0x40000,0x81785420,0x1420,0x0,0x300000,0x80400000,0x81785420,0x80000,0x80000,0x80000,0x0,0x33bc3a,0x33bc3a,0x0,0x0,0x0,0x4000,0x0,0x33bc3a,0x33bc3a,0x0,0x33bc3a,0x0,0x0,0x4000,0x200,0x0,0x0,0x0,0x40,0x33bc3a,0x0,0x0,0x0,0x30818,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x100,0x100,0x0,0x0,0x0,0x100,0x400,0x1020,0x3383c,0x3281c,0x12808,0x20014,0x1020,0x0,0x0,0x0,0x8,0x0,0x800,0x3383c,0x808,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x3383c,0x0,0x1,0x0,0x3a818,0x0,0x0,0x0,0x0,0x0,0x32818,0x1020,0x0,0x0,0x1,0x0,0x60000000,0x40000000,0x60000000,0x0,0x400000,0x0,0x40,0x0,0x0,0x1e800002,0x1e800002,0x0,0x0,0x0,0x40,0x0,0x33bc3a,0x33bc3a,0x0,0x1,0x0,0x1,0x1000000,0x0,0x33bc3a,0x33bc3a,0x0,0x33bc3a,0x0,0x0,0x1000000,};
  final private int[] jj_la1_3 = {0x100,0x100,0x8000000,0x8000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10000000,0x8040000,0x8040000,0x4000000,0x8000000,0x8000000,0x0,0x0,0x8040000,0x8040000,0x0,0x8040000,0x0,0x0,0x0,0x0,0x4000000,0x10000000,0x4000000,0x0,0x8040000,0x0,0x0,0x4000000,0x8040000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80c9f10,0x80c9f10,0x10,0x200,0x800,0x1000,0x0,0x0,0x8040000,0x8040000,0x0,0x0,0x0,0x4000000,0x40000,0x0,0x0,0x0,0x0,0x8040000,0x8040000,0x0,0x0,0x0,0x4000000,0x4000000,0x40000000,0x40000000,0x800000,0x0,0x8040000,0x0,0x0,0x0,0x8040000,0x4000000,0x0,0x0,0x4000000,0x4000000,0x8040000,0x0,0x8040100,0x4000000,0x0,0x4000000,0x0,0x0,0x0,0x4000000,0x0,0x10000000,0x0,0x4000000,0x4000000,0x0,0x0,0x8040000,0x8,0x10000000,0x0,0x2,0x8040004,0x8040004,0x0,0x0,0x0,0x0,0x0,0x0,0x8040000,0x8040000,0x0,0x8040000,0x0,0x0,0x0,};
  final private int[] jj_la1_4 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x2,0x4,0x18,0x18,0x60,0x60,0x380,0x380,0x460,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[25];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public Parser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 125; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 125; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 125; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 125; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 125; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 125; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[139];
    for (int i = 0; i < 139; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 125; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 139; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 25; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
