/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): Sylvain Leblanc, Romain Rouvoy________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * Implementation class of the HomeServant native interface.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class HomeServantImpl
       extends org.omg.CORBA.LocalObject
       implements HomeServant
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected SystemConfiguration the_home_configuration_;

    /**
     **
     **/
    protected SystemConfiguration the_component_configuration_;

    /**
     **
     **/
    protected SystemHomeFinder the_home_finder_;

    /**
     **
     **/
    protected PCA the_PCA_;

    /**
     **
     **/
    protected HomeExecutorBase the_home_executor_;

    /**
     **
     **/
    protected org.omg.Components.CCMHome the_home_ref_;

    /**
     **
     **/
    protected org.omg.Components.Cookie the_cookie_;

    /**
     **
     **/
    protected org.objectweb.ccm.Deployment.ContainerBase the_container_base_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    HomeServantImpl()
    {
        the_home_configuration_ = null;
        the_component_configuration_ = null;
        the_home_finder_ = null;
        the_PCA_ = null;
        the_home_executor_ = null;
        the_home_ref_ = null;
        the_cookie_ = null;
        the_container_base_ = null;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

   // ==================================================================
    //
    // Public methods for the HomeServant interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_home_configuration:1.0
    //
    /**
     **
     **/
    public SystemConfiguration
    the_home_configuration()
    {
        return the_home_configuration_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_home_configuration:1.0
    //
    /**
     **
     **/
    public SystemConfiguration
    the_component_configuration()
    {
        return the_component_configuration_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_home_finder:1.0
    //
    /**
     **
     **/
    public SystemHomeFinder
    the_home_finder()
    {
        return the_home_finder_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_PCA:1.0
    //
    /**
     **
     **/
    public PCA
    the_PCA()
    {
        return the_PCA_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_home_executor:1.0
    //
    /**
     **
     **/
    public HomeExecutorBase
    the_home_executor()
    {
        return the_home_executor_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_home_ref:1.0
    //
    /**
     **
     **/
    public org.omg.Components.CCMHome
    the_home_ref()
    {
        return the_home_ref_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/HomeServant/the_registration_info:1.0
    //
    /**
     **
     **/
    public org.omg.Components.Cookie
    the_registration_info()
    {
        return the_cookie_;
    }

    /**
     ** 
     **/
    public void 
    the_container_base(org.objectweb.ccm.Deployment.ContainerBase container)
    {
        the_container_base_ = container;
    }

    /**
     **
     **/
    public org.objectweb.ccm.Deployment.ContainerBase
    the_container_base()
    {
        return the_container_base_;
    }

     // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     **
     **/
    public void
    the_home_configuration(SystemConfiguration config)
    {
        the_home_configuration_ = config;
    }

    /**
     **
     **/
    public void
    the_component_configuration(SystemConfiguration config)
    {
        the_component_configuration_ = config;
    }

    /**
     **
     **/
    public void
    the_home_finder(SystemHomeFinder finder)
    {
        the_home_finder_ = finder;
    }

    /**
     **
     **/
    public void
    the_PCA(PCA pca)
    {
        the_PCA_ = pca;
    }

    /**
     **
     **/
    public void
    the_home_executor(HomeExecutorBase home)
    {
        the_home_executor_ = home;
    }

    /**
     **
     **/
    public void
    the_home_ref(org.omg.Components.CCMHome ref)
    {
        the_home_ref_ = ref;
    }

    /**
     **
     **/
    public void
    the_registration_info(org.omg.Components.Cookie cookie)
    {
        the_cookie_ = cookie;
    }

    /**
     ** Remove the CCMHome 
     **/
    public void
    remove()
        throws org.omg.Components.RemoveFailure
    {
        the_container_base().get_rootPCA().deactivate_home(this);
        the_container_base().remove_home(the_home_ref());
    }
}
