/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class OperationCallContext
       extends org.omg.CORBA.LocalObject
       implements CallContext
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected java.lang.String the_operation_name_;

    /**
     **
     **/
    protected CallContext the_parent_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    OperationCallContext(CallContext parent,
                         java.lang.String op_name)
    {
        the_parent_ = parent;
        the_operation_name_ = op_name;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the CallContext interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallContext/get_call_coordinator:1.0
    //
    /**
     **
     **/
    public CallCoordinator
    get_call_coordinator(java.lang.String op_name)
    {
        return the_parent_.get_call_coordinator(op_name);
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallContext/uid:1.0
    //
    /**
     **
     **/
    public java.lang.String
    uid()
    {
        return the_parent_.uid();
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallContext/operation_name:1.0
    //
    /**
     **
     **/
    public java.lang.String
    operation_name()
    {
        return the_operation_name_;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallContext/duplicate:1.0
    //
    /**
     **
     **/
    public CallContext
    duplicate(java.lang.String op_name)
    {
        //
        //  This kind of context can't be more duplicated.
        //
        return null;
    }
}
