/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers.Plugins;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class EmptyConfiguration
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.ccm.Containers.SystemConfiguration
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    EmptyConfiguration()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the SystemConfiguration interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Container/SystemConfiguration/create_call_coordinator:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.CallCoordinator
    create_call_coordinator(java.lang.String uid,
                            java.lang.String op_name,
                            org.objectweb.ccm.Containers.SystemHomeFinder finder)
    {
        try
        {
            org.objectweb.ccm.Containers.SystemHome home = null;
            home = finder.find_system_home("EmptyCoordinatorHome");
            return (org.objectweb.ccm.Containers.CallCoordinator)home.create_component(null);
        }
        catch(org.objectweb.ccm.Containers.HomeNotFound ex)
        {
            //  Should never happen !!!
        }
        catch(org.objectweb.ccm.Containers.CreationFailed ex)
        {
            //  Should never happen !!!
        }
        return null;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Container/SystemConfiguration/create_call_controllers:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.CallController[]
    create_call_controllers(java.lang.String uid,
                            java.lang.String op_name,
                            org.objectweb.ccm.Containers.SystemHomeFinder finder)
    {
        try
        {
            org.objectweb.ccm.Containers.SystemHome home = null;
            org.objectweb.ccm.Containers.CallController[] ctrls =
                new org.objectweb.ccm.Containers.CallController[1];
            home = finder.find_system_home("EmptyControllerHome");
            ctrls[0] = (org.objectweb.ccm.Containers.CallController)home.create_component(null);
            return ctrls;
        }
        catch(org.objectweb.ccm.Containers.HomeNotFound ex)
        {
            //  Should never happen !!!
        }
        catch(org.objectweb.ccm.Containers.CreationFailed ex)
        {
            //  Should never happen !!!
        }
        return null;
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Container/SystemConfiguration/create_activation_coordinator:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.ActivationCoordinator
    create_activation_coordinator(java.lang.String uid,
                                  org.objectweb.ccm.Containers.SystemHomeFinder finder)
    {
        // should never be called !!!
        throw new java.lang.Error("Can\'t use an empty coordinator for activation");
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Container/SystemConfiguration/create_activation_controllers:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.ActivationController[]
    create_activation_controllers(java.lang.String uid,
                                  org.objectweb.ccm.Containers.SystemHomeFinder finder)
    {
        // should never be called !!!
        throw new java.lang.Error("Can\'t use an empty controller for activation");
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Container/SystemConfiguration/create_PCAPolicies:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.PCAPolicy[]
    create_PCAPolicies(java.lang.String uid,
                       org.objectweb.ccm.Containers.SystemHomeFinder finder)
    {
        return new org.objectweb.ccm.Containers.PCAPolicy[0];
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Container/SystemConfiguration/set_parent_configuration:1.0
    //
    /**
     **
     **/
    public void
    set_parent_configuration(org.objectweb.ccm.Containers.SystemConfiguration config)
    {
    }

    // ==================================================================
    //
    // Public methods for the SystemComponent interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the Configuration interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Configuration/configure:1.0
    //
    /**
     **
     **/
    public void
    configure(org.objectweb.ccm.Containers.PropertySet config)
    throws org.objectweb.ccm.Containers.ConfigurationFailed
    {
        //
        // TODO : do nothing ???
        //
        throw new org.objectweb.ccm.Containers.ConfigurationFailed("not implemented !");
    }
}
