/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers.Plugins;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class ListCoordinator
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.ccm.Containers.CallCoordinator,
                  org.objectweb.ccm.Containers.ActivationCoordinator
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected org.objectweb.ccm.util.Vector controllers_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    ListCoordinator()
    {
        controllers_ = new org.objectweb.ccm.util.Vector();
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the CallCoordinator interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallCoordinator/add:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.CallCoordinator
    add(org.objectweb.ccm.Containers.CallController ctrl)
    {
        controllers_.add(ctrl);
        return this;
    }

    // ==================================================================
    //
    // Public methods for the ActivationCoordinator interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/ActivationCoordinator/add:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.ActivationCoordinator
    add(org.objectweb.ccm.Containers.ActivationController ctrl)
    {
        controllers_.add(ctrl);
        return this;
    }

    // ==================================================================
    //
    // Public methods for the CallProtocol interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallProtocol/preinvoke:1.0
    //
    /**
     **
     **/
    public void
    preinvoke(org.objectweb.ccm.Containers.CallContext ctx)
    {
        org.objectweb.ccm.Containers.CallController[] ctrls = null;
        ctrls = (org.objectweb.ccm.Containers.CallController[])
            controllers_.toArray(new org.objectweb.ccm.Containers.CallController[0]);

        for (int i=0;i<ctrls.length;i++)
            ctrls[i].preinvoke(ctx);
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallProtocol/postinvoke:1.0
    //
    /**
     **
     **/
    public void
    postinvoke(org.objectweb.ccm.Containers.CallContext ctx)
    {
        org.objectweb.ccm.Containers.CallController[] ctrls = null;
        ctrls = (org.objectweb.ccm.Containers.CallController[])
            controllers_.toArray(new org.objectweb.ccm.Containers.CallController[0]);

        for (int i=0;i<ctrls.length;i++)
            ctrls[i].postinvoke(ctx);
    }

    // ==================================================================
    //
    // Public methods for the ActivationProtocol interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/ActivationProtocol/preinvoke:1.0
    //
    /**
     **
     **/
    public void
        preinvoke(org.objectweb.ccm.Containers.ActivationContext ctx)
    {
        org.objectweb.ccm.Containers.ActivationController[] ctrls = null;
        ctrls = (org.objectweb.ccm.Containers.ActivationController[])
            controllers_.toArray(new org.objectweb.ccm.Containers.ActivationController[0]);

        for (int i=0;i<ctrls.length;i++)
            ctrls[i].preinvoke(ctx);
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/ActivationProtocol/postinvoke:1.0
    //
    /**
     **
     **/
    public void
    postinvoke(org.objectweb.ccm.Containers.ActivationContext ctx)
    {
        org.objectweb.ccm.Containers.ActivationController[] ctrls = null;
        ctrls = (org.objectweb.ccm.Containers.ActivationController[])
            controllers_.toArray(new org.objectweb.ccm.Containers.ActivationController[0]);

        for (int i=0;i<ctrls.length;i++)
            ctrls[i].postinvoke(ctx);
    }

    // ==================================================================
    //
    // Public methods for the SystemComponent interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the Configuration interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Configuration/configure:1.0
    //
    /**
     **
     **/
    public void
    configure(org.objectweb.ccm.Containers.PropertySet config)
    throws org.objectweb.ccm.Containers.ConfigurationFailed
    {
    }
}
