/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers.Plugins;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class TraceController
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.ccm.Containers.CallController
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    private java.io.PrintStream trace_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    TraceController()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     **
     **/
    protected static java.lang.String
    monthToString(int month)
    {
        switch(month)
        {
            case java.util.Calendar.JANUARY :
                return "January";
            case java.util.Calendar.FEBRUARY :
                return "February";
            case java.util.Calendar.MARCH :
                return "March";
            case java.util.Calendar.APRIL :
                return "April";
            case java.util.Calendar.MAY :
                return "May";
            case java.util.Calendar.JUNE :
                return "June";
            case java.util.Calendar.JULY :
                return "July";
            case java.util.Calendar.AUGUST :
                return "August";
            case java.util.Calendar.SEPTEMBER :
                return "September";
            case java.util.Calendar.OCTOBER :
                return "October";
            case java.util.Calendar.NOVEMBER :
                return "November";
            case java.util.Calendar.DECEMBER :
                return "December";
            default :
                return "";
        }
    }

    /**
     **
     **/
    protected java.lang.String
    getTime()
    {
        java.util.GregorianCalendar cal = new java.util.GregorianCalendar();
        java.lang.String res = "";
        res = res + java.lang.Integer.toString(cal.get(java.util.GregorianCalendar.HOUR_OF_DAY)) + ":";
        res = res + java.lang.Integer.toString(cal.get(java.util.GregorianCalendar.MINUTE)) + " on ";
        int month = cal.get(java.util.GregorianCalendar.MONTH);
        res = res + monthToString(month) + " ";
        res = res + java.lang.Integer.toString(cal.get(java.util.GregorianCalendar.DAY_OF_MONTH)) + ", ";
        res = res + java.lang.Integer.toString(cal.get(java.util.GregorianCalendar.YEAR));
        return res;
    }

    // ==================================================================
    //
    // Public methods for the CallController interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the CallProtocol interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallProtocol/preinvoke:1.0
    //
    /**
     **
     **/
    public void
    preinvoke(org.objectweb.ccm.Containers.CallContext ctx)
    {
        java.lang.String msg =
            "### preinvoke was called at "+getTime()+"\n"+
            "    on interface : \""+ctx.uid()+"\"\n"+
            "    on operation : \""+ctx.operation_name()+"\"\n";

        trace_.print(msg);
    }

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/CallProtocol/postinvoke:1.0
    //
    /**
     **
     **/
    public void
    postinvoke(org.objectweb.ccm.Containers.CallContext ctx)
    {
        java.lang.String msg =
            "### postinvoke was called at "+getTime()+"\n"+
            "    on interface  : \""+ctx.uid()+"\"\n"+
            "    on operation  : \""+ctx.operation_name()+"\"\n";

        trace_.print(msg);
    }

    // ==================================================================
    //
    // Public methods for the SystemComponent interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the Configuration interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Configuration/configure:1.0
    //
    /**
     **
     **/
    public void
    configure(org.objectweb.ccm.Containers.PropertySet config)
    throws org.objectweb.ccm.Containers.ConfigurationFailed
    {
        try
        {
            java.lang.String filename = config.get_as_string("filename").value();
            trace_ = new java.io.PrintStream(new java.io.FileOutputStream(filename));
        }
        catch(org.objectweb.ccm.Containers.UnknownProperty ex)
        {
            java.lang.String msg =
                "exception in class org.objectweb.ccm.Containers.Plugins.TraceController\n"+
                "   operation : configure\n"+
                "   message : "+ex.getMessage();
            throw new org.objectweb.ccm.Containers.ConfigurationFailed(msg);
        }
        catch(org.objectweb.ccm.Containers.BadPropertyKind ex)
        {
            java.lang.String msg =
                "exception in class org.objectweb.ccm.Containers.Plugins.TraceController\n"+
                "   operation : configure\n"+
                "   message : "+ex.getMessage();
            throw new org.objectweb.ccm.Containers.ConfigurationFailed(msg);
        }
        catch(java.io.FileNotFoundException ex)
        {
            java.lang.String msg =
                "exception in class org.objectweb.ccm.Containers.Plugins.TraceController\n"+
                "   operation : configure\n"+
                "   message : "+ex.getMessage();
            throw new org.objectweb.ccm.Containers.ConfigurationFailed(msg);
        }
    }
}
