/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Containers.Plugins;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class TraceControllerHome
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.ccm.Containers.SystemHome
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected org.objectweb.ccm.util.Table singletons_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    protected
    TraceControllerHome()
    {
        singletons_ = new org.objectweb.ccm.util.Table();
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the SystemHome interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/SystemHome/create:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.SystemComponent
    create_component(org.objectweb.ccm.Containers.PropertySet config)
    throws org.objectweb.ccm.Containers.CreationFailed
    {
        boolean is_singleton = true;
        java.lang.String name = null;
        try
        {
            name = config.get_as_string("singleton").value();
        }
        catch(org.objectweb.ccm.Containers.UnknownProperty ex)
        {
            java.lang.String msg =
                "exception in class org.objectweb.ccm.Containers.Plugins.TraceControllerHome\n"+
                "   operation : configure\n"+
                "   message : "+ex.getMessage();
            // throw new org.objectweb.ccm.Containers.CreationFailed(msg);
            is_singleton = false;
        }
        catch(org.objectweb.ccm.Containers.BadPropertyKind ex)
        {
            java.lang.String msg =
                "exception in class org.objectweb.ccm.Containers.Plugins.TraceControllerHome\n"+
                "   operation : configure\n"+
                "   message : "+ex.getMessage();
            // throw new org.objectweb.ccm.Containers.CreationFailed(msg);
            is_singleton = false;
        }

        if (!is_singleton)
            return new TraceController();

        TraceController trace = (TraceController)singletons_.get(name);
        if (trace!=null)
            return trace;

        trace = new TraceController();
        singletons_.put(name, trace);
        return trace;
    }

    // ==================================================================
    //
    // Public methods for the SystemComponent interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the Configuration interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Configuration/configure:1.0
    //
    /**
     **
     **/
    public void
    configure(org.objectweb.ccm.Containers.PropertySet config)
    throws org.objectweb.ccm.Containers.ConfigurationFailed
    {
    }

    // ==================================================================
    //
    // Public static methods.
    //
    // ==================================================================

    /**
     **  Callback - no parameters
     **/
    public static TraceControllerHome
    create()
    {
        return new TraceControllerHome();
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
}
