/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.Deployment;

/**
 * ?????????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class SystemHomeManagerImpl
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.ccm.Containers.SystemHomeManager
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     **
     **/
    protected org.objectweb.ccm.util.Table system_homes_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **
     **/
    public
    SystemHomeManagerImpl()
    {
        system_homes_ = new org.objectweb.ccm.util.Table();
    }

    // ==================================================================
    //
    // Methods for the OpenCCM::Containers::SystemHomeManager interface.
    //
    // ==================================================================

    /**
     **
     **/
    public org.objectweb.ccm.Containers.SystemHome
    create_system_home(java.lang.String implUUID,
                       java.lang.String alias,
                       java.lang.String entrypt)
    throws org.objectweb.ccm.Containers.CreationFailed
    {
        try
        {
            TheComponentInstallation.getComponentInstallation().get_implementation(implUUID);

	    // Call the static 'create' method of the 'clazz' class.
            java.lang.Object obj = 
                TheURLClassLoader.getURLClassLoader().callStaticClassMethod(entrypt, new Object[0]);

	    // Check that the result is a SystemHome.
            org.objectweb.ccm.Containers.SystemHome home = (org.objectweb.ccm.Containers.SystemHome)obj;
            system_homes_.put(alias, home);
            return home;
        }
        catch(org.omg.Components.Deployment.UnknownImplId ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
        }
        catch(org.omg.Components.Deployment.InstallationFailure ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
        }
        catch(java.lang.ClassNotFoundException ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
        }
        catch(java.lang.NoSuchMethodException ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
        }
        catch(java.lang.reflect.InvocationTargetException ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
        }
        catch(java.lang.IllegalAccessException ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
        }
	catch(java.lang.ClassCastException ex)
        {
            throw new org.objectweb.ccm.Containers.CreationFailed();
	}
    }

    /**
     **
     **/
    public org.objectweb.ccm.Containers.SystemHome
    find_system_home(java.lang.String alias)
    throws org.objectweb.ccm.Containers.HomeNotFound
    {
        java.lang.Object home = system_homes_.get(alias);
        if (home==null)
            throw new org.objectweb.ccm.Containers.HomeNotFound();

        return (org.objectweb.ccm.Containers.SystemHome)home;
    }
} 
