/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.ccm.plugins.transaction.controller;

/**
 * This interface ??????.
 *
 * @author <a=href="Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class TransactionControllerHome
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.ccm.Containers.SystemHome
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    protected
    TransactionControllerHome()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the SystemHome interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/SystemHome/create:1.0
    //
    /**
     **
     **/
    public org.objectweb.ccm.Containers.SystemComponent
    create_component(org.objectweb.ccm.Containers.PropertySet config)
    {
				org.objectweb.ccm.Containers.StringProperty _property;
				try
						{
								_property = config.get_as_string("OTS_Policy");
						} catch(org.objectweb.ccm.Containers.UnknownProperty ex) {
								return null;
						} catch(org.objectweb.ccm.Containers.BadPropertyKind ex) {
								return null;
						}

      if ( _property.value().equals("NOT_SUPPORTED"))
					return new NotSupportedController();
      else if ( _property.value().equals("REQUIRED"))
					return new RequiredController();
      else if ( _property.value().equals("SUPPORTS"))
					return new SupportsController();
      else if ( _property.value().equals("REQUIRES_NEW"))
					return new RequiresNewController();
      else if ( _property.value().equals("MANDATORY"))
					return new MandatoryController();
      else if ( _property.value().equals("NEVER"))
					return new NeverController();
      else
					return null;
    }

    // ==================================================================
    //
    // Public methods for the SystemComponent interface.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for the Configuration interface.
    //
    // ==================================================================

    //
    //  IDL:goal.lifl.fr/OpenCCM/Containers/Configuration/configure:1.0
    //
    /**
     **
     **/
    public void
    configure(org.objectweb.ccm.Containers.PropertySet config)
    throws org.objectweb.ccm.Containers.ConfigurationFailed
    {
    }

    // ==================================================================
    //
    // Public static methods.
    //
    // ==================================================================

    /**
     **  Callback - no parameters
     **/
    public static TransactionControllerHome
    create()
    {
        return new TransactionControllerHome();
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
}

