/* Generated By:JavaCC: Do not edit this line. Parser.java */
package org.objectweb.corba.parser.lib;

import org.objectweb.corba.ast.api.*;

/**
 * Lexical and syntaxic parser for analysing OMG IDL / PSDL / CIDL files
 * and feeding the OMG IDL / PSDL / CIDL Abstract Syntax Tree.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 *
 * @date 2001
 */

public class Parser
       extends org.omg.CORBA.LocalObject
       implements org.objectweb.corba.parser.api.Parser, ParserConstants {
    // ==================================================================
    //
    // Internal State.
    //
    // ==================================================================

    /** The used OMG IDL / PSDL / CIDL Abstract Syntax Tree. */
    private AST ast_;

    /** The used ErrorManager. */
    private ErrorManager error_;

    /** The global scope. */
    private Scope globalScope_;

    /** The current scope. */
    private Scope currentScope_;

    /** To store Scope objects for recursive calls in the grammar. */
    private java.util.Stack scopes_;

    /** For forward declarations checking. */
    private java.util.Vector forward_scopes_;

    /** To store FileScope objects when an included file is detected. */
    private java.util.Stack fileScopes_;

    /** For keyword collisions checking. */
    private java.util.Hashtable keywords_;

    /** The current prefix. */
    private String currentPrefix_;

    /** To store prefix when an included file is detected. */
    private java.util.Stack prefix_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     * Constructor with used FileInputStream, AST and ErrorManager objects.
     *
     * @param str The file to parse.
     * @param ast The Abtract Syntax Tree.
     * @param error The ErrorManager to display errors and warnings.
     */
    public
    Parser(java.io.FileInputStream str,
           AST ast,
           ErrorManager error)
    {
        // Init the generated JavaCC parser with the file stream.
        //
        this(str);

        // Create the generated JavaCC Token Manager.
        //
        // the jj_input_stream variable denotes the input stream of the parser.
        // Warning: it's generated by JavaCC.
        //
        token_source = new ParserTokenManager(jj_input_stream, this);

        // Store the used OMG IDL / PSDL / CIDL Abstract Syntax Tree.
        //
        ast_ = ast;

        // Store the used ErrorManager.
        //
        error_ = error;

        // Create the global scope in the AST.
        //
        FileScope fs = ast.startFileScope("");
        globalScope_ = fs;
        currentScope_ = fs;

        // Init scope stacks.
        //
        scopes_ = new java.util.Stack();
        forward_scopes_ = new java.util.Vector();
        fileScopes_ = new java.util.Stack();

        // Init the keyword collisions checking table and
        // add all IDL/PSDL/CIDL keywords in this table.         
        //
        keywords_ = new java.util.Hashtable();
        for (int i=ParserConstants.ABSTRACT;i<=ParserConstants.STOREDON;i++)
        {
            keywords_.put(ParserConstants.tokenImage[i].toUpperCase(),
                          ParserConstants.tokenImage[i]);
        }

        // Init the current prefix and the prefix stack.
        //
        currentPrefix_ = null;
        prefix_ = new java.util.Stack();
    }

    // ==================================================================
    //
    // Methods for the org::objectweb::corba::parser::api interface.
    //
    // ==================================================================

    /**
     * Parse with the OMG IDL syntax.
     *
     * @return The new created FileScope.
     */
    public FileScope
    parseIDL()
    {
      try {
        // Start the <specification> E-BNF rule.
        //
        specification();

      // Catch any parsing exception.
      //
      } catch (ParseException e) {
        try {
          error_manager(e);
        } catch (ParseException x) {
          error("Unexcepted parse exception in parseIDL()!");
        }
     }

      // Check if all forward declarations are completed.
      //
      checkForwardScopes();

      // Return the global file scope.
      //
      return (FileScope)globalScope_;
    }

    /**
     * Parse with the OMG PSDL syntax.
     *
     * @return The new created FileScope.
     */
    public FileScope
    parsePSDL()
    {
      try {
        // Start the <psdl_specification> E-BNF rule.
        //
        psdl_specification();

      // Catch any parsing exception.
      //
      } catch (ParseException e) {
        try {
          error_manager(e);
        } catch (ParseException x) {
          error("Unexcepted parse exception in parsePSDL()!");
        }
      }

      // Check if all forward declarations are completed.
      //
      checkForwardScopes();

      // Return the global file scope.
      //
      return (FileScope)globalScope_;
    }

    /**
     * Parse with the OMG CIDL syntax.
     *
     * @return The new created FileScope.
     */
    public FileScope
    parseCIDL()
    {
        try {
            // Start the <cidl_specification> E-BNF rule.
            //
            cidl_specification();
        } catch (ParseException e) {
            // Catch any parsing exception.
            try {
                error_manager(e);
            } catch (ParseException x) {
                error("Unexcepted parse exception in parseCIDL()!");
            }
        }

        // Check if all forward declarations are completed.
        //
        checkForwardScopes();

        // Return the global file scope.
        //
        return (FileScope)globalScope_;
    }

    // ==================================================================
    //
    // Public methods in relation with the ErrorManager.
    //
    // ==================================================================

    /**
     * To set the ErrorManager that will be used by the parser for error
     * and warning reporting.
     */
    public final void
    setErrorManager(ErrorManager error)
    {
        error_ = error;
    }

    /**
     * To obtain the ErrorManager.
     */
    public final ErrorManager
    getErrorManager()
    {
        return error_;
    }

    /**
     *    Change the source filename.
     */
    public final void
    setFileName(String fileName)
    {
       error_.setFileName(fileName);
    }

    // ==================================================================
    //
    // Public methods in relation with Scopes.
    //
    // ==================================================================

    /**
     * Push the current scope on the stack and set scope as the current scope.
     *   
     * @param scope the new current scope.
     */
    public void
    pushScope(Scope scope)
    {
        scopes_.push(currentScope_);
        currentScope_ = scope;
        prefix_.push(currentPrefix_);
        //currentPrefix_ = null;
    }

    /**
     * Pop the first scope from the stack and set it as the current scope.
     */
    public void
    popScope()
    {
        currentScope_ = (Scope)scopes_.pop();
        currentPrefix_ = (String)prefix_.pop();
    }

    // ==================================================================
    //
    // Public methods in relation with the macros.
    //
    // ==================================================================

    /**
     * This method is called by the Token Manager when he encounters
     * the include begin mark.
     */
    public void
    pushFileScope(String fileName)
    {
        FileScope fs = currentScope_.startFileScope(fileName);
        ((FileScope)globalScope_).addIncluded(fs);

        fileScopes_.push(globalScope_);
        globalScope_ = fs;

        pushScope(fs);
    }

    /**
     * This method is called by the Token Manager when he encounters
     * the include end mark.
     */
    public void
    popFileScope()
    {
        globalScope_ = (Scope)fileScopes_.pop();
        popScope();
    }

    /**
     * To set the prefix for incoming declarations.
     * Note: used by pragma prefix macro.
     */
    public void
    setPrefix(String prefix)
    {
System.err.println("New prefix : "+prefix);
        currentPrefix_ = prefix;
    }

    /**
     * To set the prefix for the specified declaration.
     * Note: used by typePrefix rule.
     */
    public void
    setPrefix(Declaration decl, String prefix)
    {
        if (decl != null)
            decl.setPrefix(prefix);
    }

    /**
     * To set the Id of a declaration.
     * Note: used by pragma id macro.
     *
     * @param name the name of a declaration.
     */
    public void
    setId(String name, String id)
    {
        Declaration decl = findDeclaration(name);
        if (decl != null)
            decl.setId(id);
    }

    /**
     * To set the Id of a declaration.
     * Note: used by typeId rule.
     */
    public void
    setId(Declaration decl, String id)
    {
        if (decl != null)
            decl.setId(id);
    }

    /**
     * To set the version of a declaration.
     * Note: used by pragma version macro.
     *
     * @param name the name of a declaration.
     */
    public void
    setVersion(String name, String version)
    {
        Declaration decl = findDeclaration(name);
        if (decl != null)
            decl.setVersion(version);
    }

    // ==================================================================
    //
    // Internal methods in relation with the keywords.
    //
    // ==================================================================

    /**
     * To test if an identifier collapses with a keyword.
     */
    private final String
    collapse(String id)
    {
       String newid;
       // escape identifiers => turns off keyword checking
       if (id.charAt(0)=='_') return id.substring(1);
       // test if id is in the keyword hashtable

// COULD BE SIMPLIFIED BY REMOVING the "" when the keywords table is built.

       newid="\""+id+"\"";
       newid=newid.toUpperCase();
       if (keywords_.containsKey(newid))
       {
          error("identifier "+getToken(0)+" collapses with keyword "+(String)keywords_.get(newid));
       }
       return id;
    }

    // ==================================================================
    //
    // Internal methods in relation with the Error Manager.
    //
    // ==================================================================

    /**
     * Display a warning.
     */
    private final void
    warning(String message)
    {
       error_.warning(token.beginLine,message);
    }

    /**
     * Display a warning with a line number.
     */
    private final void
    warning(int line,String message)
    {
       error_.warning(line,message);
    }

    /**
     * Display an warning for a Declaration.
     */
    private final void
    warning(Declaration decl, String message)
    {
        error_.warning(token.beginLine,
                       decl.getAbsoluteName() + ' ' + message);
    }

    /**
     * Display an error.
     */
    private final void
    error(String message)
    {
        error_.error(token.beginLine, message);
    }

    /**
     * Display an error for a Declaration.
     */
    private final void
    error(Declaration decl, String message)
    {
        error_.error(token.beginLine,
                     decl.getAbsoluteName() + ' ' + message);
    }

    /**
     * Display an error for a SystemException.
     */
    private final void
    error(org.omg.CORBA.SystemException sysExc)
    {
        error_.error(token.beginLine, sysExc);
    }

    // ==================================================================
    //
    // Internal methods in relation with the filter class.
    //
    // ==================================================================

    /**
     * Find a declaration in the current scope.
     *
     * If the declaration if not found, the error message
     * "must be declared" is printed.
     *
     * @param name The name of the declaration.
     *
     * @return The found declaration or null.
     */
    private final Declaration
    findDeclaration(String name)
    {
        return findDeclaration(currentScope_, name);
    }

    /**
     * Find a declaration in a scope.
     *
     * If the declaration if not found, the error message
     * "must be declared" is printed.
     *
     * @param scope The scope in which the declaration is searched.
     * @param name The name of the declaration.
     *
     * @return The found declaration or null.
     */
    private final Declaration
    findDeclaration(Scope scope, String name)
    {
       Declaration decl = scope.find(name);

        if (decl == null) {
           if(scope == currentScope_)
               error(name + " must be declared");
           else
               error(scope.getAbsoluteName() + "::" + name + " must be declared");
        }

        return decl;
    }

    /**
     * Create a Declaration.
     */
    private final void
    createDeclaration(Declaration decl)
    {
        try
        {
            decl.setPrefix(currentPrefix_);
            decl.create();
        } catch(org.omg.CORBA.SystemException exc1) {
            error_.error(token.beginLine, exc1, decl);

        } catch(ASTError exc2) {
            error(exc2.getMessage());

/*
        } catch(Error exc2) {
            error_.error(token.beginLine, exc2.getMessage());
*/

        } catch(java.lang.NullPointerException exc) {
            if(((ForwardScope)decl.getParent()).isCompleted())
                error(decl, "impossible to create declaration");
        }
    }

    /**
     * Create a Forward Scope.
     */
    private final void
    createForwardScope(ForwardScope forward)
    {
        try
        {
            forward.setPrefix(currentPrefix_);
            forward.setForward(true);
            forward.create();
            forward_scopes_.add(forward);
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error_.error(token.beginLine, exc, forward);

        } catch(ASTError exc2) {
            error(exc2.getMessage());

        }
    }

    /**
     * Check if forward scope declarations are completed.
     */
    private final void
    checkForwardScopes()
    {
        for(java.util.Enumeration e = forward_scopes_.elements();
            e.hasMoreElements(); )
        {
           ForwardScope scope = (ForwardScope)e.nextElement();
           if (!scope.isCompleted())
               error_.error(token.beginLine, "forward declaration " +
                            scope.getAbsoluteName() + " not completed");
        }
    }

    /**
     * Open a new Scope.
     */
    private final void
    openScope(Scope scope)
    {
// System.err.println("openScope " + scope);
        try
        {
            pushScope(scope);

            if (scope instanceof ForwardScope)
            {
                ForwardScope fscope = (ForwardScope)scope;

                fscope.setForward(false);
                fscope.create();
            }

            scope.setPrefix(currentPrefix_);
        } catch(org.omg.CORBA.SystemException exc) {
// System.err.println("Exception in openScope");
            error_.error(token.beginLine, exc, scope);

        } catch(ASTError exc2) {
            error(exc2.getMessage());
        }
    }

    /**
     * Close a Scope.
     */
    private final void
    closeScope()
    {
        try
        {
// System.err.println("closeScope " + currentScope_);

            if (currentScope_ instanceof ForwardScope)
            {
                if(!((ForwardScope)currentScope_).isCompleted())
                   currentScope_.create();
                currentScope_.check();
            } else {
                currentScope_.create();
                currentScope_.check();
            }
        } catch(org.omg.CORBA.SystemException exc) {
// System.err.println("EXCEPTION in closeScope");
            error_.error(token.beginLine, exc, currentScope_);

        } catch(ASTError exc2) {
            error(exc2.getMessage());

        } finally {
            popScope();
        }
    }

    // ==================================================================
    //
    // Internal methods in relation with the translation of escaped
    // sequences.
    //
    // ==================================================================

    /**
     * Check if a character is a digit in radix 16.
     */
    private final boolean
    isDigit16(char ch)
    {
       return Character.isDigit(ch) ||
              (Character.toUpperCase(ch)>='A' &&
               Character.toUpperCase(ch)<='F');
    }

    /**
     * Check if a character is a digit in radix 8.
     */
    private final boolean
    isDigit8(char ch)
    {
       return Character.isDigit(ch) && ch <'8';
    }

    /**
     * Translate all the escaped sequences of a String .
     */
    private final String
    translateString(String input)
    {
      int i=0;
      StringBuffer result = new StringBuffer(input.length());
      while (i<input.length()) {
        if(input.charAt(i)!='\\') result.append(input.charAt(i));
        else {
          i++;
          switch(input.charAt(i))
          {
            case 'n'  : result.append('\n'); break;
            case 't'  : result.append('\t'); break;
            case 'v'  : result.append('\u000b'); break;
            case 'b'  : result.append('\u0008'); break;
            case 'r'  : result.append('\r'); break;
            case 'f'  : result.append('\f'); break;
            case 'a'  : result.append('\u0007'); break;
            case '\\' : result.append('\\'); break;
            case '?'  : result.append('?'); break;
            case '\'' : result.append('\''); break;
            case '\"' : result.append('\"'); break;
            case 'u'  :
            case 'x'  :
            {
              int j=i+1;
              while ( isDigit16(input.charAt(j) )) j++;
              result.append((char)Long.parseLong(input.substring(i+1,j),16));
              i=j-1;
              break;
            }
            default :
            {
              int j=i;
              while ( isDigit8(input.charAt(j) )) j++;
              result.append((char)Long.parseLong(input.substring(i,j),8));
              i=j-1;
              break;
            }
          }
        }
        i++;
      }
      return result.toString();
    }

  int was_expected(ParseException e,int[] type) throws ParseException {
   int[][] expected = e. expectedTokenSequences;
   for (int i=0;i<expected.length;i++)
   {
       for (int j=0;j<expected[i].length;j++)
       {
           for (int k=0;k<type.length;k++)
           {
               if (expected[i][j]==type[k])
                  return k;
           }
       }
   }
   return -1;
  }

  void error_manager(ParseException e) throws ParseException {
   Token t=getToken(0);
   int[] types = {LPAREN, RPAREN, LBRACKET, RBRACKET, GTSIGN, LTSIGN,
                  LBRACE, RBRACE, SEMICOLON};
   int ret;
   if ((ret=was_expected(e,types))!=-1)
   {
       error(ParserConstants.tokenImage[types[ret]] + " expected");
   }
   else
   {
       t=getToken(1);
       error("unexpected token " + "\"" + t.image + "\"");
   }
   t=getToken(0);
   while (t.kind != SEMICOLON)
   {
       t = getNextToken();
   }
  }

  void token_error_manager(TokenMgrError e) throws ParseException {
   Token t = getToken(1);
   warning(t.beginLine,"unknown macro");
  }

// ==================================================================
//
// New production rules for identifier and some literals.
//
// ==================================================================
  final public String string_literal() throws ParseException {
    Token t;
    StringBuffer s = new StringBuffer("");
    String tmp;
    label_1:
    while (true) {
      t = jj_consume_token(STRING_LITERAL);
        tmp = translateString(t.image);
        s.append(tmp.substring(1,tmp.length()-1));
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_LITERAL:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
    }
        {if (true) return s.toString();}
    throw new Error("Missing return statement in function");
  }

  final public String wide_string_literal() throws ParseException {
    Token t;
    StringBuffer s = new StringBuffer("");
    String tmp;
    t = jj_consume_token(WIDE_STRING_LITERAL);
        tmp = translateString(t.image);
        s.append(tmp.substring(2,tmp.length()-1));
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      tmp = string_literal();
        s.append(tmp);
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
        {if (true) return s.toString();}
    throw new Error("Missing return statement in function");
  }

  final public String identifier() throws ParseException {
    Token t;
    t = jj_consume_token(IDENTIFIER);
        {if (true) return collapse(t.image);}
    throw new Error("Missing return statement in function");
  }

/**
 * <type_name> ::= <scoped_name>
 */
  final public TypeRef type_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof TypeRef)
            {if (true) return (TypeRef)decl;}

        error(decl, "must be a type name");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * <exception_name> ::= <scoped_name>
 */
  final public ExceptionDecl exception_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof ExceptionDecl)
            {if (true) return (ExceptionDecl)decl;}

        error(decl, "must be an exception name");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * <component_name> ::= <scoped_name>
 */
  final public ComponentDecl component_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof ComponentDecl)
            {if (true) return (ComponentDecl)decl;}

        error(decl, "must be a component type");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * <event_name> ::= <scoped_name>
 */
  final public EventDecl event_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof EventDecl)
            {if (true) return (EventDecl)decl;}

        error(decl, "must be a event type");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * <home_name> ::= <scoped_name>
 */
  final public HomeDecl home_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof HomeDecl)
            {if (true) return (HomeDecl)decl;}

        error(decl, "must be a home type");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * <imported_name> ::=  <identifier>
 *                    | "::" <identifier>
 *                    | <imported_name> "::" <identifier>
 */
  final public String imported_name() throws ParseException {
    String id = null;
    String tmp = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DCOLON:
      jj_consume_token(DCOLON);
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    tmp = identifier();
                             id=tmp;
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DCOLON:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_2;
      }
      jj_consume_token(DCOLON);
      tmp = identifier();
                           id=id+"::"+tmp;
    }
        {if (true) return id;}
    throw new Error("Missing return statement in function");
  }

// ==================================================================
//
// OMG IDL 2.4 Grammar.
//
// ==================================================================

/**
 * (1) <specification> ::= <importx>* <definition>+
 */
  final public void specification() throws ParseException {
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPORT:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_3;
      }
      importx();
    }
    label_4:
    while (true) {
      definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case TYPEID:
      case TYPEPREFIX:
      case COMPONENT:
      case EVENT:
      case HOME:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_4;
      }
    }
  }

/**
 * (2) <definition> ::= <type_dcl> ";"
 *                 |   <const_dcl> ";"
 *                 |   <except_dcl> ";"
 *                 |   <interface> ";"
 *                 |   <module> ";"
 *                 |   <value> ";"
 *
 *                 |   <type_id_dcl> ";"
 *                 |   <type_prefix_dcl> ";"
 *                 |   <event> ";"
 *
 *                 |   <component> ";"
 *                 |   <home_dcl> ";"
 */
  final public void definition() throws ParseException {
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ENUM:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
        type_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case CONST:
        const_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case EXCEPTION:
        except_dcl();
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[6] = jj_gen;
        if (jj_2_1(2)) {
          interfacex();
          jj_consume_token(SEMICOLON);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MODULE:
            module();
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[7] = jj_gen;
            if (jj_2_2(4)) {
              value();
              jj_consume_token(SEMICOLON);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case TYPEID:
                type_id_dcl();
                jj_consume_token(SEMICOLON);
                break;
              case TYPEPREFIX:
                type_prefix_dcl();
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[8] = jj_gen;
                if (jj_2_3(4)) {
                  event();
                  jj_consume_token(SEMICOLON);
                } else {
                  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                  case COMPONENT:
                    component();
                    jj_consume_token(SEMICOLON);
                    break;
                  case HOME:
                    home_dcl();
                    jj_consume_token(SEMICOLON);
                    break;
                  default:
                    jj_la1[9] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                  }
                }
              }
            }
          }
        }
      }
    } catch (ParseException e) {
    error_manager(e);
    } catch (TokenMgrError e) {
    token_error_manager(e);
    }
  }

/**
 * (3) <module> ::= "module" <identifier> "{" <definition>+ "}"
 */
  final public void module() throws ParseException {
    ModuleDecl module=null;
    String name;
    jj_consume_token(MODULE);
    name = identifier();
        module = currentScope_.declareModule(name);
        openScope(module);
    jj_consume_token(LBRACE);
    label_5:
    while (true) {
      definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case TYPEID:
      case TYPEPREFIX:
      case COMPONENT:
      case EVENT:
      case HOME:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_5;
      }
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 * (4) <interface> ::= <interface_dcl>
 *                 |   <forward_dcl>
 */
  final public void interfacex() throws ParseException {
    if (jj_2_4(4)) {
      interface_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case INTERFACE:
      case LOCAL:
        forward_dcl();
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (5) <interface_dcl> ::= <interface_header> "{" <interface_body> "}"
 */
  final public void interface_dcl() throws ParseException {
    InterfaceDecl itf=null;
    itf = interface_header();
        openScope(itf);
    jj_consume_token(LBRACE);
    interface_body();
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 * (6) <forward_dcl> ::= [ "abstract" | "local" ] "interface" <identifier>
 */
  final public void forward_dcl() throws ParseException {
    InterfaceDecl itf;
    itf = declare_interface();
          createForwardScope(itf);
  }

/**
 * <declare_interface> ::= [ "abstract" | "local" ] "interface" <identifier>
 */
  final public InterfaceDecl declare_interface() throws ParseException {
    InterfaceDecl itf=null;
    boolean is_abstract = false;
    boolean is_local = false;
    String name;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
    case LOCAL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                 is_abstract = true;
        break;
      case LOCAL:
        jj_consume_token(LOCAL);
              is_local = true;
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    jj_consume_token(INTERFACE);
    name = identifier();
        try
        {
            if(is_abstract)
                itf = currentScope_.declareAbstractInterface(name);
            else if(is_local)
                itf = currentScope_.declareLocalInterface(name);
            else
                itf = currentScope_.declareInterface(name);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return itf;}
    throw new Error("Missing return statement in function");
  }

/**
 * (7) <interface_header> ::= [ "abstract" | "local" ]
 *                            "interface" <identifier>
 *                            [ <interface_inheritance_spec> ]
 */
  final public InterfaceDecl interface_header() throws ParseException {
    InterfaceDecl itf=null;
    itf = declare_interface();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      interface_inheritance_spec(itf.getInheritedInterfaceList());
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
        {if (true) return itf;}
    throw new Error("Missing return statement in function");
  }

/**
 * (8) <interface_body> ::= <export>*
 */
  final public void interface_body() throws ParseException {
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[15] = jj_gen;
        break label_6;
      }
      export();
    }
  }

/**
 * (9) <export> ::= <type_dcl> ";"
 *              |   <const_dcl> ";"
 *              |   <except_dcl> ";"
 *              |   <attr_dcl> ";"
 *              |   <op_dcl> ";"
 *              |   <type_id_dcl> ";"
 *              |   <type_prefix_dcl> ";"
 */
  final public void export() throws ParseException {
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ENUM:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
        type_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case CONST:
        const_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case EXCEPTION:
        except_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case ATTRIBUTE:
      case READONLY:
        attr_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case SHORT:
      case STRING:
      case UNSIGNED:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case IDENTIFIER:
      case DCOLON:
        op_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case TYPEID:
        type_id_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case TYPEPREFIX:
        type_prefix_dcl();
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (ParseException e) {
    error_manager(e);
    } catch (TokenMgrError e) {
    token_error_manager(e);
    }
  }

/**
 * (10) <interface_inheritance_spec> ::= ":" <interface_name>
 *                                           { "," <interface_name> }*
 */
  final public void interface_inheritance_spec(InterfaceList list) throws ParseException {
    InterfaceDecl itf=null;
    jj_consume_token(COLON);
    itf = interface_name();
       list.add(itf);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[17] = jj_gen;
        break label_7;
      }
      jj_consume_token(COMMA);
      itf = interface_name();
       list.add(itf);
    }
  }

/**
 * (11) <interface_name> ::= <scoped_name>
 */
  final public InterfaceDecl interface_name() throws ParseException {
    Declaration decl=null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof InterfaceDecl)
            {if (true) return (InterfaceDecl)decl;}

        error(decl, "must be an interface");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (12) <scoped_name> ::= <identifier>
 *                   |   "::" <identifier>
 *                   |    <scoped_name> "::" <identifier>
 *
 * Note: Recursivity is removed into our implementation.
 */
  final public Declaration scoped_name() throws ParseException {
    Declaration decl = null;
    Declaration decl1 = null;
    Scope current = currentScope_;
    String id;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DCOLON:
      jj_consume_token(DCOLON);
           current = globalScope_;
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    id = identifier();
        decl = findDeclaration(current, id);
        if (decl == null)
            {if (true) return null;}
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DCOLON:
        ;
        break;
      default:
        jj_la1[19] = jj_gen;
        break label_8;
      }
      jj_consume_token(DCOLON);
      id = identifier();
          if (!(decl instanceof Scope))
          {
              error(decl.getAbsoluteName() + " is not an OMG IDL scope");
              {if (true) return null;}
          }

          decl1 = findDeclaration((Scope)decl, id);
          if (decl1==null)
              {if (true) return null;}

          decl = decl1;
    }
        {if (true) return decl;}
    throw new Error("Missing return statement in function");
  }

/**
 * (13) <value> ::= ( <value_dcl> | <value_abs_dcl> | <value_box_dcl>
 *              |     <value_forward_dcl> )
 */
  final public void value() throws ParseException {
    if (jj_2_5(4)) {
      value_dcl();
    } else if (jj_2_6(4)) {
      value_abs_dcl();
    } else if (jj_2_7(4)) {
      value_box_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case VALUETYPE:
        value_forward_dcl();
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (14) <value_forward_dcl> ::= [ "abstract" ] "valuetype" <identifier>
 */
  final public void value_forward_dcl() throws ParseException {
    ValueDecl value = null;
    String name;
    boolean is_abstract = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
      jj_consume_token(ABSTRACT);
                 is_abstract = true;
      break;
    default:
      jj_la1[21] = jj_gen;
      ;
    }
    jj_consume_token(VALUETYPE);
    name = identifier();
        try
        {
            value = currentScope_.declareValue(name);
            if (is_abstract)
                value.setAbstract(true);
            createForwardScope(value);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
  }

/**
 * (15) <value_box_dcl> ::= "valuetype" <identifier> <type_spec>
 */
  final public void value_box_dcl() throws ParseException {
    ValueBoxDecl valuebox = null;
    TypeRef type = null;
    String name = null;
    jj_consume_token(VALUETYPE);
    name = identifier();
    type = type_spec();
        valuebox = currentScope_.startValueBox(name);
        valuebox.setType(type);
        createDeclaration(valuebox);
  }

/**
 * (16) <value_abs_dcl> ::= "abstract" "valuetype" <identifier>
 *                                                 [ <value_inheritance_spec> ]
 *                                                 "{" <export>* "}"
 */
  final public void value_abs_dcl() throws ParseException {
    ValueDecl value = null;
    String name;
    if (jj_2_8(4)) {
      jj_consume_token(ABSTRACT);
      jj_consume_token(VALUETYPE);
      name = identifier();
        try
        {
            value = currentScope_.declareValue(name);
            value.setAbstract(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        openScope(value);
      jj_consume_token(LBRACE);
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANY:
        case ATTRIBUTE:
        case BOOLEAN:
        case CHAR:
        case CONST:
        case DOUBLE:
        case ENUM:
        case EXCEPTION:
        case FLOAT:
        case LONG:
        case NATIVE:
        case OBJECT:
        case OCTET:
        case ONEWAY:
        case READONLY:
        case SHORT:
        case STRING:
        case STRUCT:
        case TYPEDEF:
        case UNSIGNED:
        case UNION:
        case VALUEBASE:
        case VOID:
        case WCHAR:
        case WSTRING:
        case TYPEID:
        case TYPEPREFIX:
        case IDENTIFIER:
        case DCOLON:
          ;
          break;
        default:
          jj_la1[22] = jj_gen;
          break label_9;
        }
        export();
      }
      jj_consume_token(RBRACE);
        closeScope();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
        jj_consume_token(VALUETYPE);
        name = identifier();
        try
        {
            value = currentScope_.declareValue(name);
            value.setAbstract(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        value_inheritance_spec(value);
        openScope(value);
        jj_consume_token(LBRACE);
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ANY:
          case ATTRIBUTE:
          case BOOLEAN:
          case CHAR:
          case CONST:
          case DOUBLE:
          case ENUM:
          case EXCEPTION:
          case FLOAT:
          case LONG:
          case NATIVE:
          case OBJECT:
          case OCTET:
          case ONEWAY:
          case READONLY:
          case SHORT:
          case STRING:
          case STRUCT:
          case TYPEDEF:
          case UNSIGNED:
          case UNION:
          case VALUEBASE:
          case VOID:
          case WCHAR:
          case WSTRING:
          case TYPEID:
          case TYPEPREFIX:
          case IDENTIFIER:
          case DCOLON:
            ;
            break;
          default:
            jj_la1[23] = jj_gen;
            break label_10;
          }
          export();
        }
        jj_consume_token(RBRACE);
        closeScope();
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (17) <value_dcl> ::= <value_header> "{" <value_element>* "}"
 */
  final public void value_dcl() throws ParseException {
    ValueDecl value = null;
    value = value_header();
        openScope(value);
    jj_consume_token(LBRACE);
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FACTORY:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case PRIVATE:
      case PUBLIC:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_11;
      }
      value_element();
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 * (18) <value_header> ::= [ "custom" ] "valuetype" <identifier>
 *                                                  [ <value_inheritance_spec> ]
 */
  final public ValueDecl value_header() throws ParseException {
    ValueDecl value = null;
    boolean is_custom = false;
    String name;
    if (jj_2_9(4)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
        jj_consume_token(CUSTOM);
                            is_custom = true;
        break;
      default:
        jj_la1[26] = jj_gen;
        ;
      }
      jj_consume_token(VALUETYPE);
      name = identifier();
        try
        {
            value = currentScope_.declareValue(name);
            if (is_custom)
                value.setCustom(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
      value_inheritance_spec(value);
        {if (true) return value;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
      case VALUETYPE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CUSTOM:
          jj_consume_token(CUSTOM);
               is_custom = true;
          break;
        default:
          jj_la1[27] = jj_gen;
          ;
        }
        jj_consume_token(VALUETYPE);
        name = identifier();
        try
        {
            value = currentScope_.declareValue(name);
            if (is_custom)
                value.setCustom(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return value;}
        break;
      default:
        jj_la1[28] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (19) <value_inheritance_spec> ::= [ ":" [ "truncatable" ] <value_name>
 *                                         { "," <value_name> }* ]
 *                                   [ "supports" <interface_name>
 *                                                { "," <interface_name> }* ]
 */
  final public void value_inheritance_spec(ValueDecl value) throws ParseException {
    ValueDecl inhValue=null;
    InterfaceDecl itf=null;
    InterfaceList supportedInterfaces=value.getSupportedInterfaceList();
    ValueList abstractValues=value.getAbstractValueList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUNCATABLE:
        jj_consume_token(TRUNCATABLE);
                          value.setTruncatable(true);
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      inhValue = value_name();
        if (inhValue != null)
        {
            if (inhValue.isAbstract())
                abstractValues.add(inhValue);
            else
                value.setBaseValue(inhValue);
        }
      label_12:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[30] = jj_gen;
          break label_12;
        }
        jj_consume_token(COMMA);
        inhValue = value_name();
        abstractValues.add(inhValue);
      }
      break;
    default:
      jj_la1[31] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUPPORTS:
      jj_consume_token(SUPPORTS);
      itf = interface_name();
        supportedInterfaces.add(itf);
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[32] = jj_gen;
          break label_13;
        }
        jj_consume_token(COMMA);
        itf = interface_name();
        supportedInterfaces.add(itf);
      }
      break;
    default:
      jj_la1[33] = jj_gen;
      ;
    }
  }

/**
 * (20) <value_name> ::= <scoped_name>
 */
  final public ValueDecl value_name() throws ParseException {
    Declaration decl = null;
    decl = scoped_name();
        if(decl == null)
            {if (true) return null;}

        if (decl instanceof ValueDecl)
            {if (true) return (ValueDecl)decl;}

        error(decl, "must be a valuetype");
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (21) <value_element> ::= <export>
 *                     |   <state_member>
 *                     |   <init_dcl>
 */
  final public void value_element() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case ATTRIBUTE:
    case BOOLEAN:
    case CHAR:
    case CONST:
    case DOUBLE:
    case ENUM:
    case EXCEPTION:
    case FLOAT:
    case LONG:
    case NATIVE:
    case OBJECT:
    case OCTET:
    case ONEWAY:
    case READONLY:
    case SHORT:
    case STRING:
    case STRUCT:
    case TYPEDEF:
    case UNSIGNED:
    case UNION:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case TYPEID:
    case TYPEPREFIX:
    case IDENTIFIER:
    case DCOLON:
      export();
      break;
    case PRIVATE:
    case PUBLIC:
      state_member();
      break;
    case FACTORY:
      init_dcl();
      break;
    default:
      jj_la1[34] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (22) <state_member> ::= ( "public" | "private" ) <type_spec> <declarators> ";"
 */
  final public void state_member() throws ParseException {
    DeclaratorList declList=null;
    TypeRef type=null;
    boolean is_public=false;
    boolean is_private=false;
    ValueDecl value = (ValueDecl)currentScope_;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PUBLIC:
      jj_consume_token(PUBLIC);
               is_public=true;
      break;
    case PRIVATE:
      jj_consume_token(PRIVATE);
                                               is_private=true;
      break;
    default:
      jj_la1[35] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    type = type_spec();
    declList = declarators(type);
    jj_consume_token(SEMICOLON);
        for(int i=0; i<declList.size(); i++)
        {
            ValueMemberDecl vm = value.startValueMember(declList.nameAt(i));
            if(is_public) vm.setPublic();
            if(is_private) vm.setPrivate();
            vm.setType(declList.typeAt(i));
            createDeclaration(vm);
        }
  }

/**
 * (23) <init_dcl> ::= "factory" <identifier> "(" [ <init_param_decls> ] ")"
 *                     [ <raises_expr> ] ";"
 */
  final public void init_dcl() throws ParseException {
    Initializer init = null;
    String name = null;
    ValueDecl value = (ValueDecl)currentScope_;
    jj_consume_token(FACTORY);
    name = identifier();
        init = currentScope_.startInitializer(name);
        value.getInitializerList().add(init);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      init_param_decls(init.getParameterList());
      break;
    default:
      jj_la1[36] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(init.getExceptionList());
      break;
    default:
      jj_la1[37] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

/**
 * (24) <init_param_decls> ::= <init_param_decl> { "," <init_param_decl> }*
 */
  final public void init_param_decls(ParameterList list) throws ParseException {
    init_param_decl(list);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[38] = jj_gen;
        break label_14;
      }
      jj_consume_token(COMMA);
      init_param_decl(list);
    }
  }

/**
 * (25) <init_param_decl> ::= <init_param_attribute> <param_type_spec>
 *                                                   <simple_declarator>
 *
 * (26) <init_param_attribute> ::= "in"
 */
  final public void init_param_decl(ParameterList list) throws ParseException {
    TypeRef type = null;
    String id = null;
    jj_consume_token(IN);
    type = param_type_spec();
    id = simple_declarator();
        list.addInParam(id, type);
  }

/**
 * (27) <const_dcl> ::= "const" <const_type> <identifier> "=" <const_exp>
 */
  final public void const_dcl() throws ParseException {
  ConstantDecl constant = null;
  AnyValue value = null;
  String name = null;
  TypeRef type;
    jj_consume_token(CONST);
    type = const_type();
    name = identifier();
    jj_consume_token(ASSIGN);
    value = const_exp();
        constant = currentScope_.startConstant(name);
        constant.setType(type);
        constant.setAnyValue(value);
        createDeclaration(constant);
  }

/**
 * (28) <const_type> ::= <integer_type>
 *                   |   <char_type>
 *                   |   <wide_char_type>
 *                   |   <boolean_type>
 *                   |   <floating_pt_type>
 *                   |   <string_type>
 *                   |   <wide_string_type>
 *                   |   <fixed_pt_const_type>
 *                   |   <scoped_name>
 *                   |   <octet_type>
 */
  final public TypeRef const_type() throws ParseException {
  TypeRef type=null;
    if (jj_2_10(2)) {
      type = floating_pt_type();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHAR:
        type = char_type();
        break;
      case WCHAR:
        type = wide_char_type();
        break;
      case BOOLEAN:
        type = boolean_type();
        break;
      case LONG:
      case SHORT:
      case UNSIGNED:
        type = integer_type();
        break;
      case STRING:
        type = string_type();
        break;
      case WSTRING:
        type = wide_string_type();
        break;
      case FIXED:
        type = fixed_pt_const_type();
        break;
      case IDENTIFIER:
      case DCOLON:
        type = type_name();
        break;
      case OCTET:
        type = octet_type();
        break;
      default:
        jj_la1[39] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (29) <const_exp> ::= <or_expr>
 */
  final public AnyValue const_exp() throws ParseException {
    AnyValue v;
    v = or_expr();
        {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
 * (30) <or_expr> ::= <xor_expr>
 *                |   <or_expr> "|" <xor_expr>
 */
  final public AnyValue or_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = xor_expr();
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PIPE:
        ;
        break;
      default:
        jj_la1[40] = jj_gen;
        break label_15;
      }
      jj_consume_token(PIPE);
      v2 = xor_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() | v2.getAsInteger());
            else
                error("invalid operand for binary operator |");
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (31) <xor_expr> ::= <and_expr>
 *                 |   <xor_expr> "^" <and_expr>
 */
  final public AnyValue xor_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = and_expr();
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CICUMFLEX:
        ;
        break;
      default:
        jj_la1[41] = jj_gen;
        break label_16;
      }
      jj_consume_token(CICUMFLEX);
      v2 = and_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() ^ v2.getAsInteger());
            else
                error("invalid operand for binary operator ^");
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (32) <and_expr> ::= <shift_expr>
 *                 |   <and_expr> "&" <shift_expr>
 */
  final public AnyValue and_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = shift_expr();
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AMPERSAND:
        ;
        break;
      default:
        jj_la1[42] = jj_gen;
        break label_17;
      }
      jj_consume_token(AMPERSAND);
      v2 = shift_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() & v2.getAsInteger());
            else
                error("invalid operand for binary operator &");
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (33) <shift_expr> ::= <add_expr>
 *                   |   <shift_expr> ">>" <add_expr>
 *                   |   <shift_expr> "<<" <add_expr>
 */
  final public AnyValue shift_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = add_expr();
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RSHIFT:
      case LSHIFT:
        ;
        break;
      default:
        jj_la1[43] = jj_gen;
        break label_18;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RSHIFT:
        jj_consume_token(RSHIFT);
        v2 = add_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() >> v2.getAsInteger());
            else
                error("invalid operand for binary operator >>");
        break;
      case LSHIFT:
        jj_consume_token(LSHIFT);
        v2 = add_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() << v2.getAsInteger());
            else
                error("invalid operand for binary operator <<");
        break;
      default:
        jj_la1[44] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (34) <add_expr> ::= <mult_expr>
 *                 |   <add_expr> "+" <mult_expr>
 *                 |   <add_expr> "-" <mult_expr>
 */
  final public AnyValue add_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = mult_expr();
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[45] = jj_gen;
        break label_19;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
        v2 = mult_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() + v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() + v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() + v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() + v2.getAsFloating());
            else
                error("invalid operand for binary operator +");
        break;
      case MINUS:
        jj_consume_token(MINUS);
        v2 = mult_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() - v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() - v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() - v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() - v2.getAsFloating());
            else
                error("invalid operand for binary operator -");
        break;
      default:
        jj_la1[46] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (35) <mult_expr> ::= <unary_expr>
 *                  |   <mult_expr> "*" <unary_expr>
 *                  |   <mult_expr> "/" <unary_expr>
 *                  |   <mult_expr> "%" <unary_expr>
 */
  final public AnyValue mult_expr() throws ParseException {
    AnyValue v1, v2;
    v1 = unary_expr();
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
      case REM:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_20;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
        v2 = unary_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() * v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() * v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() * v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() * v2.getAsFloating());
            else
                error("invalid operand for binary operator *");
        break;
      case SLASH:
        jj_consume_token(SLASH);
        v2 = unary_expr();
             if(v1.isInteger() && v2.isInteger())
                v1.setAsFloating(v1.getAsInteger() / v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() / v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() / v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() / v2.getAsFloating());
            else
                error("invalid operand for binary operator /");
        break;
      case REM:
        jj_consume_token(REM);
        v2 = unary_expr();
            if(v1.isInteger() && v2.isInteger())
                v1.setAsInteger(v1.getAsInteger() % v2.getAsInteger());
            else if(v1.isInteger() && v2.isFloating())
                v1.setAsFloating(v1.getAsInteger() % v2.getAsFloating());
            else if(v1.isFloating() && v2.isInteger())
                v1.setAsFloating(v1.getAsFloating() % v2.getAsInteger());
            else if(v1.isFloating() && v2.isFloating())
                v1.setAsFloating(v1.getAsFloating() % v2.getAsFloating());
            else
                error("invalid operand for binary operator %");
        break;
      default:
        jj_la1[48] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return v1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (36) <unary_expr> ::= <unary_operator> <primary_expr>
 *                   |   <primary_expr>
 *
 * (37) <unary_operator> ::= "-" | "+" | "~"
 */
  final public AnyValue unary_expr() throws ParseException {
    AnyValue value=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FALSE:
    case TRUE:
    case INTEGER_LITERAL:
    case STRING_LITERAL:
    case WIDE_STRING_LITERAL:
    case CHARACTER_LITERAL:
    case WIDE_CHARACTER_LITERAL:
    case FLOATING_PT_LITERAL:
    case FIXED_PT_LITERAL:
    case IDENTIFIER:
    case LPAREN:
    case DCOLON:
      value = primary_expr();
      break;
    case MINUS:
      jj_consume_token(MINUS);
      value = primary_expr();
        if (value.isInteger())
            value.setAsInteger(-value.getAsInteger());
        else if (value.isFloating())
            value.setAsFloating(-value.getAsFloating());
        else
            error("wrong argument type for unary minus");
      break;
    case PLUS:
      jj_consume_token(PLUS);
      value = primary_expr();
        if (!value.isInteger() && !value.isFloating())
            error("wrong argument type for unary plus");
      break;
    case TILDE:
      jj_consume_token(TILDE);
      value = primary_expr();
        if (value.isInteger())
            value.setAsInteger(~value.getAsInteger());
        else
            error("wrong argument type for bit-complement");
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 * (38) <primary_expr> ::= <scoped_name>
 *                     |   <literal>
 *                     |   "(" <const_exp> ")"
 */
  final public AnyValue primary_expr() throws ParseException {
    AnyValue value=null;
    Declaration decl;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      decl = scoped_name();
        if(decl != null)
        {
            if (decl instanceof WithAnyValue)
                value = ((WithAnyValue)decl).getAnyValue();
            else
                error(decl, "must be a constant name or enumerator");
        }
        if(value == null)
        {
            value = ast_.createAnyValue();
            value.setAsInteger(0);
        }
      break;
    case FALSE:
    case TRUE:
    case INTEGER_LITERAL:
    case STRING_LITERAL:
    case WIDE_STRING_LITERAL:
    case CHARACTER_LITERAL:
    case WIDE_CHARACTER_LITERAL:
    case FLOATING_PT_LITERAL:
    case FIXED_PT_LITERAL:
      value = literal();
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      value = const_exp();
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[50] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 * (39) <literal> ::= <integer_literal>
 *                |   <string_literal>
 *                |   <wide_string_literal>
 *                |   <character_literal>
 *                |   <wide_character_literal>
 *                |   <fixed_pt_literal>
 *                |   <floating_pt_literal>
 *                |   <boolean_literal>
 *
 * (40) <boolean_literal> ::= "TRUE"
 *                        |   "FALSE"
 */
  final public AnyValue literal() throws ParseException {
    AnyValue value = ast_.createAnyValue();
    Token t;
    String s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      t = jj_consume_token(INTEGER_LITERAL);
        s = t.image.toLowerCase();
        if (s.startsWith("0x"))
            value.setAsInteger(Long.parseLong(s.substring(2,s.length()),16));
        else if (s.startsWith("0"))
            value.setAsInteger(Long.parseLong(s,8));
        else
            value.setAsInteger(Long.parseLong(s,10));
      break;
    default:
      jj_la1[51] = jj_gen;
      if (jj_2_11(2)) {
        s = string_literal();
        value.setAsString(s);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case WIDE_STRING_LITERAL:
          s = wide_string_literal();
        value.setAsWString(s);
          break;
        default:
          jj_la1[52] = jj_gen;
          if (jj_2_12(2)) {
            t = jj_consume_token(CHARACTER_LITERAL);
        s = translateString(t.image);
        value.setAsChar(s.charAt(1));
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case WIDE_CHARACTER_LITERAL:
              t = jj_consume_token(WIDE_CHARACTER_LITERAL);
        s = translateString(t.image);
        value.setAsWChar(s.charAt(2));
              break;
            default:
              jj_la1[53] = jj_gen;
              if (jj_2_13(2)) {
                t = jj_consume_token(FIXED_PT_LITERAL);
        s = t.image;
        value.setAsFixed(s.substring(0,s.length()-1));
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case FLOATING_PT_LITERAL:
                  t = jj_consume_token(FLOATING_PT_LITERAL);
        value.setAsFloating(Double.parseDouble(t.image));
                  break;
                case TRUE:
                  jj_consume_token(TRUE);
        value.setAsBoolean(true);
                  break;
                case FALSE:
                  jj_consume_token(FALSE);
        value.setAsBoolean(false);
                  break;
                default:
                  jj_la1[54] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
            }
          }
        }
      }
    }
    {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 * (41) <positive_int_const> ::= <const_exp>
 */
  final public int positive_int_const() throws ParseException {
     AnyValue value;
    value = const_exp();
        if (value.isInteger())
        {
             long integer = value.getAsInteger();
             if(integer >= 0)
                 {if (true) return (int)integer;}
        }
        error("positive constant required");
        {if (true) return 1;}
    throw new Error("Missing return statement in function");
  }

/**
 * (42) <type_dcl> ::= "typedef" <type_declarator>
 *                 |   <struct_type>
 *                 |   <union_type>
 *                 |   <enum_type>
 *                 |   "native" <simple_declarator>
 *                 |   <constr_forward_dcl>
 */
  final public void type_dcl() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYPEDEF:
      jj_consume_token(TYPEDEF);
      type_declarator();
      break;
    default:
      jj_la1[55] = jj_gen;
      if (jj_2_14(3)) {
        struct_type();
      } else if (jj_2_15(3)) {
        union_type();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ENUM:
          enum_type();
          break;
        case NATIVE:
        NativeDecl n = null;
        String name = null;
          jj_consume_token(NATIVE);
          name = identifier();
        n = currentScope_.startNative(name);
        createDeclaration(n);
          break;
        case STRUCT:
        case UNION:
          constr_forward_dcl();
          break;
        default:
          jj_la1[56] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

/**
 * (43) <type_declarator> ::= <type_spec> <declarators>
 */
  final public void type_declarator() throws ParseException {
    TypeRef type=null;
    DeclaratorList declList=null;
    type = type_spec();
    declList = declarators(type);
        for(int i=0; i<declList.size(); i++)
        {
            AliasDecl alias = currentScope_.startAlias(declList.nameAt(i));
            alias.setType(declList.typeAt(i));
            createDeclaration(alias);
        }
  }

/**
 * (44) <type_spec> ::= <simple_type_spec>
 *                  |   <constr_type_spec>
 */
  final public TypeRef type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FIXED:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SEQUENCE:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      type = simple_type_spec();
      break;
    case ENUM:
    case STRUCT:
    case UNION:
      type = constr_type_spec();
      break;
    default:
      jj_la1[57] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (45) <simple_type_spec> ::= <base_type_spec>
 *                         |   <template_type_spec>
 *                         |   <scoped_name>
 */
  final public TypeRef simple_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
      type = base_type_spec();
      break;
    case FIXED:
    case SEQUENCE:
    case STRING:
    case WSTRING:
      type = template_type_spec();
      break;
    case IDENTIFIER:
    case DCOLON:
      type = type_name();
      break;
    default:
      jj_la1[58] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (46) <base_type_spec> ::= <floating_pt_type>
 *                       |   <integer_type>
 *                       |   <char_type>
 *                       |   <wide_char_type>
 *                       |   <boolean_type>
 *                       |   <octet_type>
 *                       |   <any_type>
 *                       |   <object_type>
 *                       |   <value_base_type>
 */
  final public TypeRef base_type_spec() throws ParseException {
    TypeRef type;
    if (jj_2_16(2)) {
      type = floating_pt_type();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LONG:
      case SHORT:
      case UNSIGNED:
        type = integer_type();
        break;
      case CHAR:
        type = char_type();
        break;
      case WCHAR:
        type = wide_char_type();
        break;
      case BOOLEAN:
        type = boolean_type();
        break;
      case OCTET:
        type = octet_type();
        break;
      case ANY:
        type = any_type();
        break;
      case OBJECT:
        type = object_type();
        break;
      case VALUEBASE:
        type = value_base_type();
        break;
      default:
        jj_la1[59] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (47) <template_type_spec> ::= <sequence_type>
 *                           |   <string_type>
 *                           |   <wide_string_type>
 *                           |   <fixed_pt_type>
 */
  final public TypeRef template_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEQUENCE:
      type = sequence_type();
      break;
    case STRING:
      type = string_type();
      break;
    case WSTRING:
      type = wide_string_type();
      break;
    case FIXED:
      type = fixed_pt_type();
      break;
    default:
      jj_la1[60] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (48) <constr_type_spec> ::= <struct_type>
 *                         |   <union_type>
 *                         |   <enum_type>
 */
  final public TypeRef constr_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRUCT:
      type = struct_type();
      break;
    case UNION:
      type = union_type();
      break;
    case ENUM:
      type = enum_type();
      break;
    default:
      jj_la1[61] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (49) <declarators> ::= <declarator> { "," <declarator> }*
 */
  final public DeclaratorList declarators(TypeRef baseType) throws ParseException {
    DeclaratorList declList = new DeclaratorList();
    declarator(declList, baseType);
    label_21:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[62] = jj_gen;
        break label_21;
      }
      jj_consume_token(COMMA);
      declarator(declList, baseType);
    }
        {if (true) return declList;}
    throw new Error("Missing return statement in function");
  }

/**
 * (50) <declarator> ::= <simple_declarator>
 *                   |   <complex_declarator>
 */
  final public void declarator(DeclaratorList declList, TypeRef baseType) throws ParseException {
  String name;
    if (jj_2_17(2)) {
      complex_declarator(declList, baseType);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        name = simple_declarator();
        declList.addDeclarator(name, baseType);
        break;
      default:
        jj_la1[63] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (51) <simple_declarator> ::= <identifier>
 */
  final public String simple_declarator() throws ParseException {
    String n;
    n = identifier();
        {if (true) return n;}
    throw new Error("Missing return statement in function");
  }

/**
 * (52) <complex_declarator> ::= <array_declarator>
 */
  final public void complex_declarator(DeclaratorList declList, TypeRef baseType) throws ParseException {
    array_declarator(declList, baseType);
  }

/**
 * (53) <floating_pt_type> ::= "float"
 *                         |   "double"
 *                         |   "long" "double"
 */
  final public TypeRef floating_pt_type() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FLOAT:
      jj_consume_token(FLOAT);
        {if (true) return ast_.getFloatType();}
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
        {if (true) return ast_.getDoubleType();}
      break;
    case LONG:
      jj_consume_token(LONG);
      jj_consume_token(DOUBLE);
        {if (true) return ast_.getLongDoubleType();}
      break;
    default:
      jj_la1[64] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (54) <integer_type> ::= <signed_int>
 *                     |   <unsigned_int>
 *
 * (55) <signed_int>   ::= <signed_short_int>
 *                     |   <signed_long_int>
 *                     |   <signed_longlong_int>
 *
 * (56) <signed_short_int> ::= "short"
 *
 * (57) <signed_long_int>  ::= "long"
 *
 * (58) <signed_longlong_int> ::= "long" "long"
 *
 * (59) <unsigned_int>   ::= <unsigned_short_int>
 *                       |   <unsigned_long_int>
 *                       |   <unsigned_longlong_int>
 *
 * (60) <unsigned_short_int> ::= "unsigned" "short"
 *
 * (61) <unsigned_long_int>  ::= "unsigned" "long"
 *
 * (62) <unsigned_longlong_int> ::= "unsigned" "long" "long"
 */
  final public TypeRef integer_type() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SHORT:
      jj_consume_token(SHORT);
        {if (true) return ast_.getShortType();}
      break;
    default:
      jj_la1[65] = jj_gen;
      if (jj_2_18(2)) {
        jj_consume_token(LONG);
        jj_consume_token(LONG);
        {if (true) return ast_.getLongLongType();}
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LONG:
          jj_consume_token(LONG);
        {if (true) return ast_.getLongType();}
          break;
        default:
          jj_la1[66] = jj_gen;
          if (jj_2_19(2)) {
            jj_consume_token(UNSIGNED);
            jj_consume_token(SHORT);
        {if (true) return ast_.getUShortType();}
          } else if (jj_2_20(3)) {
            jj_consume_token(UNSIGNED);
            jj_consume_token(LONG);
            jj_consume_token(LONG);
        {if (true) return ast_.getULongLongType();}
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case UNSIGNED:
              jj_consume_token(UNSIGNED);
              jj_consume_token(LONG);
        {if (true) return ast_.getULongType();}
              break;
            default:
              jj_la1[67] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      }
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (63) <char_type> ::= "char"
 */
  final public TypeRef char_type() throws ParseException {
    jj_consume_token(CHAR);
        {if (true) return ast_.getCharType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (64) <wide_char_type> ::= "wchar"
 */
  final public TypeRef wide_char_type() throws ParseException {
    jj_consume_token(WCHAR);
        {if (true) return ast_.getWCharType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (65) <boolean_type> ::= "boolean"
 */
  final public TypeRef boolean_type() throws ParseException {
    jj_consume_token(BOOLEAN);
        {if (true) return ast_.getBooleanType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (66) <octet_type> ::= "octet"
 */
  final public TypeRef octet_type() throws ParseException {
    jj_consume_token(OCTET);
        {if (true) return ast_.getOctetType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (67) <any_type> ::= "any"
 */
  final public TypeRef any_type() throws ParseException {
    jj_consume_token(ANY);
        {if (true) return ast_.getAnyType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (68) <object_type> ::= "Object"
 */
  final public TypeRef object_type() throws ParseException {
    jj_consume_token(OBJECT);
        {if (true) return ast_.getObjectType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (69) <struct_type> ::= "struct" <identifier> "{" <member_list> "}"
 */
  final public TypeRef struct_type() throws ParseException {
    StructDecl struct = null;
    String name = "";
    jj_consume_token(STRUCT);
    name = identifier();
        struct = currentScope_.declareStruct(name);
        openScope(struct);
    jj_consume_token(LBRACE);
    member_list();
    jj_consume_token(RBRACE);
        closeScope();
        {if (true) return (TypeRef)struct;}
    throw new Error("Missing return statement in function");
  }

/**
 * (70) <member_list> ::= <member>+
 */
  final public void member_list() throws ParseException {
    StructDecl struct = (StructDecl)currentScope_;
    label_22:
    while (true) {
      member(struct.getMemberList());
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case ENUM:
      case FIXED:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case SEQUENCE:
      case SHORT:
      case STRING:
      case STRUCT:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case WCHAR:
      case WSTRING:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[68] = jj_gen;
        break label_22;
      }
    }
  }

/**
 * (71) <member> ::= <type_spec> <declarators> ";"
 */
  final public void member(StructMemberList list) throws ParseException {
    TypeRef type;
    DeclaratorList declList;
    type = type_spec();
    declList = declarators(type);
    jj_consume_token(SEMICOLON);
        for(int i=0; i<declList.size(); i++)
        {
            list.addMember(declList.nameAt(i), declList.typeAt(i));
        }
  }

/**
 * (72) <union_type> ::= "union" <identifier> "switch" "(" <switch_type_spec> ")"
 *                                           "{" <switch_body> "}"
 */
  final public TypeRef union_type() throws ParseException {
    UnionDecl union = null;
    String name = "";
    TypeRef type=null;
    jj_consume_token(UNION);
    name = identifier();
    jj_consume_token(SWITCH);
    jj_consume_token(LPAREN);
    type = switch_type_spec();
    jj_consume_token(RPAREN);
        union = currentScope_.declareUnion(name);
        union.setDiscriminator(type);
        openScope(union);
    jj_consume_token(LBRACE);
    switch_body();
    jj_consume_token(RBRACE);
        closeScope();
        {if (true) return (TypeRef)union;}
    throw new Error("Missing return statement in function");
  }

/**
 * (73) <switch_type_spec> ::= <integer_type>
 *                         |   <char_type>
 *                         |   <boolean_type>
 *                         |   <enum_type>
 *                         |   <scoped_name>
 */
  final public TypeRef switch_type_spec() throws ParseException {
  TypeRef type=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LONG:
    case SHORT:
    case UNSIGNED:
      type = integer_type();
      break;
    case CHAR:
      type = char_type();
      break;
    case BOOLEAN:
      type = boolean_type();
      break;
    case ENUM:
      type = enum_type();
      break;
    case IDENTIFIER:
    case DCOLON:
      type = type_name();
      break;
    default:
      jj_la1[69] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (74) <switch_body> ::= <case>+
 */
  final public void switch_body() throws ParseException {
    label_23:
    while (true) {
      casex();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case DEFAULTX:
        ;
        break;
      default:
        jj_la1[70] = jj_gen;
        break label_23;
      }
    }
  }

/**
 * (75) <case> ::= <case_label>+ <element_spec> ";"
 */
  final public void casex() throws ParseException {
    java.util.Vector labels = new java.util.Vector();
    AnyValue label;
    label_24:
    while (true) {
      label = case_label();
                         labels.addElement(label);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case DEFAULTX:
        ;
        break;
      default:
        jj_la1[71] = jj_gen;
        break label_24;
      }
    }
    element_spec(labels);
    jj_consume_token(SEMICOLON);
  }

/**
 * (76) <case_label> ::=  "case" <const_exp> ":"
 *                   |    "default" ":"
 */
  final public AnyValue case_label() throws ParseException {
    AnyValue value = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CASE:
      jj_consume_token(CASE);
      value = const_exp();
      jj_consume_token(COLON);
      break;
    case DEFAULTX:
      jj_consume_token(DEFAULTX);
      jj_consume_token(COLON);
        value = ast_.createAnyValue();
      break;
    default:
      jj_la1[72] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/**
 * (77) <element_spec> ::= <type_spec> <declarator>
 */
  final public void element_spec(java.util.Vector labels) throws ParseException {
    TypeRef type;
    DeclaratorList declList = new DeclaratorList();
    UnionMemberList union = ((UnionDecl)currentScope_).getMemberList();
    type = type_spec();
    declarator(declList, type);
        String name = declList.nameAt(0);
        type = declList.typeAt(0);

        for(int i=0; i<labels.size(); i++)
        {
            try
            {
                union.addMember(name, type, (AnyValue)labels.elementAt(i));
            }
            catch(org.omg.CORBA.SystemException exc)
            {
                error(exc);
            }
        }
  }

/**
 * (78) <enum_type> ::= "enum" <identifier> "{" <enumerator>
 *                                              { "," <enumerator> }* "}"
 *
 * (79) <enumerator> ::= <identifier>
 */
  final public TypeRef enum_type() throws ParseException {
    EnumDecl enume = null;
    StringList list = null;
    String enumerator=null;
    String name = null;
    jj_consume_token(ENUM);
    name = identifier();
    jj_consume_token(LBRACE);
        enume = currentScope_.startEnum(name);
        list = enume.getMemberList();
    enumerator = identifier();
        list.add(enumerator);
    label_25:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[73] = jj_gen;
        break label_25;
      }
      jj_consume_token(COMMA);
      enumerator = identifier();
        list.add(enumerator);
    }
    jj_consume_token(RBRACE);
        createDeclaration(enume);
        {if (true) return enume;}
    throw new Error("Missing return statement in function");
  }

/**
 * (80) <sequence_type> ::= "sequence" "<" <simple_type_spec> ","
 *                                         <positive_int_const> ">"
 *                      |   "sequence" "<" <simple_type_spec> ">"
 */
  final public TypeRef sequence_type() throws ParseException {
    TypeRef base=null;
    int length=0;
    jj_consume_token(SEQUENCE);
    jj_consume_token(LTSIGN);
    base = simple_type_spec();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      length = positive_int_const();
      break;
    default:
      jj_la1[74] = jj_gen;
      ;
    }
    jj_consume_token(GTSIGN);
        try
        {
            {if (true) return ast_.createSequenceType(length, base);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (81) <string_type> ::= "string" "<" <positive_int_const> ">"
 *                    |   "string"
 */
  final public TypeRef string_type() throws ParseException {
    int length = -1;
    jj_consume_token(STRING);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LTSIGN:
      jj_consume_token(LTSIGN);
      length = positive_int_const();
      jj_consume_token(GTSIGN);
      break;
    default:
      jj_la1[75] = jj_gen;
      ;
    }
        try
        {
            if (length == -1)
                {if (true) return ast_.getStringType();}
            else
                {if (true) return ast_.createStringType(length);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (82) <wide_string_type> ::= "wstring" "<" <positive_int_const> ">"
 *                     |   "wstring"
 */
  final public TypeRef wide_string_type() throws ParseException {
  int length = -1;
    jj_consume_token(WSTRING);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LTSIGN:
      jj_consume_token(LTSIGN);
      length = positive_int_const();
      jj_consume_token(GTSIGN);
      break;
    default:
      jj_la1[76] = jj_gen;
      ;
    }
        try
        {
            if (length == -1)
                {if (true) return ast_.getWStringType();}
            else
                {if (true) return ast_.createWStringType(length);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (83) <array_declarator> ::= <identifier> <fixed_array_size>+
 *
 * (84) <fixed_array_size> ::= "[" <positive_int_const> "]"
 */
  final public void array_declarator(DeclaratorList declList, TypeRef type) throws ParseException {
    String id;
    int size;
    id = identifier();
    label_26:
    while (true) {
      jj_consume_token(LBRACKET);
      size = positive_int_const();
        try
        {
            type = ast_.createArrayType(size, type);
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
      jj_consume_token(RBRACKET);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[77] = jj_gen;
        break label_26;
      }
    }
        declList.addDeclarator(id, type);
  }

/**
 * (85) <attr_dcl> ::= <readonly_attr_spec>
 *                  |   <attr_spec>
 */
  final public void attr_dcl() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case READONLY:
      readonly_attr_spec();
      break;
    case ATTRIBUTE:
      attr_spec();
      break;
    default:
      jj_la1[78] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (86) <except_dcl> ::= "exception" <identifier> "{" <member>* "}"
 */
  final public void except_dcl() throws ParseException {
    ExceptionDecl exception = null;
    String name = null;
    jj_consume_token(EXCEPTION);
    name = identifier();
        exception = currentScope_.startException(name);
        openScope(exception);
    jj_consume_token(LBRACE);
    label_27:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case ENUM:
      case FIXED:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case SEQUENCE:
      case SHORT:
      case STRING:
      case STRUCT:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case WCHAR:
      case WSTRING:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[79] = jj_gen;
        break label_27;
      }
      member(exception.getMemberList());
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 * (87) <op_dcl> ::= [ <op_attribute> ] <op_type_spec> <identifier>
 *                                      <parameter_dcls>
 *                                      [ <raises_expr> ] [ <context_expr> ]
 *
 * (88) <op_attribute> ::= "oneway"
 */
  final public void op_dcl() throws ParseException {
    OperationDecl op = null;
    String name = null;
    boolean oneway = false;
    TypeRef type = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ONEWAY:
      jj_consume_token(ONEWAY);
               oneway = true;
      break;
    default:
      jj_la1[80] = jj_gen;
      ;
    }
    type = op_type_spec();
    name = identifier();
        op = currentScope_.startOperation(name);
        if (oneway) op.setOneway();
        op.setType(type);
    parameter_dcls(op.getParameterList());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(op.getExceptionList());
      break;
    default:
      jj_la1[81] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONTEXT:
      context_expr(op.getContextList());
      break;
    default:
      jj_la1[82] = jj_gen;
      ;
    }
        createDeclaration(op);
  }

/**
 * (89) <op_type_spec> ::= <param_type_spec>
 *                     |   "void"
 */
  final public TypeRef op_type_spec() throws ParseException {
    TypeRef type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      type = param_type_spec();
        {if (true) return type;}
      break;
    case VOID:
      jj_consume_token(VOID);
        {if (true) return ast_.getVoidType();}
      break;
    default:
      jj_la1[83] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (90) <parameter_dcls> ::= "(" <param_dcl> { "," <param_dcl> }* ")"
 *                       |   "(" ")"
 */
  final public void parameter_dcls(ParameterList list) throws ParseException {
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
    case INOUT:
    case OUT:
      param_dcl(list);
      label_28:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[84] = jj_gen;
          break label_28;
        }
        jj_consume_token(COMMA);
        param_dcl(list);
      }
      break;
    default:
      jj_la1[85] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
  }

/**
 * (91) <param_dcl> ::= <param_attribute> <param_type_spec> <simple_declarator>
 *
 * (92) <param_attribute> ::= "in" | "out" | "inout"
 */
  final public void param_dcl(ParameterList list) throws ParseException {
    TypeRef type=null;
    String id=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      jj_consume_token(IN);
      type = param_type_spec();
      id = simple_declarator();
        list.addInParam(id, type);
      break;
    case OUT:
      jj_consume_token(OUT);
      type = param_type_spec();
      id = simple_declarator();
        list.addOutParam(id, type);
      break;
    case INOUT:
      jj_consume_token(INOUT);
      type = param_type_spec();
      id = simple_declarator();
        list.addInOutParam(id, type);
      break;
    default:
      jj_la1[86] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (93) <raises_expr> ::= "raises" "(" <scoped_name>
 *                                     { "," <scoped_name> }* ")"
 */
  final public void raises_expr(ExceptionList list) throws ParseException {
    ExceptionDecl exc=null;
    jj_consume_token(RAISES);
    jj_consume_token(LPAREN);
    exc = exception_name();
        list.add(exc);
    label_29:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[87] = jj_gen;
        break label_29;
      }
      jj_consume_token(COMMA);
      exc = exception_name();
        list.add(exc);
    }
    jj_consume_token(RPAREN);
  }

/**
 * (94) <context_expr> ::= "context" "(" <string_literal>
 *                                       { "," <string_literal> }* ")"
 */
  final public void context_expr(StringList list) throws ParseException {
    String s=null;
    jj_consume_token(CONTEXT);
    jj_consume_token(LPAREN);
    s = string_literal();
        list.add(s);
    label_30:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[88] = jj_gen;
        break label_30;
      }
      jj_consume_token(COMMA);
      s = string_literal();
        list.add(s);
    }
    jj_consume_token(RPAREN);
  }

/**
 * (95) <param_type_spec> ::= <base_type_spec>
 *                        |   <string_type>
 *                        |   <wide_string_type>
 *                        |   <scoped_name>
 */
  final public TypeRef param_type_spec() throws ParseException {
    TypeRef type=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
      type = base_type_spec();
      break;
    case STRING:
      type = string_type();
      break;
    case WSTRING:
      type = wide_string_type();
      break;
    case IDENTIFIER:
    case DCOLON:
      type = type_name();
      break;
    default:
      jj_la1[89] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

/**
 * (96) <fixed_pt_type> ::= "fixed" "<" <positive_int_const> ","
 *                                      <positive_int_const> ">"
 */
  final public TypeRef fixed_pt_type() throws ParseException {
    int digits=0;
    int scale=0;
    jj_consume_token(FIXED);
    jj_consume_token(LTSIGN);
    digits = positive_int_const();
    jj_consume_token(COMMA);
    scale = positive_int_const();
    jj_consume_token(GTSIGN);
        try
        {
            {if (true) return ast_.createFixedType((short)digits, (short)scale);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (97) <fixed_pt_const_type> ::= "fixed"
 */
  final public TypeRef fixed_pt_const_type() throws ParseException {
    jj_consume_token(FIXED);
        try
        {
            {if (true) return ast_.createFixedType((short)0, (short)0);}
        }
        catch(org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (98) <value_base_type> ::= "ValueBase"
 */
  final public TypeRef value_base_type() throws ParseException {
    jj_consume_token(VALUEBASE);
        {if (true) return ast_.getValueBaseType();}
    throw new Error("Missing return statement in function");
  }

/**
 * (99) <constr_forward_dcl> ::= "struct" <identifier>
 *                            |   "union" <identifier>
 */
  final public void constr_forward_dcl() throws ParseException {
    ForwardScope decl = null;
    String name = "";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRUCT:
      jj_consume_token(STRUCT);
      name = identifier();
        decl = currentScope_.declareStruct(name);
      break;
    case UNION:
      jj_consume_token(UNION);
      name = identifier();
        decl = currentScope_.declareUnion(name);
      break;
    default:
      jj_la1[90] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        createForwardScope(decl);
  }

// ==================================================================
//
// OMG IDL 3.0 Grammar.
//
// ==================================================================

/**
 * (100) <importx> ::= "import" <imported_scope> ";"
 */
  final public void importx() throws ParseException {
    try {
      jj_consume_token(IMPORT);
      imported_scope();
      jj_consume_token(SEMICOLON);
    } catch (ParseException e) {
    error_manager(e);
    } catch (TokenMgrError e) {
    token_error_manager(e);
    }
  }

/**
 * (101) <imported_scope> ::= <scoped_name> | <string_literal>
 */
  final public void imported_scope() throws ParseException {
    String s = null;
    Declaration decl = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      s = imported_name();
        decl = ast_.importByName(globalScope_, s);
      break;
    case STRING_LITERAL:
      s = string_literal();
        decl = ast_.importById(globalScope_, s);
      break;
    default:
      jj_la1[91] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (decl==null)
        error(s + " not found or invalid definition to import");
  }

/**
 * (102) <type_id_dcl> ::= "typeid" <scoped_name> <string_literal>
 */
  final public void type_id_dcl() throws ParseException {
    Declaration decl;
    String id;
    jj_consume_token(TYPEID);
    decl = scoped_name();
    id = string_literal();
        setId(decl,id);
  }

/**
 * (103) <type_prefix_dcl> ::= "typeprefix" <scoped_name> <string_literal>
 */
  final public void type_prefix_dcl() throws ParseException {
    Declaration decl;
    String prefix;
    jj_consume_token(TYPEPREFIX);
    decl = scoped_name();
    prefix = string_literal();
        System.out.println("type_prefix_dcl : "+decl.getName()+"=>"+prefix);
        setPrefix(decl,prefix);
  }

/**
 * (104) <readonly_attr_spec> ::= "readonly" "attribute" <param_type_spec>
 *                                              <readonly_attr_declarator>
 */
  final public void readonly_attr_spec() throws ParseException {
    TypeRef type;
    jj_consume_token(READONLY);
    jj_consume_token(ATTRIBUTE);
    type = param_type_spec();
    readonly_attr_declarator(type);
  }

/**
 * (105) <readonly_attr_declarator> ::= <simple_declarator> [ <raises_expr> ]
 *                                  |   <simple_declarator> { ","
 *                                                     <simple_declarator> }*
 */
  final public void readonly_attr_declarator(TypeRef type) throws ParseException {
    AttributeDecl attr = null;
    String name = null;
    name = identifier();
        attr = currentScope_.startAttribute(name);
        attr.setReadonly();
        attr.setType(type);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(attr.getGetExceptionList());
            createDeclaration(attr);
      break;
    default:
      jj_la1[93] = jj_gen;
           createDeclaration(attr);
      label_31:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[92] = jj_gen;
          break label_31;
        }
        jj_consume_token(COMMA);
        name = identifier();
           attr = currentScope_.startAttribute(name);
           attr.setReadonly();
           attr.setType(type);
           createDeclaration(attr);
      }
    }
  }

/**
 * (106) <attr_spec> ::= "attribute" <param_type_spec> <attr_declarator>
 */
  final public void attr_spec() throws ParseException {
    TypeRef type;
    jj_consume_token(ATTRIBUTE);
    type = param_type_spec();
    attr_declarator(type);
  }

/**
 * (107) <attr_declarator> ::= <simple_declarator> <attr_raises_expr>
 *                         |   <simple_declarator> { "," <simple_declarator> }*
 */
  final public void attr_declarator(TypeRef type) throws ParseException {
    AttributeDecl attr = null;
    String name = null;
    name = identifier();
        attr = currentScope_.startAttribute(name);
        attr.setType(type);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GETRAISES:
    case SETRAISES:
      attr_raises_expr(attr);
           createDeclaration(attr);
      break;
    default:
      jj_la1[95] = jj_gen;
           createDeclaration(attr);
      label_32:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[94] = jj_gen;
          break label_32;
        }
        jj_consume_token(COMMA);
        name = identifier();
           attr = currentScope_.startAttribute(name);
           attr.setType(type);
           createDeclaration(attr);
      }
    }
  }

/**
 * (108) <attr_raises_expr> ::= <get_excep_expr> [ <set_excep_expr> ]
 *                          |   <set_excep_expr>
 */
  final public void attr_raises_expr(AttributeDecl attr) throws ParseException {
    ExceptionList getExcList = attr.getGetExceptionList();
    ExceptionList setExcList = attr.getSetExceptionList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GETRAISES:
      get_excep_expr(getExcList);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SETRAISES:
        set_excep_expr(setExcList);
        break;
      default:
        jj_la1[96] = jj_gen;
        ;
      }
      break;
    case SETRAISES:
      set_excep_expr(setExcList);
      break;
    default:
      jj_la1[97] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (109) <get_excep_expr> ::= "getraises" <exception_list>
 */
  final public void get_excep_expr(ExceptionList excList) throws ParseException {
    jj_consume_token(GETRAISES);
    exception_list(excList);
  }

/**
 * (110) <set_excep_expr> ::= "setraises" <exception_list>
 */
  final public void set_excep_expr(ExceptionList excList) throws ParseException {
    jj_consume_token(SETRAISES);
    exception_list(excList);
  }

/**
 * (111) <exception_list> ::= "(" <scoped_name> { "," <scoped_name> }* ")"
 */
  final public void exception_list(ExceptionList list) throws ParseException {
  ExceptionDecl exc;
    jj_consume_token(LPAREN);
    exc = exception_name();
        list.add(exc);
    label_33:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[98] = jj_gen;
        break label_33;
      }
      jj_consume_token(COMMA);
      exc = exception_name();
        list.add(exc);
    }
    jj_consume_token(RPAREN);
  }

// ==================================================================
//
// OMG CCM IDL Grammar.
//
// ==================================================================

/**
 * (112) <component> ::= <component_dcl>
 *                   |   <component_forward_dcl>
 */
  final public void component() throws ParseException {
    if (jj_2_21(4)) {
      component_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPONENT:
        component_forward_dcl();
        break;
      default:
        jj_la1[99] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (113) <component_forward_dcl> ::= "component" <identifier>
 */
  final public void component_forward_dcl() throws ParseException {
    ComponentDecl component = null;
    String name;
    jj_consume_token(COMPONENT);
    name = identifier();
        try
        {
            component = currentScope_.declareComponent(name);
            createForwardScope(component);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
  }

/**
 * (114) <component_dcl> ::= <component_header> "{" <component_body> "}"
 */
  final public void component_dcl() throws ParseException {
    ComponentDecl component = null;
    component = component_header();
       openScope(component);
    jj_consume_token(LBRACE);
    component_body();
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 * (115) <component_header> ::= "component" <identifier>
 *                                   [ <component_inheritance_spec> ]
 *                                   [ <supported_interface_spec> ]
 */
  final public ComponentDecl component_header() throws ParseException {
    String name;
    ComponentDecl component = null;
    jj_consume_token(COMPONENT);
    name = identifier();
        try
        {
            component = currentScope_.declareComponent(name);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      component_inheritance_spec(component);
      break;
    default:
      jj_la1[100] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUPPORTS:
      supported_interface_spec(component.getSupportedInterfaceList());
      break;
    default:
      jj_la1[101] = jj_gen;
      ;
    }
        {if (true) return component;}
    throw new Error("Missing return statement in function");
  }

/**
 * (116) <supported_interface_spec> ::= "supports" <scoped_name>
 *                                                 { "," <scoped_name> }*
 */
  final public void supported_interface_spec(InterfaceList list) throws ParseException {
    InterfaceDecl itf;
    jj_consume_token(SUPPORTS);
    itf = interface_name();
        list.add(itf);
    label_34:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[102] = jj_gen;
        break label_34;
      }
      jj_consume_token(COMMA);
      itf = interface_name();
        list.add(itf);
    }
  }

/**
 * (117) <component_inheritance_spec> ::= ":" <scoped_name>
 */
  final public void component_inheritance_spec(ComponentDecl component) throws ParseException {
    ComponentDecl base;
    jj_consume_token(COLON);
    base = component_name();
        component.setBaseComponent(base);
  }

/**
 * (118) <component_body>  ::= <component_export>*
 */
  final public void component_body() throws ParseException {
    label_35:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ATTRIBUTE:
      case READONLY:
      case PROVIDES:
      case USES:
      case EMITS:
      case PUBLISHES:
      case CONSUMES:
        ;
        break;
      default:
        jj_la1[103] = jj_gen;
        break label_35;
      }
      component_export();
    }
  }

/**
 * (119) <component_export> ::= <provides_dcl> ";"
 *                          |   <uses_dcl> ";"
 *                          |   <emits_dcl> ";"
 *                          |   <publishes_dcl> ";"
 *                          |   <consumes_dcl> ";"
 *                          |   <attr_dcl> ";"
 */
  final public void component_export() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROVIDES:
      provides_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case USES:
      uses_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case EMITS:
      emits_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case PUBLISHES:
      publishes_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case CONSUMES:
      consumes_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case ATTRIBUTE:
    case READONLY:
      attr_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[104] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (120) <provides_dcl> ::= "provides" <interface_type> <identifier>
 */
  final public void provides_dcl() throws ParseException {
    ProvidesDecl provides = null;
    InterfaceDecl itf = null;
    String name = null;
    jj_consume_token(PROVIDES);
    itf = interface_type();
    name = identifier();
        provides = currentScope_.startProvides(name);
        provides.setInterface(itf);
        createDeclaration(provides);
  }

/**
 * (121) <interface_type> ::= <scoped_name> | "Object"
 *
 * Warning: I don't understand why a provides/uses port can be Object!
 *         This is not compliant with the IFR 3.0 specification!
 */
  final public InterfaceDecl interface_type() throws ParseException {
    InterfaceDecl itf;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      itf = interface_name();
        {if (true) return itf;}
      break;
    case OBJECT:
      jj_consume_token(OBJECT);
        {if (true) return null;} /* ARGH !!!!! */

      break;
    default:
      jj_la1[105] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (122) <uses_dcl> ::= "uses" [ "multiple" ] <interface_type> <identifier>
 */
  final public void uses_dcl() throws ParseException {
    UsesDecl uses = null;
    InterfaceDecl itf;
    boolean multiple = false;
    String name=  null;
    jj_consume_token(USES);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MULTIPLE:
      jj_consume_token(MULTIPLE);
                        multiple = true;
      break;
    default:
      jj_la1[106] = jj_gen;
      ;
    }
    itf = interface_type();
    name = identifier();
        uses = currentScope_.startUses(name);
        if (multiple) uses.setMultiple();
        uses.setInterface(itf);
        createDeclaration(uses);
  }

/**
 * (123) <emits_dcl> ::= "emits" <scoped_name> <identifier>
 */
  final public void emits_dcl() throws ParseException {
    EmitsDecl emits = null;
    EventDecl event;
    String name = null;
    jj_consume_token(EMITS);
    event = event_name();
    name = identifier();
        emits = currentScope_.startEmits(name);
        emits.setEvent(event);
        createDeclaration(emits);
  }

/**
 * (124) <publishes_dcl> ::= "publishes" <scoped_name> <identifier>
 */
  final public void publishes_dcl() throws ParseException {
    PublishesDecl publishes = null;
    EventDecl event;
    String name = null;
    jj_consume_token(PUBLISHES);
    event = event_name();
    name = identifier();
        publishes = currentScope_.startPublishes(name);
        publishes.setEvent(event);
        createDeclaration(publishes);
  }

/**
 * (125) <consumes_dcl> ::= "consumes" <scoped_name> <identifier>
 */
  final public void consumes_dcl() throws ParseException {
    ConsumesDecl consumes = null;
    EventDecl event;
    String name = null;
    jj_consume_token(CONSUMES);
    event = event_name();
    name = identifier();
        consumes = currentScope_.startConsumes(name);
        consumes.setEvent(event);
        createDeclaration(consumes);
  }

/**
 * (126) <home_dcl> ::= <home_header> <home_body>
 */
  final public void home_dcl() throws ParseException {
    HomeDecl home = null;
    home = home_header();
        openScope(home);
    home_body();
        closeScope();
  }

/**
 * (127) <home_header> ::= "home" <identifier> 
 *                         [ <home_inheritance_spec> ]
 *                         [ <supported_interface_spec> ]
 *                         "manages" <scoped_name>
 *                         [ <primary_key_spec> ]
 */
  final public HomeDecl home_header() throws ParseException {
    ComponentDecl managed;
    HomeDecl home = null;
    String name = null;
    jj_consume_token(HOME);
    name = identifier();
        home = currentScope_.startHome(name);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      home_inheritance_spec(home);
      break;
    default:
      jj_la1[107] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUPPORTS:
      supported_interface_spec(home.getSupportedInterfaceList());
      break;
    default:
      jj_la1[108] = jj_gen;
      ;
    }
    jj_consume_token(MANAGES);
    managed = component_name();
        home.setManagedComponent(managed);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIMARYKEY:
      primary_key_spec(home);
      break;
    default:
      jj_la1[109] = jj_gen;
      ;
    }
        {if (true) return home;}
    throw new Error("Missing return statement in function");
  }

/**
 * (128) <home_inheritance_spec> ::= ":" <scoped_name>
 */
  final public void home_inheritance_spec(HomeDecl home) throws ParseException {
    HomeDecl base;
    jj_consume_token(COLON);
    base = home_name();
        home.setBaseHome(base);
  }

/**
 * (129) <primary_key_spec> ::= "primarykey" <scoped_name>
 */
  final public void primary_key_spec(HomeDecl home) throws ParseException {
    ValueDecl primary;
    jj_consume_token(PRIMARYKEY);
    primary = value_name();
        home.setPrimaryKey(primary);
  }

/**
 * (130) <home_body> ::= "{" <home_export>* "}"
 */
  final public void home_body() throws ParseException {
    jj_consume_token(LBRACE);
    label_36:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FACTORY:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case FINDER:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[110] = jj_gen;
        break label_36;
      }
      home_export();
    }
    jj_consume_token(RBRACE);
  }

/**
 * (131) <home_export> ::= <export>
 *                     |   <factory_dcl> ";"
 *                     |   <finder_dcl> ";"
 */
  final public void home_export() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case ATTRIBUTE:
    case BOOLEAN:
    case CHAR:
    case CONST:
    case DOUBLE:
    case ENUM:
    case EXCEPTION:
    case FLOAT:
    case LONG:
    case NATIVE:
    case OBJECT:
    case OCTET:
    case ONEWAY:
    case READONLY:
    case SHORT:
    case STRING:
    case STRUCT:
    case TYPEDEF:
    case UNSIGNED:
    case UNION:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case TYPEID:
    case TYPEPREFIX:
    case IDENTIFIER:
    case DCOLON:
      export();
      break;
    case FACTORY:
      factory_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case FINDER:
      finder_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[111] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (132) <factory_dcl> ::= "factory" <identifier> "(" [ <init_param_dcls> ] ")"
 *                                                [ <raises_expr> ]
 */
  final public void factory_dcl() throws ParseException {
    FactoryDecl factory = null;
    String name = null;
    jj_consume_token(FACTORY);
    name = identifier();
        factory = currentScope_.startFactory(name);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      init_param_decls(factory.getParameterList());
      break;
    default:
      jj_la1[112] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(factory.getExceptionList());
      break;
    default:
      jj_la1[113] = jj_gen;
      ;
    }
        createDeclaration(factory);
  }

/**
 * (133) <finder_dcl> ::= "finder" <identifier> "(" [ <init_params_decls> ] ")"
 *                                              [ <raises_expr> ]
 */
  final public void finder_dcl() throws ParseException {
    FinderDecl finder = null;
    String name = null;
    jj_consume_token(FINDER);
    name = identifier();
        finder = currentScope_.startFinder(name);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      init_param_decls(finder.getParameterList());
      break;
    default:
      jj_la1[114] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(finder.getExceptionList());
      break;
    default:
      jj_la1[115] = jj_gen;
      ;
    }
        createDeclaration(finder);
  }

/**
 * (134) <event> ::= <event_dcl>
 *                   | <event_abs_dcl>
 *                   | <event_forward_dcl>
 */
  final public void event() throws ParseException {
    if (jj_2_22(4)) {
      event_dcl();
    } else if (jj_2_23(4)) {
      event_abs_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case EVENT:
        event_forward_dcl();
        break;
      default:
        jj_la1[116] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (135) <event_forward_dcl> ::= [ "abstract" ] "eventtype" <identifier>
 */
  final public void event_forward_dcl() throws ParseException {
    EventDecl event = null;
    String name;
    boolean is_abstract = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
      jj_consume_token(ABSTRACT);
                 is_abstract = true;
      break;
    default:
      jj_la1[117] = jj_gen;
      ;
    }
    jj_consume_token(EVENT);
    name = identifier();
        try
        {
            event = currentScope_.declareEvent(name);
            if (is_abstract)
                event.setAbstract(true);
            createForwardScope(event);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
  }

/**
 * (136) <event_abs_dcl> ::= "abstract" "eventtype" <identifier>
 *                           [ <value_inheritance_spec> ]
 *                           "{" <export>* "}"
 */
  final public void event_abs_dcl() throws ParseException {
    EventDecl event = null;
    String name;
    if (jj_2_24(4)) {
      jj_consume_token(ABSTRACT);
      jj_consume_token(EVENT);
      name = identifier();
        try
        {
            event = currentScope_.declareEvent(name);
            event.setAbstract(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        openScope(event);
      jj_consume_token(LBRACE);
      label_37:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANY:
        case ATTRIBUTE:
        case BOOLEAN:
        case CHAR:
        case CONST:
        case DOUBLE:
        case ENUM:
        case EXCEPTION:
        case FLOAT:
        case LONG:
        case NATIVE:
        case OBJECT:
        case OCTET:
        case ONEWAY:
        case READONLY:
        case SHORT:
        case STRING:
        case STRUCT:
        case TYPEDEF:
        case UNSIGNED:
        case UNION:
        case VALUEBASE:
        case VOID:
        case WCHAR:
        case WSTRING:
        case TYPEID:
        case TYPEPREFIX:
        case IDENTIFIER:
        case DCOLON:
          ;
          break;
        default:
          jj_la1[118] = jj_gen;
          break label_37;
        }
        export();
      }
      jj_consume_token(RBRACE);
        closeScope();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
        jj_consume_token(EVENT);
        name = identifier();
        try
        {
            event = currentScope_.declareEvent(name);
            event.setAbstract(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        value_inheritance_spec(event);
        openScope(event);
        jj_consume_token(LBRACE);
        label_38:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ANY:
          case ATTRIBUTE:
          case BOOLEAN:
          case CHAR:
          case CONST:
          case DOUBLE:
          case ENUM:
          case EXCEPTION:
          case FLOAT:
          case LONG:
          case NATIVE:
          case OBJECT:
          case OCTET:
          case ONEWAY:
          case READONLY:
          case SHORT:
          case STRING:
          case STRUCT:
          case TYPEDEF:
          case UNSIGNED:
          case UNION:
          case VALUEBASE:
          case VOID:
          case WCHAR:
          case WSTRING:
          case TYPEID:
          case TYPEPREFIX:
          case IDENTIFIER:
          case DCOLON:
            ;
            break;
          default:
            jj_la1[119] = jj_gen;
            break label_38;
          }
          export();
        }
        jj_consume_token(RBRACE);
        closeScope();
        break;
      default:
        jj_la1[120] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (137) <event_dcl> ::= <event_header> "{" <value_element>* "}"
 */
  final public void event_dcl() throws ParseException {
    EventDecl event = null;
    event = event_header();
        openScope(event);
    jj_consume_token(LBRACE);
    label_39:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case ATTRIBUTE:
      case BOOLEAN:
      case CHAR:
      case CONST:
      case DOUBLE:
      case ENUM:
      case EXCEPTION:
      case FACTORY:
      case FLOAT:
      case LONG:
      case NATIVE:
      case OBJECT:
      case OCTET:
      case ONEWAY:
      case PRIVATE:
      case PUBLIC:
      case READONLY:
      case SHORT:
      case STRING:
      case STRUCT:
      case TYPEDEF:
      case UNSIGNED:
      case UNION:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case TYPEID:
      case TYPEPREFIX:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[121] = jj_gen;
        break label_39;
      }
      value_element();
    }
    jj_consume_token(RBRACE);
        closeScope();
  }

/**
 * (138) <event_header> ::= [ "custom" ] "eventtype" <identifier>
 *                          [ <value_inheritance_spec> ]
 */
  final public EventDecl event_header() throws ParseException {
    EventDecl event = null;
    boolean is_custom = false;
    String name;
    if (jj_2_25(4)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
        jj_consume_token(CUSTOM);
                            is_custom = true;
        break;
      default:
        jj_la1[122] = jj_gen;
        ;
      }
      jj_consume_token(EVENT);
      name = identifier();
        try
        {
            event = currentScope_.declareEvent(name);
            if (is_custom)
                event.setCustom(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
      value_inheritance_spec(event);
        {if (true) return event;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CUSTOM:
      case EVENT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CUSTOM:
          jj_consume_token(CUSTOM);
               is_custom = true;
          break;
        default:
          jj_la1[123] = jj_gen;
          ;
        }
        jj_consume_token(EVENT);
        name = identifier();
        try
        {
            event = currentScope_.declareEvent(name);
            if (is_custom)
                event.setCustom(true);
        }
        catch (org.omg.CORBA.SystemException exc)
        {
            error(exc);
        }
        {if (true) return event;}
        break;
      default:
        jj_la1[124] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

// ==================================================================
//
// OMG PSDL Grammar.
//
// ==================================================================

/**
 * (1) <psdl_specification> ::= <psdl_definition>+
 */
  final public void psdl_specification() throws ParseException {
    label_40:
    while (true) {
      psdl_definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case STORAGEHOME:
      case STORAGETYPE:
        ;
        break;
      default:
        jj_la1[125] = jj_gen;
        break label_40;
      }
    }
  }

/**
 * (2) <psdl_definition> ::= <type_dcl> ";"
 *                         | <const_dcl> ";"   
 *                         | <except_dcl> ";"   
 *                         | <interface> ";"   
 *                         | <psdl_module> ";"   
 *                         | <storagehome> ";"   
 *                         | <abstract_storagehome> ";"   
 *                         | <storagetype> ";"   
 *                         | <abstract_storagetype> ";"   
 *                         | <value> ";"   
 */
  final public void psdl_definition() throws ParseException {
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ENUM:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
        type_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case CONST:
        const_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case EXCEPTION:
        except_dcl();
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[126] = jj_gen;
        if (jj_2_26(2)) {
          interfacex();
          jj_consume_token(SEMICOLON);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MODULE:
            psdl_module();
            jj_consume_token(SEMICOLON);
            break;
          case STORAGEHOME:
            storagehome();
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[127] = jj_gen;
            if (jj_2_27(2)) {
              abstract_storagehome();
              jj_consume_token(SEMICOLON);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case STORAGETYPE:
                storagetype();
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[128] = jj_gen;
                if (jj_2_28(2)) {
                  abstract_storagetype();
                  jj_consume_token(SEMICOLON);
                } else {
                  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                  case ABSTRACT:
                  case CUSTOM:
                  case VALUETYPE:
                    value();
                    jj_consume_token(SEMICOLON);
                    break;
                  default:
                    jj_la1[129] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                  }
                }
              }
            }
          }
        }
      }
    } catch (ParseException e) {
    error_manager(e);
    } catch (TokenMgrError e) {
    token_error_manager(e);
    }
  }

/**
 * (3) <psdl_module> ::= "module" <identifier> "{" <psdl_definition>+ "}"
 */
  final public void psdl_module() throws ParseException {
   PsdlModuleDecl module = null;
   String name;
    jj_consume_token(MODULE);
    name = identifier();
         module = currentScope_.declarePsdlModule(name);
         openScope(module);
    jj_consume_token(LBRACE);
    label_41:
    while (true) {
      psdl_definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case STORAGEHOME:
      case STORAGETYPE:
        ;
        break;
      default:
        jj_la1[130] = jj_gen;
        break label_41;
      }
    }
    jj_consume_token(RBRACE);
         closeScope();
  }

/**
 * (4) <abstract_storagehome_name> ::= <scoped_name>
 */
  final public AbstractStorageHomeDecl abstract_storagehome_name() throws ParseException {
   Declaration decl = null;
    decl = scoped_name();
         if(decl == null) {
            {if (true) return null;}
         }
         if(decl instanceof AbstractStorageHomeDecl) {
            {if (true) return (AbstractStorageHomeDecl)decl;}
         }
         error(decl, "must be an abstract storagehome");
         {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (5) <abstract_storagetype> ::= <abstract_storagetype_dcl>
 *                            | <abstract_storagetype_fwd_dcl>
 */
  final public void abstract_storagetype() throws ParseException {
    if (jj_2_29(4)) {
      abstract_storagetype_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        abstract_storagetype_fwd_dcl();
        break;
      default:
        jj_la1[131] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (6) <abstract_storagetype_dcl> ::= <abstract_storagetype_header>  
 *                                    "{" <abstract_storagetype_body> "}"
 */
  final public void abstract_storagetype_dcl() throws ParseException {
   AbstractStorageTypeDecl ast = null;
    ast = abstract_storagetype_header();
         openScope(ast);
    jj_consume_token(LBRACE);
    abstract_storagetype_body();
    jj_consume_token(RBRACE);
         closeScope();
  }

/**
 * <declare_abstract_storagetype> ::= "abstract" "storagetype" <identifier>
 */
  final public AbstractStorageTypeDecl declare_abstract_storagetype() throws ParseException {
   String name;
    jj_consume_token(ABSTRACT);
    jj_consume_token(STORAGETYPE);
    name = identifier();
         {if (true) return currentScope_.declareAbstractStorageType(name);}
    throw new Error("Missing return statement in function");
  }

/**
 * (7) <abstract_storagetype_fwd_dcl> ::= "abstract" "storagetype" <identifier>
 */
  final public void abstract_storagetype_fwd_dcl() throws ParseException {
   AbstractStorageTypeDecl ast = null;
    ast = declare_abstract_storagetype();
         createForwardScope(ast);
  }

/**
 * (8) <abstract_storagetype_header> ::= "abstract" "storagetype" <identifier>
 *                                                  [ <abstract_storagetype_inh_spec> ]
 */
  final public AbstractStorageTypeDecl abstract_storagetype_header() throws ParseException {
   AbstractStorageTypeDecl ast = null;
    ast = declare_abstract_storagetype();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      abstract_storagetype_inh_spec(ast.getAbstractStorageTypeList());
      break;
    default:
      jj_la1[132] = jj_gen;
      ;
    }
         {if (true) return ast;}
    throw new Error("Missing return statement in function");
  }

/**
 * (9) <abstract_storagetype_body> ::= <abstract_storagetype_member>*
 */
  final public void abstract_storagetype_body() throws ParseException {
    label_42:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case READONLY:
      case SHORT:
      case STRING:
      case UNSIGNED:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case STATE:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[133] = jj_gen;
        break label_42;
      }
      abstract_storagetype_member();
    }
  }

/**
 * (10) <abstract_storagetype_member> ::= <psdl_state_dcl> ";"
 *                              | <storagetype_local_op_dcl> ";" 
 */
  final public void abstract_storagetype_member() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case READONLY:
    case STATE:
      psdl_state_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      storagetype_local_op_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[134] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (11) <abstract_storagetype_inh_spec> ::= ":" <abstract_storagetype_name> 
 *                                { "," <abstract_storagetype_name> }* 
 */
  final public void abstract_storagetype_inh_spec(AbstractStorageTypeList list) throws ParseException {
   AbstractStorageTypeDecl inherited = null;
    jj_consume_token(COLON);
    inherited = abstract_storagetype_name();
         list.add(inherited);
    label_43:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[135] = jj_gen;
        break label_43;
      }
      jj_consume_token(COMMA);
      inherited = abstract_storagetype_name();
         list.add(inherited);
    }
  }

/**
 * (12) <abstract_storagetype_name> ::= <scoped_name>
 */
  final public AbstractStorageTypeDecl abstract_storagetype_name() throws ParseException {
   Declaration decl = null;
    decl = scoped_name();
         if(decl == null){
            {if (true) return null;}
         }
         if(decl instanceof AbstractStorageTypeDecl){
            {if (true) return (AbstractStorageTypeDecl)decl;}
         }
         error(decl, "must be an abstract storagetype");
         {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (13) <psdl_state_dcl> ::= ["readonly"] "state" <psdl_state_type_spec>
 *                      <simple_declarator> { "," <simple_declarator> }*
 */
  final public void psdl_state_dcl() throws ParseException {
   StorageTypeStateMemberDecl stateMember = null;
   boolean isReadonly = false;
   PsdlTypeRef stateType = null;
   String name =  null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case READONLY:
      jj_consume_token(READONLY);
                   isReadonly = true;
      break;
    default:
      jj_la1[136] = jj_gen;
      ;
    }
    jj_consume_token(STATE);
    stateType = psdl_state_type_spec();
    name = simple_declarator();
      stateMember = currentScope_.startStorageTypeStateMember(name);
      stateMember.setReadonly(isReadonly);
      stateMember.setType(stateType);
      createDeclaration(stateMember);
    label_44:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[137] = jj_gen;
        break label_44;
      }
      jj_consume_token(COMMA);
      name = simple_declarator();
      stateMember = currentScope_.startStorageTypeStateMember(name);
      stateMember.setReadonly(isReadonly);
      stateMember.setType(stateType);
      createDeclaration(stateMember);
    }
  }

/**
 * (14) <psdl_state_type_spec> ::= <base_type_spec>
 *                          | <string_type>
 *                          | <wide_string_type>
 *                          | <abstract_storagetype_ref_type>
 *                          | <scoped_name>
 */
  final public PsdlTypeRef psdl_state_type_spec() throws ParseException {
  TypeRef idl_type = null;
  PsdlTypeRef psdl_type = null;
  Declaration decl = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case UNSIGNED:
    case VALUEBASE:
    case WCHAR:
      idl_type = base_type_spec();
          {if (true) return ast_.createPsdlType(idl_type);}
      break;
    case STRING:
      idl_type = string_type();
          {if (true) return ast_.createPsdlType(idl_type);}
      break;
    case WSTRING:
      idl_type = wide_string_type();
          {if (true) return ast_.createPsdlType(idl_type);}
      break;
    case REF:
    case STRONG:
      psdl_type = abstract_storagetype_ref_type();
          {if (true) return psdl_type;}
      break;
    case IDENTIFIER:
    case DCOLON:
      decl = scoped_name();
         if(decl == null)
         {
            {if (true) return null;}
         }
         if(decl instanceof AbstractStorageTypeDecl)
         {
            {if (true) return ast_.createAbstractStorageTypePsdlType(false, false, (AbstractStorageTypeDecl)decl);}
         }
         /* WARNING THIS MUST BE MORE RESTRICTED, i.e. don't accept native types */
         if (decl instanceof TypeRef)
         {
            {if (true) return ast_.createPsdlType((TypeRef)decl);}
         }
         error(decl, "must be a psdl type name");
         {if (true) return null;}
      break;
    default:
      jj_la1[138] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (15) <abstract_storagetype_ref_type> ::= ["strong"] "ref"
 *                                     "<" <abstract_storagetype_name> ">"
 */
  final public PsdlTypeRef abstract_storagetype_ref_type() throws ParseException {
  boolean isStrong = false;
  AbstractStorageTypeDecl ast = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRONG:
      jj_consume_token(STRONG);
                 isStrong = true;
      break;
    default:
      jj_la1[139] = jj_gen;
      ;
    }
    jj_consume_token(REF);
    jj_consume_token(LTSIGN);
    ast = abstract_storagetype_name();
    jj_consume_token(GTSIGN);
    {if (true) return ast_.createAbstractStorageTypePsdlType(isStrong, true, ast);}
    throw new Error("Missing return statement in function");
  }

/**
 * (16) <abstract_storagehome> ::= <abstract_storagehome_dcl>
 *                          | <abstract_storagehome_fwd_dcl>
 */
  final public void abstract_storagehome() throws ParseException {
    if (jj_2_30(4)) {
      abstract_storagehome_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        abstract_storagehome_fwd_dcl();
        break;
      default:
        jj_la1[140] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * <declare_abstract_storagehome> ::= "abstract" "storagehome" <identifier>
 */
  final public AbstractStorageHomeDecl declare_abstract_storagehome() throws ParseException {
   String name = null;
    jj_consume_token(ABSTRACT);
    jj_consume_token(STORAGEHOME);
    name = identifier();
  {if (true) return currentScope_.declareAbstractStorageHome(name);}
    throw new Error("Missing return statement in function");
  }

/**
 * (17) <abstract_storagehome_fwd_dcl> ::= "abstract" "storagehome" <identifier>
 */
  final public void abstract_storagehome_fwd_dcl() throws ParseException {
   AbstractStorageHomeDecl ash = null;
    ash = declare_abstract_storagehome();
         createForwardScope(ash);
  }

/**
 * (18) <abstract_storagehome_dcl> ::= <abstract_storagehome_header>
 *                                "{" <abstract_storagehome_body> "}"
 */
  final public void abstract_storagehome_dcl() throws ParseException {
   AbstractStorageHomeDecl ash = null;
    ash = abstract_storagehome_header();
         openScope(ash);
    jj_consume_token(LBRACE);
    abstract_storagehome_body();
    jj_consume_token(RBRACE);
         closeScope();
  }

/**
 * (19) <abstract_storagehome_header> ::= "abstract" "storagehome" <identifier> "of"
 *                                   <abstract_storagetype_name>
 *                                   [ <abstract_storagehome_inh_spec> ]
 */
  final public AbstractStorageHomeDecl abstract_storagehome_header() throws ParseException {
   AbstractStorageHomeDecl ash = null;
   AbstractStorageTypeDecl ast = null;
    ash = declare_abstract_storagehome();
    jj_consume_token(OF);
    ast = abstract_storagetype_name();
      ash.setAbstractStorageType(ast);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      abstract_storagehome_inh_spec(ash.getAbstractStorageHomeList());
      break;
    default:
      jj_la1[141] = jj_gen;
      ;
    }
{if (true) return ash;}
    throw new Error("Missing return statement in function");
  }

/**
 * (20) <abstract_storagehome_body> ::= <storagehome_member>*
 */
  final public void abstract_storagehome_body() throws ParseException {
    label_45:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case FACTORY:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case SHORT:
      case STRING:
      case UNSIGNED:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case KEY:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[142] = jj_gen;
        break label_45;
      }
      storagehome_member();
    }
  }

/**
 * (21) <storagehome_member> ::= <local_op_dcl> ";"
 *                        | <key_dcl> ";"
 *                        | <psdl_factory_dcl> ";"
 */
  final public void storagehome_member() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      local_op_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case KEY:
      key_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case FACTORY:
      psdl_factory_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[143] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (22) <abstract_storagehome_inh_spec> ::= ":" <abstract_storagehome_name>
 *                                  { "," <abstract_storagehome_name> }* 
 */
  final public void abstract_storagehome_inh_spec(AbstractStorageHomeList list) throws ParseException {
   AbstractStorageHomeDecl inherited = null;
    jj_consume_token(COLON);
    inherited = abstract_storagehome_name();
         list.add(inherited);
    label_46:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[144] = jj_gen;
        break label_46;
      }
      jj_consume_token(COMMA);
      inherited = abstract_storagehome_name();
         list.add(inherited);
    }
  }

/**
 * (23) <storagetype_local_op_dcl> ::= <op_type_spec> <identifier> <parameter_dcls>
 *                             [ <raises_expr> ] ["const"]
 */
  final public void storagetype_local_op_dcl() throws ParseException {
    PsdlOperationDecl op = null;
    String name = null;
    TypeRef type = null;
    type = op_type_spec();
    name = identifier();
        op = currentScope_.startPsdlOperation(name);
        op.setType(type);
    parameter_dcls(op.getParameterList());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(op.getExceptionList());
      break;
    default:
      jj_la1[145] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONST:
      jj_consume_token(CONST);
                op.setConst(true);
      break;
    default:
      jj_la1[146] = jj_gen;
      ;
    }
        createDeclaration(op);
  }

/**
 * (24) <local_op_dcl> ::= <op_type_spec> <identifier> <parameter_dcls>
 *                             [ <raises_expr> ]
 */
  final public void local_op_dcl() throws ParseException {
    PsdlOperationDecl op = null;
    String name = null;
    TypeRef type = null;
    type = op_type_spec();
    name = identifier();
        op = currentScope_.startPsdlOperation(name);
        op.setConst(false);
        op.setType(type);
    parameter_dcls(op.getParameterList());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RAISES:
      raises_expr(op.getExceptionList());
      break;
    default:
      jj_la1[147] = jj_gen;
      ;
    }
        createDeclaration(op);
  }

/**
 * (25) <key_dcl> ::= "key" <identifier> 
 *                     [ "(" <simple_declarator> {"," <simple_declarator>}* ")" ]
 */
  final public void key_dcl() throws ParseException {
  StorageHomeKeyDecl shk = null;
  StringList list = null;
  String name = null;
  boolean hasSimpleDeclarator = false;
    jj_consume_token(KEY);
    name = identifier();
        shk = ((StorageHomeBase)currentScope_).startStorageHomeKey(name);
        list = shk.getMemberList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      name = simple_declarator();
        hasSimpleDeclarator = true;
        list.add(name);
      label_47:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[148] = jj_gen;
          break label_47;
        }
        jj_consume_token(COMMA);
        name = simple_declarator();
        list.add(name);
      }
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[149] = jj_gen;
      ;
    }
     if(!hasSimpleDeclarator)
        list.add(name);
     createDeclaration(shk);
  }

/**
 * (26) <storagetype> ::= <storagetype_dcl> 
 *                       | <storagetype_fwd_dcl>
 */
  final public void storagetype() throws ParseException {
    if (jj_2_31(3)) {
      storagetype_dcl();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STORAGETYPE:
        storagetype_fwd_dcl();
        break;
      default:
        jj_la1[150] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (27) <storagetype_dcl> ::= <storagetype_header> "{" <storagetype_body> "}"
 */
  final public void storagetype_dcl() throws ParseException {
   StorageTypeDecl st = null;
    st = storagetype_header();
         openScope(st);
    jj_consume_token(LBRACE);
    storagetype_body();
    jj_consume_token(RBRACE);
         closeScope();
  }

/**
 * <declare_storagetype> ::= "storagetype" <identifier>
 */
  final public StorageTypeDecl declare_storagetype() throws ParseException {
   String name;
    jj_consume_token(STORAGETYPE);
    name = identifier();
        {if (true) return currentScope_.declareStorageType(name);}
    throw new Error("Missing return statement in function");
  }

/**
 * (28) <storagetype_fwd_dcl> ::= "storagetype" <identifier>
 */
  final public void storagetype_fwd_dcl() throws ParseException {
   StorageTypeDecl st = null;
    st = declare_storagetype();
         createForwardScope(st);
  }

/**
 * (29) <storagetype_header> ::= "storagetype" <identifier>
 *                       [ <storagetype_inh_spec> ]
 *                       [ <storagetype_impl_spec> ]
 *                       [ <ref_rep_directive> ]
 */
  final public StorageTypeDecl storagetype_header() throws ParseException {
   StorageTypeDecl st = null;
    st = declare_storagetype();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      storagetype_inh_spec(st);
      break;
    default:
      jj_la1[151] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IMPLEMENTS:
      storagetype_impl_spec(st.getAbstractStorageTypeList());
      break;
    default:
      jj_la1[152] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REF:
      ref_rep_directive(st.getRefRepDirectiveList());
      break;
    default:
      jj_la1[153] = jj_gen;
      ;
    }
        {if (true) return st;}
    throw new Error("Missing return statement in function");
  }

/**
 * (30) <storagetype_body> ::= <storagetype_member>*
 */
  final public void storagetype_body() throws ParseException {
    label_48:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case READONLY:
      case SHORT:
      case STRING:
      case UNSIGNED:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case STATE:
      case STORES:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[154] = jj_gen;
        break label_48;
      }
      storagetype_member();
    }
  }

/**
 * (31) <storagetype_member> ::= <psdl_state_dcl> ";"
 *                     | <store_directive> ";"
 *                     | <storagetype_local_op_dcl> ";"
 */
  final public void storagetype_member() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case READONLY:
    case STATE:
      psdl_state_dcl();
      jj_consume_token(SEMICOLON);
      break;
    case STORES:
      store_directive();
      jj_consume_token(SEMICOLON);
      break;
    case ANY:
    case BOOLEAN:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case LONG:
    case OBJECT:
    case OCTET:
    case SHORT:
    case STRING:
    case UNSIGNED:
    case VALUEBASE:
    case VOID:
    case WCHAR:
    case WSTRING:
    case IDENTIFIER:
    case DCOLON:
      storagetype_local_op_dcl();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[155] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (32) <storagetype_inh_spec> ::= ":" <storagetype_name>
 */
  final public void storagetype_inh_spec(StorageTypeDecl st) throws ParseException {
  StorageTypeDecl inherited = null;
    jj_consume_token(COLON);
    inherited = storagetype_name();
            st.setBaseStorageType(inherited);
  }

/**
 * (33) <storagetype_name> ::= <scoped_name>
 */
  final public StorageTypeDecl storagetype_name() throws ParseException {
   Declaration decl = null;
    decl = scoped_name();
         if(decl == null)
         {
            {if (true) return null;}
         }
         if(decl instanceof StorageTypeDecl)
         {
            {if (true) return (StorageTypeDecl)decl;}
         }
         error(decl, "must be a storagetype");
         {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (34) <storagetype_impl_spec> ::= "implements" <abstract_storagetype_name>
 *                          { "," <abstract_storagetype_name> }*
 */
  final public void storagetype_impl_spec(AbstractStorageTypeList list) throws ParseException {
  AbstractStorageTypeDecl ast = null;
    jj_consume_token(IMPLEMENTS);
    ast = abstract_storagetype_name();
            list.add(ast);
    label_49:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[156] = jj_gen;
        break label_49;
      }
      jj_consume_token(COMMA);
      ast = abstract_storagetype_name();
            list.add(ast);
    }
  }

/**
 * (35) <storagetype_ref_type> ::= "ref" "<" <storagetype_name> ">"
 */
  final public PsdlTypeRef storagetype_ref_type() throws ParseException {
    StorageTypeDecl st = null;
    jj_consume_token(REF);
    jj_consume_token(LTSIGN);
    st = storagetype_name();
    jj_consume_token(GTSIGN);
        {if (true) return ast_.createStorageTypePsdlType(true, st);}
    throw new Error("Missing return statement in function");
  }

/**
 * (36) <storagehome_scope> ::= "scope" <storagehome_name>
 */
  final public StorageHomeDecl storagehome_scope() throws ParseException {
    StorageHomeDecl sh = null;
    jj_consume_token(SCOPE);
    sh = storagehome_name();
        {if (true) return sh;}
    throw new Error("Missing return statement in function");
  }

/**
 * (37) <store_directive> ::= "stores" <simple_declarator> "as"
 *                    <psdl_concrete_state_type> [<storagehome_scope>]
 */
  final public void store_directive() throws ParseException {
    StorageTypeStoreDirectiveDecl decl = null;
    StorageHomeDecl home = null;
    String name = null;
    PsdlTypeRef type = null;
    jj_consume_token(STORES);
    name = simple_declarator();
            decl = currentScope_.startStorageTypeStoreDirective(name);
            decl.setStateMember(name);
    jj_consume_token(AS);
    type = psdl_concrete_state_type();
            decl.setType(type);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SCOPE:
      home = storagehome_scope();
                                 decl.setStorageHome(home);
      break;
    default:
      jj_la1[157] = jj_gen;
      ;
    }
            try{
                decl.create();
            }catch(ASTError e){
                error(e.getMessage());
            }
  }

/**
 * (38) <psdl_concrete_state_type> ::= <storagetype_name>
 *                           | <storagetype_ref_type>
 */
  final public PsdlTypeRef psdl_concrete_state_type() throws ParseException {
    StorageTypeDecl st = null;
    PsdlTypeRef ref = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case DCOLON:
      st = storagetype_name();
            {if (true) return ast_.createStorageTypePsdlType(false, st);}
      break;
    case REF:
      ref = storagetype_ref_type();
            {if (true) return ref;}
      break;
    default:
      jj_la1[158] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (39) <ref_rep_directive> ::= "ref" "(" <simple_declarator>
 *                      { "," <simple_declarator> }* ")"
 */
  final public void ref_rep_directive(StringList list) throws ParseException {
  String name = null;
    jj_consume_token(REF);
    jj_consume_token(LPAREN);
    name = simple_declarator();
            list.add(name);
    label_50:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[159] = jj_gen;
        break label_50;
      }
      jj_consume_token(COMMA);
      name = simple_declarator();
            list.add(name);
    }
    jj_consume_token(RPAREN);
  }

/**
 * (40) <storagehome> ::= <storagehome_header> "{" <storagehome_body> "}"
 */
  final public void storagehome() throws ParseException {
   StorageHomeDecl sh = null;
    sh = storagehome_header();
         openScope(sh);
    jj_consume_token(LBRACE);
    storagehome_body();
    jj_consume_token(RBRACE);
         closeScope();
  }

/**
 * (41) <storagehome_header> ::= "storagehome" <identifier> "of" <storagetype_name>
 *                       [ <storagehome_inh_spec> ]
 *                       [ <storagehome_impl_spec> ]
 *                       [ <primary_key_dcl> ]
 */
  final public StorageHomeDecl storagehome_header() throws ParseException {
   StorageHomeDecl sh = null;
   StorageTypeDecl st = null;
   String name = null;
    jj_consume_token(STORAGEHOME);
    name = identifier();
            sh = currentScope_.startStorageHome(name);
    jj_consume_token(OF);
    st = storagetype_name();
            sh.setStorageType(st);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      storagehome_inh_spec(sh);
      break;
    default:
      jj_la1[160] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IMPLEMENTS:
      storagehome_impl_spec(sh.getAbstractStorageHomeList());
      break;
    default:
      jj_la1[161] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIMARY:
      primary_key_dcl(sh);
      break;
    default:
      jj_la1[162] = jj_gen;
      ;
    }
            {if (true) return sh;}
    throw new Error("Missing return statement in function");
  }

/**
 * (42) <storagehome_body> ::= <storagehome_member>*
 */
  final public void storagehome_body() throws ParseException {
    label_51:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
      case BOOLEAN:
      case CHAR:
      case DOUBLE:
      case FACTORY:
      case FLOAT:
      case LONG:
      case OBJECT:
      case OCTET:
      case SHORT:
      case STRING:
      case UNSIGNED:
      case VALUEBASE:
      case VOID:
      case WCHAR:
      case WSTRING:
      case KEY:
      case IDENTIFIER:
      case DCOLON:
        ;
        break;
      default:
        jj_la1[163] = jj_gen;
        break label_51;
      }
      storagehome_member();
    }
  }

/**
 * (43) <storagehome_inh_spec> ::= ":" <storagehome_name>
 */
  final public void storagehome_inh_spec(StorageHomeDecl sh) throws ParseException {
  StorageHomeDecl inherited = null;
    jj_consume_token(COLON);
    inherited = storagehome_name();
        sh.setBaseStorageHome(inherited);
  }

/**
 * (44) <storagehome_name> ::= <scoped_name>
 */
  final public StorageHomeDecl storagehome_name() throws ParseException {
   Declaration decl = null;
    decl = scoped_name();
         if(decl == null)
         {
            {if (true) return null;}
         }
         if(decl instanceof StorageHomeDecl)
         {
            {if (true) return (StorageHomeDecl)decl;}
         }
         error(decl, "must be a storagehome");
         {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

/**
 * (45) <storagehome_impl_spec> ::= "implements" <abstract_storagehome_name>
 *                          { "," <abstract_storagehome_name> }* 
 */
  final public void storagehome_impl_spec(AbstractStorageHomeList list) throws ParseException {
  AbstractStorageHomeDecl ash = null;
    jj_consume_token(IMPLEMENTS);
    ash = abstract_storagehome_name();
            list.add(ash);
    label_52:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[164] = jj_gen;
        break label_52;
      }
      jj_consume_token(COMMA);
      ash = abstract_storagehome_name();
            list.add(ash);
    }
  }

/**
 * (46) <primary_key_dcl> ::= "primary" "key" <identifier>
 *                        | "primary" "key" "ref" 
 */
  final public void primary_key_dcl(StorageHomeDecl sh) throws ParseException {
  String name = null;
    if (jj_2_32(3)) {
      jj_consume_token(PRIMARY);
      jj_consume_token(KEY);
      name = identifier();
            sh.setPrimaryKeyName(name);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PRIMARY:
        jj_consume_token(PRIMARY);
        jj_consume_token(KEY);
        jj_consume_token(REF);
            sh.setPrimaryKeyRef(true);
        break;
      default:
        jj_la1[165] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * (47) <psdl_factory_dcl> ::= "factory" <identifier> <factory_parameters>
 */
  final public void psdl_factory_dcl() throws ParseException {
    StorageHomeFactoryDecl factory = null;
    String name = null;
    jj_consume_token(FACTORY);
    name = identifier();
            factory = ((StorageHomeBase)currentScope_).startStorageHomeFactory(name);
    factory_parameters(factory.getMemberList());
            createDeclaration(factory);
  }

/**
 * (48) <factory_parameters> ::= "("  <simple_declarator>
 *                               { "," <simple_declarator> }* ")"
 */
  final public void factory_parameters(StringList list) throws ParseException {
  String name = null;
    jj_consume_token(LPAREN);
    name = simple_declarator();
                                 list.add(name);
    label_53:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[166] = jj_gen;
        break label_53;
      }
      jj_consume_token(COMMA);
      name = simple_declarator();
                                       list.add(name);
    }
    jj_consume_token(RPAREN);
  }

// ==================================================================
//
// OMG CIDL Grammar.
//
// ==================================================================

/**
 * (1) <cidl_specification> ::= <import>* <cidl_definition>+
 */
  final public void cidl_specification() throws ParseException {
    label_54:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPORT:
        ;
        break;
      default:
        jj_la1[167] = jj_gen;
        break label_54;
      }
      importx();
    }
    label_55:
    while (true) {
      cidl_definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case TYPEID:
      case TYPEPREFIX:
      case COMPONENT:
      case EVENT:
      case HOME:
      case STORAGEHOME:
      case STORAGETYPE:
      case COMPOSITION:
        ;
        break;
      default:
        jj_la1[168] = jj_gen;
        break label_55;
      }
    }
  }

/**
 * (2) <cidl_definition> ::= <type_dcl> ";"
 *                       |   <const_dcl> ";"
 *                       |   <except_dcl> ";"
 *                       |   <interface> ";"
 *                       |   <cidl_module> ";"
 *                       |   <storagehome> ";"
 *                       |   <abstract_storagehome> ";"
 *                       |   <storagetype> ";"
 *                       |   <abstract_storagetype> ";"
 *                       |   <value> ";"
 *                       |   <type_id_dcl> ";"
 *                       |   <type_prefix_dcl> ";"
 *                       |   <event> ";"
 *                       |   <component> ";"
 *                       |   <home_dcl> ";"
 *                       |   <composition> ";"
 */
  final public void cidl_definition() throws ParseException {
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ENUM:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
        type_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case CONST:
        const_dcl();
        jj_consume_token(SEMICOLON);
        break;
      case EXCEPTION:
        except_dcl();
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[169] = jj_gen;
        if (jj_2_33(2)) {
          interfacex();
          jj_consume_token(SEMICOLON);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MODULE:
            cidl_module();
            jj_consume_token(SEMICOLON);
            break;
          case STORAGEHOME:
            storagehome();
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[170] = jj_gen;
            if (jj_2_34(2)) {
              abstract_storagehome();
              jj_consume_token(SEMICOLON);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case STORAGETYPE:
                storagetype();
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[171] = jj_gen;
                if (jj_2_35(2)) {
                  abstract_storagetype();
                  jj_consume_token(SEMICOLON);
                } else if (jj_2_36(2)) {
                  value();
                  jj_consume_token(SEMICOLON);
                } else {
                  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                  case TYPEID:
                    type_id_dcl();
                    jj_consume_token(SEMICOLON);
                    break;
                  case TYPEPREFIX:
                    type_prefix_dcl();
                    jj_consume_token(SEMICOLON);
                    break;
                  case ABSTRACT:
                  case CUSTOM:
                  case EVENT:
                    event();
                    jj_consume_token(SEMICOLON);
                    break;
                  case COMPONENT:
                    component();
                    jj_consume_token(SEMICOLON);
                    break;
                  case HOME:
                    home_dcl();
                    jj_consume_token(SEMICOLON);
                    break;
                  case COMPOSITION:
                    composition();
                    jj_consume_token(SEMICOLON);
                    break;
                  default:
                    jj_la1[172] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                  }
                }
              }
            }
          }
        }
      }
    } catch (ParseException e) {
    error_manager(e);
    } catch (TokenMgrError e) {
    token_error_manager(e);
    }
  }

/**
 * (3) <cidl_module> ::= "module" <identifier> "{" <cidl_definition>+ "}"
 */
  final public void cidl_module() throws ParseException {
    CidlModuleDecl module = null;
    String name;
    jj_consume_token(MODULE);
    name = identifier();
        module = currentScope_.declareCidlModule(name);
        openScope(module);
    jj_consume_token(LBRACE);
    label_56:
    while (true) {
      cidl_definition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case CONST:
      case CUSTOM:
      case ENUM:
      case EXCEPTION:
      case INTERFACE:
      case MODULE:
      case NATIVE:
      case STRUCT:
      case TYPEDEF:
      case UNION:
      case VALUETYPE:
      case LOCAL:
      case TYPEID:
      case TYPEPREFIX:
      case COMPONENT:
      case EVENT:
      case HOME:
      case STORAGEHOME:
      case STORAGETYPE:
      case COMPOSITION:
        ;
        break;
      default:
        jj_la1[173] = jj_gen;
        break label_56;
      }
    }
    jj_consume_token(RBRACE);
        closeScope();
        // System.out.println("prefix du module "+name+" : "+module.getPrefix());

  }

/**
 * (4) <composition> ::= "composition" <category> <identifier>
 *                       "{" <composition_body> "}"
 */
  final public void composition() throws ParseException {
    CompositionDecl comp = null;
    String name;
    CategoryKind ck = null;
    jj_consume_token(COMPOSITION);
    ck = category();
    name = identifier();
            comp = currentScope_.startComposition(name);
            comp.setCategoryKind(ck);
            openScope(comp);
    jj_consume_token(LBRACE);
    composition_body();
    jj_consume_token(RBRACE);
            closeScope();
  }

/**
 * (5) <category> ::= "entity"
 *                |   "process"
 *                |   "service"
 *                |   "session"
 */
  final public CategoryKind category() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ENTITY:
      jj_consume_token(ENTITY);
        {if (true) return CategoryKind.ck_entity;}
      break;
    case PROCESS:
      jj_consume_token(PROCESS);
        {if (true) return CategoryKind.ck_process;}
      break;
    case SERVICE:
      jj_consume_token(SERVICE);
        {if (true) return CategoryKind.ck_service;}
      break;
    case SESSION:
      jj_consume_token(SESSION);
        {if (true) return CategoryKind.ck_session;}
      break;
    default:
      jj_la1[174] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
 * (6) <composition_body> ::= <home_executor_def> [ <proxy_home_def> ]
 */
  final public void composition_body() throws ParseException {
    home_executor_def();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROXY:
      proxy_home_def();
      break;
    default:
      jj_la1[175] = jj_gen;
      ;
    }
  }

/**
 * (11) <home_executor_def> ::= "home" "executor" <identifier>
 *                               "{" <home_executor_body> "}" ";"
 */
  final public void home_executor_def() throws ParseException {
    HomeExecutorDecl homeExec = null;
    String name;
    jj_consume_token(HOME);
    jj_consume_token(EXECUTOR);
    name = identifier();
        homeExec = ((CompositionDecl)currentScope_).startHomeExecutor(name);
        openScope(homeExec);
    jj_consume_token(LBRACE);
    home_executor_body(homeExec);
    jj_consume_token(RBRACE);
        closeScope();
    jj_consume_token(SEMICOLON);
  }

/**
 * (12) <home_executor_body> ::= <home_impl_dcl>
 *                               [ <abstract_storage_home_binding> ]
 *                               [ <stored_on_dcl> ]
 *                               <executor_def>
 *                               [ <abstract_storage_home_delegation_spec> ]
 *                               [ <executor_delegation_spec> ]
 *                               [ <abstract_spec> ]
 */
  final public void home_executor_body(HomeExecutorDecl homeExec) throws ParseException {
    home_impl_dcl(homeExec);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BINDSTO:
      abstract_storage_home_binding(homeExec);
      break;
    default:
      jj_la1[176] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STOREDON:
      home_persistence_dcl(homeExec);
      break;
    default:
      jj_la1[177] = jj_gen;
      ;
    }
    executor_def();
    if (jj_2_37(2)) {
      abstract_storage_home_delegation_spec(homeExec.getAbstractStorageHomeDelegationList());
    } else {
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DELEGATESTO:
      executor_delegation_spec(homeExec.getExecutorDelegationList());
      break;
    default:
      jj_la1[178] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ABSTRACT:
      abstract_spec(homeExec.getAbstractOperationList());
      break;
    default:
      jj_la1[179] = jj_gen;
      ;
    }
  }

/**
 * (13) <home_impl_dcl> ::= "implements" <home_type_name> ";"
 */
  final public void home_impl_dcl(HomeExecutorDecl homeExec) throws ParseException {
    HomeDecl home;
    jj_consume_token(IMPLEMENTS);
    home = home_type_name();
    jj_consume_token(SEMICOLON);
        homeExec.setHomeType(home);
  }

/**
 * (14) <home_type_name> ::= <scoped_name>
 */
  final public HomeDecl home_type_name() throws ParseException {
  HomeDecl home;
    home = home_name();
    {if (true) return home;}
    throw new Error("Missing return statement in function");
  }

/**
 * (15) <abstract_storage_home_binding> ::= "bindsTo" <abstract_storage_home_name> ";"
 */
  final public void abstract_storage_home_binding(HomeExecutorDecl homeExec) throws ParseException {
    AbstractStorageHomeDecl ash;
    jj_consume_token(BINDSTO);
    ash = abstract_storage_home_name();
        homeExec.setAbstractStorageHomeBinding(ash);
    jj_consume_token(SEMICOLON);
  }

/**
 * (16) <abstract_storage_home_name> ::= <abstract_storage_home_name_label>
 */
  final public AbstractStorageHomeDecl abstract_storage_home_name() throws ParseException {
  AbstractStorageHomeDecl ash;
    // NOT APPROPRIATED   abstract_storage_home_name_label()
    
      ash = abstract_storagehome_name();
    {if (true) return ash;}
    throw new Error("Missing return statement in function");
  }

/**
 * NOT NEEDED AS CATALOG IS REMOVED
 * (17) <abstract_storage_home_name_label> ::= <identifier>
 */
  final public void abstract_storage_home_name_label() throws ParseException {
    identifier();
  }

/**
 * (18) <home_persistence_dcl> ::= "storedOn" <abstract_storage_home_name> ";"
 */
  final public void home_persistence_dcl(HomeExecutorDecl homeExec) throws ParseException {
    AbstractStorageHomeDecl ash;
    jj_consume_token(STOREDON);
    ash = abstract_storage_home_name();
        homeExec.setHomePersistence(ash);
    jj_consume_token(SEMICOLON);
  }

/**
 * (19) <executor_def> ::= "manages" <identifier> [ <executor_body> ] ";"
 */
  final public void executor_def() throws ParseException {
    ExecutorDecl exec = null;
    String name = null;
    jj_consume_token(MANAGES);
    name = identifier();
        exec = ((HomeExecutorDecl)currentScope_).startExecutor(name);
        openScope(exec);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      executor_body(exec);
      break;
    default:
      jj_la1[180] = jj_gen;
      ;
    }
        closeScope();
    jj_consume_token(SEMICOLON);
  }

/**
 * (20) <executor_body> ::= "{" <executor_member>+ "}"
 */
  final public void executor_body(ExecutorDecl exec) throws ParseException {
    jj_consume_token(LBRACE);
    label_57:
    while (true) {
      executor_member(exec);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DELEGATESTO:
      case SEGMENT:
        ;
        break;
      default:
        jj_la1[181] = jj_gen;
        break label_57;
      }
    }
    jj_consume_token(RBRACE);
  }

/**
 * (21) <executor_member> ::= <segment_def>
 *                          | <feature_delegation_spec>
 */
  final public void executor_member(ExecutorDecl exec) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEGMENT:
      segment_def();
      break;
    case DELEGATESTO:
      feature_delegation_spec(exec.getFeatureDelegationList());
      break;
    default:
      jj_la1[182] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (22) <segment_def> ::= "segment" <identifier>
 *                        "{" <segment_member>+ "}"
 */
  final public void segment_def() throws ParseException {
    SegmentDecl seg = null;
    String name = null;
    jj_consume_token(SEGMENT);
    name = identifier();
        seg = ((ExecutorDecl)currentScope_).startSegment(name);
// SegmentDecl not a Scope!       openScope(seg);

    jj_consume_token(LBRACE);
    label_58:
    while (true) {
      segment_member(seg);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROVIDES:
      case STOREDON:
        ;
        break;
      default:
        jj_la1[183] = jj_gen;
        break label_58;
      }
    }
    jj_consume_token(RBRACE);

  }

/**
 * (23) <segment_member> ::= <segment_persistence_dcl> ";"
 *                         | <facet_dcl> ";"
 */
  final public void segment_member(SegmentDecl seg) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STOREDON:
      segment_persistence_dcl(seg);
      jj_consume_token(SEMICOLON);
      break;
    case PROVIDES:
      facet_dcl(seg);
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[184] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (24) <segment_persistence_dcl> ::= "storedOn" <abstract_storage_home_name> ";"
 */
  final public void segment_persistence_dcl(SegmentDecl seg) throws ParseException {
    AbstractStorageHomeDecl ash = null;
    jj_consume_token(STOREDON);
    ash = abstract_storage_home_name();
        seg.setAbstractStorageHome(ash);
    jj_consume_token(SEMICOLON);
  }

/**
 * (25) <facet_dcl> ::= "provides" "facet" <identifier> {"," <identifier>}*
 */
  final public void facet_dcl(SegmentDecl seg) throws ParseException {
    String name = null;
    StringList list=seg.getFacetList();
    jj_consume_token(PROVIDES);
    jj_consume_token(FACET);
    name = identifier();
        list.add(name);
    label_59:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[185] = jj_gen;
        break label_59;
      }
      jj_consume_token(COMMA);
      identifier();
                         list.add(name);
    }
  }

/**
 * (26) <feature_delegation_spec> ::= "delegatesTo" "storage" <feature_delegation_list> 
 */
  final public void feature_delegation_spec(DelegationList list) throws ParseException {
    jj_consume_token(DELEGATESTO);
    jj_consume_token(STORAGE);
    feature_delegation_list(list);
  }

/**
 * (27) <feature_delegation_list> ::= "(" <feature_delegation>
 *                                    {"," <feature_delegation>}* ")" 
 */
  final public void feature_delegation_list(DelegationList list) throws ParseException {
    jj_consume_token(LPAREN);
    feature_delegation(list);
    label_60:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[186] = jj_gen;
        break label_60;
      }
      jj_consume_token(COMMA);
      feature_delegation(list);
    }
    jj_consume_token(RPAREN);
  }

/**
 * (28) <feature_delegation> ::= <feature_name> ":" <storage_member_name>
 */
  final public void feature_delegation(DelegationList list) throws ParseException {
    String state1 = null;
    String state2 = null;
    state1 = feature_name();
    jj_consume_token(COLON);
    state2 = storage_member_name();
        list.add(state1, state2);
  }

/**
 * (29) <feature_name> ::= <identifier>
 */
  final public String feature_name() throws ParseException {
    String name = null;
    name = identifier();
        {if (true) return name;}
    throw new Error("Missing return statement in function");
  }

/**
 * (30) <storage_member_name> ::= <identifier>
 */
  final public String storage_member_name() throws ParseException {
    String name = null;
    name = identifier();
        {if (true) return name;}
    throw new Error("Missing return statement in function");
  }

/**
 * (31) <abstract_storage_home_delegation_spec> ::= "delegatesTo" "abstract" "storagehome"
 *                                                 <delegation_list> ";"
 */
  final public void abstract_storage_home_delegation_spec(DelegationList list) throws ParseException {
    jj_consume_token(DELEGATESTO);
    jj_consume_token(ABSTRACT);
    jj_consume_token(STORAGEHOME);
    delegation_list(list);
    jj_consume_token(SEMICOLON);
  }

/**
 * (32) <executor_delegation_spec> ::= "delegatesTo" "executor" <delegation_list> ";"
 */
  final public void executor_delegation_spec(DelegationList list) throws ParseException {
    jj_consume_token(DELEGATESTO);
    jj_consume_token(EXECUTOR);
    delegation_list(list);
    jj_consume_token(SEMICOLON);
  }

/**
 * (33) <delegation_list> ::= "(" <delegation> {","  <delegation>}* ")"
 */
  final public void delegation_list(DelegationList list) throws ParseException {
    jj_consume_token(LPAREN);
    delegation(list);
    label_61:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[187] = jj_gen;
        break label_61;
      }
      jj_consume_token(COMMA);
      delegation(list);
    }
    jj_consume_token(RPAREN);
  }

/**
 * (34) <delegation> ::= <operation_name> [":" <operation_name>]
 */
  final public void delegation(DelegationList list) throws ParseException {
    String op1 = null;
    String op2 = null;
    op1 = operation_name();
        op2=op1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      op2 = operation_name();
      break;
    default:
      jj_la1[188] = jj_gen;
      ;
    }
       list.add(op1, op2);
  }

/**
 * (35) <operation_name> ::= <identifier>
 */
  final public String operation_name() throws ParseException {
    String name = null;
    name = identifier();
        {if (true) return name;}
    throw new Error("Missing return statement in function");
  }

/**
 * (36) <abstract_spec> ::= "abstract" <operation_list> ";"
 */
  final public void abstract_spec(StringList list) throws ParseException {
    jj_consume_token(ABSTRACT);
    operation_list(list);
    jj_consume_token(SEMICOLON);
  }

/**
 * (37) <operation_list> ::=  "(" <operation_name> {"," <operation_name>}* ")"
 */
  final public void operation_list(StringList list) throws ParseException {
    String op = null;
    jj_consume_token(LPAREN);
    op = operation_name();
        list.add(op);
    label_62:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[189] = jj_gen;
        break label_62;
      }
      jj_consume_token(COMMA);
      operation_name();
                            list.add(op);
    }
    jj_consume_token(RPAREN);
  }

/**
 * (38) <proxy_home_def> ::=  "proxy" "home" <identifier>
 *                            "{" <proxy_home_member>+ "}" ";"
 */
  final public void proxy_home_def() throws ParseException {
    ProxyHomeDecl proxyHome;
    String name = null;
    jj_consume_token(PROXY);
    jj_consume_token(HOME);
    name = identifier();
        proxyHome = ((CompositionDecl)currentScope_).startProxyHome(name);
    jj_consume_token(LBRACE);
    label_63:
    while (true) {
      proxy_home_member(proxyHome);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case DELEGATESTO:
        ;
        break;
      default:
        jj_la1[190] = jj_gen;
        break label_63;
      }
    }
    jj_consume_token(RBRACE);
        createDeclaration(proxyHome);
    jj_consume_token(SEMICOLON);
  }

/**
 * (39) <proxy_home_member> ::= <home_delegation_spec> ";"
 *                            | <abstract_spec>
 */
  final public void proxy_home_member(ProxyHomeDecl proxyHome) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DELEGATESTO:
      home_delegation_spec(proxyHome.getHomeDelegationList());
      jj_consume_token(SEMICOLON);
      break;
    case ABSTRACT:
      abstract_spec(proxyHome.getAbstractOperationList());
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[191] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * (40) <home_delegation_spec> ::=  "delegatesTo" "home" <delegation_list>
 */
  final public void home_delegation_spec(DelegationList homeDelegList) throws ParseException {
    jj_consume_token(DELEGATESTO);
    jj_consume_token(HOME);
    delegation_list(homeDelegList);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_26();
    jj_save(25, xla);
    return retval;
  }

  final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_27();
    jj_save(26, xla);
    return retval;
  }

  final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_28();
    jj_save(27, xla);
    return retval;
  }

  final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_29();
    jj_save(28, xla);
    return retval;
  }

  final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_30();
    jj_save(29, xla);
    return retval;
  }

  final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_31();
    jj_save(30, xla);
    return retval;
  }

  final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_32();
    jj_save(31, xla);
    return retval;
  }

  final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_33();
    jj_save(32, xla);
    return retval;
  }

  final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_34();
    jj_save(33, xla);
    return retval;
  }

  final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_35();
    jj_save(34, xla);
    return retval;
  }

  final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_36();
    jj_save(35, xla);
    return retval;
  }

  final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_37();
    jj_save(36, xla);
    return retval;
  }

  final private boolean jj_3R_208() {
    if (jj_3R_225()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_32() {
    if (jj_scan_token(PRIMARY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KEY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_229() {
    if (jj_scan_token(VOID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_134() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_228() {
    if (jj_3R_245()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_212() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_228()) {
    jj_scanpos = xsp;
    if (jj_3R_229()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_70() {
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_97()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_207() {
    if (jj_scan_token(NATIVE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_206() {
    if (jj_3R_199()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() {
    if (jj_scan_token(STRUCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_3R_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_scan_token(TYPEDEF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_187() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3_14()) {
    jj_scanpos = xsp;
    if (jj_3_15()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) {
    jj_scanpos = xsp;
    if (jj_3R_208()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_135() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(STORAGETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_236() {
    if (jj_scan_token(OBJECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_211() {
    if (jj_scan_token(ONEWAY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_191() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_211()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_212()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_116() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_142()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_3R_112()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_235() {
    if (jj_scan_token(ANY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_90() {
    if (jj_3R_116()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_111() {
    if (jj_3R_134()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_29()) {
    jj_scanpos = xsp;
    if (jj_3R_111()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_29() {
    if (jj_3R_85()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_234() {
    if (jj_scan_token(OCTET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_5()) {
    jj_scanpos = xsp;
    if (jj_3_6()) {
    jj_scanpos = xsp;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_68()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_227() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_189() {
    if (jj_scan_token(EXCEPTION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_180() {
    if (jj_3R_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_233() {
    if (jj_scan_token(BOOLEAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_210() {
    if (jj_3R_227()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_209() {
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_190() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_209()) {
    jj_scanpos = xsp;
    if (jj_3R_210()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_232() {
    if (jj_scan_token(WCHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_13() {
    if (jj_scan_token(FIXED_PT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_242() {
    if (jj_scan_token(DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_204() {
    if (jj_scan_token(CONSUMES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_179() {
    if (jj_scan_token(DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_153() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_179()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_242()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_231() {
    if (jj_scan_token(CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_104() {
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_128()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_128()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_248() {
    if (jj_scan_token(UNSIGNED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_203() {
    if (jj_scan_token(PUBLISHES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_scan_token(CONST)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_198() {
    if (jj_3R_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_20() {
    if (jj_scan_token(UNSIGNED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_226() {
    if (jj_scan_token(READONLY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_28() {
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_19() {
    if (jj_scan_token(UNSIGNED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SHORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_27() {
    if (jj_3R_83()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_26() {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_250() {
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_247() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_127() {
    if (jj_3R_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_202() {
    if (jj_scan_token(EMITS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_193() {
    if (jj_scan_token(TYPEPREFIX)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_246() {
    if (jj_scan_token(SHORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_230() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_246()) {
    jj_scanpos = xsp;
    if (jj_3_18()) {
    jj_scanpos = xsp;
    if (jj_3R_247()) {
    jj_scanpos = xsp;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3_20()) {
    jj_scanpos = xsp;
    if (jj_3R_248()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_240() {
    if (jj_scan_token(WSTRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_250()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_113() {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(OF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_145() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_192() {
    if (jj_scan_token(TYPEID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_161() {
    if (jj_scan_token(REF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_201() {
    if (jj_scan_token(USES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_249() {
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_195() {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_37() {
    if (jj_3R_88()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_172() {
    if (jj_scan_token(FACTORY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_3R_193()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_239() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_249()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_169() {
    if (jj_3R_192()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_86() {
    if (jj_3R_113()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_103() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_168() {
    if (jj_3R_191()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_75() {
    Token xsp;
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_103()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_167() {
    if (jj_3R_190()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOUBLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_3R_189()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_3R_187()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_165() {
    if (jj_3R_188()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_101() {
    if (jj_scan_token(DOUBLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_146() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_164()) {
    jj_scanpos = xsp;
    if (jj_3R_165()) {
    jj_scanpos = xsp;
    if (jj_3R_166()) {
    jj_scanpos = xsp;
    if (jj_3R_167()) {
    jj_scanpos = xsp;
    if (jj_3R_168()) {
    jj_scanpos = xsp;
    if (jj_3R_169()) {
    jj_scanpos = xsp;
    if (jj_3R_170()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_119() {
    if (jj_3R_145()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_100() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_132() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_157()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_100()) {
    jj_scanpos = xsp;
    if (jj_3R_101()) {
    jj_scanpos = xsp;
    if (jj_3R_102()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_194() {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_171() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_194()) {
    jj_scanpos = xsp;
    if (jj_3R_195()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_238() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_3R_146()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_200() {
    if (jj_scan_token(PROVIDES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_78() {
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_93() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_120()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_137() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(STORAGEHOME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_25() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_82()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_107() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3R_132()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_150() {
    if (jj_3R_172()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_186() {
    if (jj_3R_190()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_110() {
    if (jj_3R_133()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_92() {
    if (jj_3R_118()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_119()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_149() {
    if (jj_3R_171()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_30()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_30() {
    if (jj_3R_86()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_185() {
    if (jj_3R_204()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_122() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_148()) {
    jj_scanpos = xsp;
    if (jj_3R_149()) {
    jj_scanpos = xsp;
    if (jj_3R_150()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_3R_146()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_184() {
    if (jj_3R_203()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_108() {
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_183() {
    if (jj_3R_202()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_182() {
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_181() {
    if (jj_3R_200()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_156() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) {
    jj_scanpos = xsp;
    if (jj_3R_185()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_244() {
    if (jj_scan_token(UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_199() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() {
    if (jj_3R_107()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_108()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_243() {
    if (jj_scan_token(STRUCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_225() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_243()) {
    jj_scanpos = xsp;
    if (jj_3R_244()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_131() {
    if (jj_3R_156()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_126() {
    if (jj_3R_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_106() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_131()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_scan_token(LOCAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_144() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_237() {
    if (jj_scan_token(VALUEBASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_118() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_144()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_180()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_99() {
    if (jj_scan_token(SUPPORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_178() {
    if (jj_3R_199()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_109() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_177() {
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_176() {
    if (jj_3R_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_115() {
    if (jj_3R_118()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_125() {
    if (jj_scan_token(TRUNCATABLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_152() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_scan_token(SUPPORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_98() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_125()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_126()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_73() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_98()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_99()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_24() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_224() {
    if (jj_3R_241()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_130() {
    if (jj_3R_155()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_223() {
    if (jj_3R_240()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_3R_92()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_3R_154()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_222() {
    if (jj_3R_239()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_241() {
    if (jj_scan_token(FIXED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LTSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_221() {
    if (jj_3R_238()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_88() {
    if (jj_scan_token(DELEGATESTO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_197() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_221()) {
    jj_scanpos = xsp;
    if (jj_3R_222()) {
    jj_scanpos = xsp;
    if (jj_3R_223()) {
    jj_scanpos = xsp;
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_89() {
    if (jj_3R_115()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_159() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_129()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_130()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_147() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_143() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_254() {
    if (jj_3R_198()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_121() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_147()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_117() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_143()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_253() {
    if (jj_3R_240()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_220() {
    if (jj_3R_237()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_252() {
    if (jj_3R_239()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_219() {
    if (jj_3R_236()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_scan_token(CUSTOM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_36() {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_251() {
    if (jj_3R_196()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_218() {
    if (jj_3R_235()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_35() {
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_217() {
    if (jj_3R_234()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_34() {
    if (jj_3R_83()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_245() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_251()) {
    jj_scanpos = xsp;
    if (jj_3R_252()) {
    jj_scanpos = xsp;
    if (jj_3R_253()) {
    jj_scanpos = xsp;
    if (jj_3R_254()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_216() {
    if (jj_3R_233()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_33() {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_215() {
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_214() {
    if (jj_3R_231()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_91() {
    if (jj_3R_117()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() {
    if (jj_3R_105()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_213() {
    if (jj_3R_230()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_23() {
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_16() {
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_22()) {
    jj_scanpos = xsp;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_22() {
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_94() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_9() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_72()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_196() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3R_213()) {
    jj_scanpos = xsp;
    if (jj_3R_214()) {
    jj_scanpos = xsp;
    if (jj_3R_215()) {
    jj_scanpos = xsp;
    if (jj_3R_216()) {
    jj_scanpos = xsp;
    if (jj_3R_217()) {
    jj_scanpos = xsp;
    if (jj_3R_218()) {
    jj_scanpos = xsp;
    if (jj_3R_219()) {
    jj_scanpos = xsp;
    if (jj_3R_220()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_3R_161()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_140() {
    if (jj_3R_160()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_139() {
    if (jj_3R_159()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_114() {
    if (jj_3R_138()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_139()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_140()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_141()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_95() {
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_3R_94()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_95()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_175() {
    if (jj_3R_198()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_174() {
    if (jj_3R_197()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_3R_196()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_151() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_173()) {
    jj_scanpos = xsp;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_21() {
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_158() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_77() {
    if (jj_scan_token(UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SWITCH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_scan_token(STORAGETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_124() {
    if (jj_3R_152()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_3R_151()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_97() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_96() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_87() {
    if (jj_3R_114()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_136() {
    if (jj_3R_158()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3R_96()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VALUETYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_112() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_136()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_31() {
    if (jj_3R_87()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[192];
  final private int[] jj_la1_0 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x0,0x340ca08,0x200c200,0x1000000,0x0,0x0,0x340ca08,0x400008,0x8,0x8,0x0,0x1e88e370,0x1e88e370,0x0,0x0,0x0,0x8,0x8,0x1e88e370,0x1e88e370,0x8,0xde89e370,0x800,0x800,0x800,0x0,0x0,0x0,0x0,0x0,0xde89e370,0xc0000000,0x100000,0x0,0x0,0x8840140,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000,0x20000,0x0,0x0,0x0,0x20000,0x0,0x2004000,0xc8c6150,0xc8c2150,0xc800150,0x40000,0x4000,0x0,0x0,0x882000,0x0,0x800000,0x0,0xc8c6150,0x804140,0x1080,0x1080,0x1080,0x0,0x0,0x0,0x0,0x0,0x20,0xc8c6150,0x10000000,0x0,0x400,0xc882150,0x0,0x20300000,0x20300000,0x0,0x0,0xc882150,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20,0x20,0x4000000,0x0,0x0,0x0,0x0,0x1e89e370,0x1e89e370,0x100000,0x0,0x100000,0x0,0x8,0x8,0x1e88e370,0x1e88e370,0x8,0xde89e370,0x800,0x800,0x800,0x340ca08,0x200c200,0x1000000,0x0,0x808,0x340ca08,0x8,0x0,0xc882150,0xc882150,0x0,0x0,0x0,0xc882150,0x0,0x8,0x0,0xc892150,0xc892150,0x0,0x0,0x200,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc882150,0xc882150,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc892150,0x0,0x0,0x0,0x0,0x340ca08,0x200c200,0x1000000,0x0,0x808,0x340ca08,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x8,};
  final private int[] jj_la1_2 = {0x0,0x0,0x0,0x0,0x40000,0x81785420,0x1420,0x0,0x300000,0x80400000,0x81785420,0x80000,0x80000,0x80000,0x0,0x33bc3a,0x33bc3a,0x0,0x0,0x0,0x4000,0x0,0x33bc3a,0x33bc3a,0x0,0x33bc3a,0x0,0x0,0x4000,0x200,0x0,0x0,0x0,0x40,0x33bc3a,0x0,0x0,0x1,0x0,0x30818,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x100,0x100,0x0,0x0,0x0,0x100,0x400,0x1020,0x3383c,0x3281c,0x12808,0x20014,0x1020,0x0,0x0,0x0,0x8,0x0,0x800,0x3383c,0x808,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x3383c,0x0,0x1,0x0,0x3a818,0x0,0x0,0x0,0x0,0x0,0x32818,0x1020,0x0,0x0,0x1,0x0,0x60000000,0x40000000,0x60000000,0x0,0x400000,0x0,0x40,0x0,0x1e800002,0x1e800002,0x0,0x0,0x0,0x40,0x0,0x33bc3a,0x33bc3a,0x0,0x1,0x0,0x1,0x1000000,0x0,0x33bc3a,0x33bc3a,0x0,0x33bc3a,0x0,0x0,0x1000000,0x85420,0x1420,0x0,0x0,0x4000,0x85420,0x0,0x0,0x3a81a,0x3a81a,0x0,0x2,0x0,0x32818,0x0,0x0,0x0,0x3a818,0x3a818,0x0,0x1,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x3a81a,0x3a81a,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3a818,0x0,0x0,0x0,0x40000,0x81785420,0x1420,0x0,0x0,0x81700000,0x81785420,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x800000,0x800000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_3 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000000,0x20000000,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x2,0x4,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3000,0x0,0x1000,0x2000,0x0,0x3000,0x0,0x0,0x800,0x800,0x0,0x0,0x0,0x8200,0x8000,0x0,0x0,0x40,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x2000,0x0,0x20,0x200,0x4800,0x4800,0x0,0x400,0x200,0x0,0x0,0x20,0x100,0x40,0x0,0x100,0x0,0x0,0x23000,0x0,0x1000,0x2000,0x20000,0x23000,0x6480000,0x800000,0x10000,0x10000000,0x40000,0x0,0x0,0x1040000,0x1040000,0x10000000,0x10000000,0x0,0x0,0x0,0x0,0x0,0x40000,0x40000,};
  final private int[] jj_la1_4 = {0x2,0x2,0x100000,0x100000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200000,0x100800,0x100800,0x80000,0x100000,0x100000,0x0,0x0,0x100800,0x100800,0x0,0x100800,0x0,0x0,0x0,0x0,0x80000,0x200000,0x80000,0x0,0x100800,0x0,0x0,0x0,0x80000,0x100800,0x2000000,0x4000000,0x8000000,0x30000000,0x30000000,0xc0000000,0xc0000000,0x0,0x0,0xc010193e,0x10193e,0x0,0x4,0x10,0x20,0x0,0x0,0x100800,0x100800,0x0,0x0,0x0,0x80000,0x800,0x0,0x0,0x0,0x0,0x100800,0x100800,0x0,0x0,0x0,0x80000,0x80000,0x800000,0x800000,0x10000,0x0,0x100800,0x0,0x0,0x0,0x100800,0x80000,0x0,0x0,0x80000,0x80000,0x100800,0x0,0x100802,0x80000,0x0,0x80000,0x0,0x0,0x0,0x80000,0x0,0x200000,0x0,0x80000,0x0,0x0,0x100800,0x0,0x200000,0x0,0x0,0x100800,0x100800,0x0,0x0,0x0,0x0,0x0,0x0,0x100800,0x100800,0x0,0x100800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200000,0x100800,0x100800,0x80000,0x0,0x80000,0x100800,0x0,0x0,0x200000,0x100800,0x100800,0x80000,0x0,0x0,0x0,0x80000,0x1000,0x0,0x200000,0x0,0x0,0x100800,0x100800,0x80000,0x0,0x100800,0x80000,0x200000,0x0,0x0,0x100800,0x80000,0x0,0x80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x80000,0x80000,0x80000,0x200000,0x80000,0x0,0x0,};
  final private int[] jj_la1_5 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7,0x7,0x8,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[37];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public Parser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 192; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 192; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 192; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 192; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 192; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 192; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enume = jj_expentries.elements(); enume.hasMoreElements();) {
        int[] oldentry = (int[])(enume.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[164];
    for (int i = 0; i < 164; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 192; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
          if ((jj_la1_5[i] & (1<<j)) != 0) {
            la1tokens[160+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 164; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 37; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
